=== modified file 'Code Tokenizer and Parser/Parser_Test.css'
--- Code Tokenizer and Parser/Parser_Test.css	2013-04-05 14:54:48 +0000
+++ Code Tokenizer and Parser/Parser_Test.css	2013-04-04 08:42:36 +0000
@@ -1,9 +1,11 @@
 @charset "utf-8";
 
-#infobox {
-	border: 2px solid black;
-	background-color: #fed;
-	padding: 4px;
-	vertical-align: top;
-	float: left;
+#infobox{
+	border:2px solid black;
+	background-color:#fed;
+	width:500px;
+	height:1200px;
+	padding:4px;
+	vertical-align:top;
+	float:left;
 }
\ No newline at end of file

=== modified file 'Code Tokenizer and Parser/Parser_Test.html'
--- Code Tokenizer and Parser/Parser_Test.html	2013-04-05 08:35:29 +0000
+++ Code Tokenizer and Parser/Parser_Test.html	2013-04-03 08:20:14 +0000
@@ -5,7 +5,7 @@
 		<link rel="stylesheet" href="Parser_Test.css" type="text/css" media="screen" />
 		<script type="text/javascript" src="Parser_Test.js"></script>
 	</head>
-	<body onload="newButton();">
+	<body onload="newbutton();">
 		<div id="infobox">
 		</div>
 	</body>

=== modified file 'Code Tokenizer and Parser/Parser_Test.js'
--- Code Tokenizer and Parser/Parser_Test.js	2013-04-05 14:54:48 +0000
+++ Code Tokenizer and Parser/Parser_Test.js	2013-04-03 12:27:12 +0000
@@ -1,34 +1,41 @@
-// Array to hold the tokens				
-var tokens = [];  
 /* 
  * Token class and storage definition									
  */
+ 
 function token(kind, val, fromchar, tochar, row) {
     this.kind = kind;
     this.val = val;
     this.from = fromchar;
     this.to = tochar;
     this.row = row;
-}          
+}
+
+// Array to hold the tokens				
+var tokens = [];            
 /*
  * Store token in tokens array
  * Creates a new token object using the constructor
  */
+ 
 function makeToken(kind, val, from, to, rowno) {
 	newtoken = new token(kind, val, from, to, rowno);
 	tokens.push(newtoken);
 }
+
 /*
  * Writes error from tokenizer
  */		
+ 
 function error(str, val, row) {
 	alert("Tokenizer Error: " + str + val + " at row " + row);
 }
+
 /*
  * Tokenize function 
  * Tokenizer partly based on ideas from the very clever tokenizer written by Douglas Cockford
  * The tokenizer is passed a string, and a string of prefix and suffix terminators
- */		
+ */
+		
 function tokenize(instring, inprefix, insuffix) {	    
 	// index of the start of the token.
 	var from;                   	
@@ -70,180 +77,180 @@
                     break;
                 }
             }
-            makeToken('name', str, from, i, row);
+            maketoken('name', str, from, i, row);
 			// Number token
-		} else if (c >= '0' && c <= '9') {												
-		    str = c;
-		    i++;
-		    for(;;) {
-				c = instring.charAt(i);
-		        if(c < '0' || c > '9') {
-				break;
-				}
-		        i++;
-		        str += c;
-		    }
-		    if(c == '.') {
-		        i++;
-		        str += c;
-		        for(;;){
-			   	c=instring.charAt(i);
-		            if(c < '0' || c > '9'){ 
-					break;
-					}
-		            i++;
-		            str += c;
-		            }
-		    }
-		    if(c == 'e' || c =='E') {
-		        i++;
-		        str += c;
-				c=instring.charAt(i);
-		        if(c == '-' || c == '+') {
-		            i++;
-		            str += c;
-					c=instring.charAt(i);
+		    } else if (c >= '0' && c <= '9') {												
+		        str = c;
+		        i++;
+		        for(;;) {
+		    		c = instring.charAt(i);
+		            if(c < '0' || c > '9') {
+						break;
+					}
+		            i++;
+		            str += c;
+		            }
+		        if(c == '.') {
+		            i++;
+		            str += c;
+		            for(;;){
+				    	c=instring.charAt(i);
+		                if(c < '0' || c > '9'){ 
+							break;
+						}
+		                i++;
+		                str += c;
+		                }
+		            }
+		        if(c == 'e' || c =='E') {
+		            i++;
+		            str += c;
+		    		c=instring.charAt(i);
+		            if(c == '-' || c == '+') {
+		                i++;
+		                str += c;
+				    	c=instring.charAt(i);
+		            }
+		            if(c < '0' || c > '9') {
+						error('Bad Exponent in Number: ',str,row);
+					}
+		            do {
+		                i++;
+		                str += c;
+				    	c = instring.charAt(i);
+		                } while(c >= '0' && c <= '9');
+		            }
+		        if(c >= 'a' && c <= 'z') {
+		                str += c;
+		                i++;
+		                error('Bad Number: ',str,row);
+		            }
+		        n =+ str;
+		        if(isFinite(n)) {
+ 					maketoken('number', n, from, i, row);		            		
+		        } else {
+		            error('Bad Number: ', str, row);
 		        }
-		        if(c < '0' || c > '9') {
-					error('Bad Exponent in Number: ',str,row);
-				}
-		        do {
-		            i++;
-		            str += c;
-				  	c = instring.charAt(i);
-		        } while(c >= '0' && c <= '9');
-		    }
-		    if(c >= 'a' && c <= 'z') {
-		        str += c;
-		        i++;
-		        error('Bad Number: ',str,row);
-		    }
-		    n =+ str;
-		    if(isFinite(n)) {
-				makeToken('number', n, from, i, row);		            		
-		    } else {
-		        error('Bad Number: ', str, row);
-		    }
-			// String .. handles c style breaking codes
-		} else if (c == '\'' || c == '"') {																				
-		    str = '';
-		    q = c;
-		    i++;
-		    for(;;) {
-				c = instring.charAt(i);
-				if(c < ' ') {
-					if((c == '\n') || (c == '\r') || (c == '')) {
-						// Add row if this white space is a row terminator
-						row++;
-					} else {
-						error('Unterminated String: ', str, row);		                		
-					}
-				}
-				if (c == q) {
-					break;
-				}
-				if(c == '\\') {
-					i++;
-					if(i >= length) {
-						error('Unterminated String: ', str, row);		                		
-					}
-					c = instring.charAt(i);
-					if(c == 'b') { 
-						c = '\b'; 
-						break; 
-					}
-					if(c == 'f') { 
-						c = '\f'; 
-						break; 
-					}
-					if(c == 'n') { 
-						c = '\n'; 
-						break; 
-					}
-					if(c == 'r') { 
-						c = '\r'; 
-						break; 
-					}
-					if(c == 't') { 
-						c = '\t'; 
-						break; 
-					}
-					if(c == 'u') {
-						if(i >= length) {
-							error('Unterminated String: ', str, row);		                		
-						}
-						c = parseInt(this.substr(i + 1, 4), 16);
-						if(!isFinite(c) || c < 0) {
-							error('Unterminated String: ', str, row);		                		
-						}
-						c = String.fromCharCode(c);
-						i+=4;
-						break;		                    
-					}
-				}
-				str += c;
-				i++;
-		    }
-		    i++;
-		    makeToken('string', str, from, i, row);
-    		c = instring.charAt(i);
-			// Comment of // type ... does not cover block comments
-		} else if (c == '/' && instring.charAt(i+1) == '/') {								
-		    i++;
-		    for(;;) {
-				c=instring.charAt(i);
-		        if(c == '\n' || c == '\r' || c == '') {
-		            row++;
-		            break;
-				}
-		        i++;
-		    }
+				// String .. handles c style breaking codes
+		        } else if (c == '\'' || c == '"') {																				
+		            str = '';
+		            q = c;
+		            i++;
+		            for(;;) {
+		    		    c = instring.charAt(i);
+		                if(c < ' ') {
+							if((c == '\n') || (c == '\r') || (c == '')) {
+								// Add row if this white space is a row terminator
+								row++;
+							} else {
+								error('Unterminated String: ', str, row);		                		
+							}
+		                }
+		                if (c == q) {
+							break;
+						}
+		                if(c == '\\') {
+		                    i++;
+		                    if(i >= length) {
+				                error('Unterminated String: ', str, row);		                		
+		                    }
+				    		c = instring.charAt(i);
+		                    if(c == 'b') { 
+								c = '\b'; 
+								break; 
+							}
+		                    if(c == 'f') { 
+								c = '\f'; 
+								break; 
+							}
+		                    if(c == 'n') { 
+								c = '\n'; 
+								break; 
+							}
+		                    if(c == 'r') { 
+								c = '\r'; 
+								break; 
+							}
+		                    if(c == 't') { 
+								c = '\t'; 
+								break; 
+							}
+		                    if(c == 'u') {
+		                        if(i >= length) {
+						        	error('Unterminated String: ', str, row);		                		
+		                        }
+		                        c = parseInt(this.substr(i + 1, 4), 16);
+		                        if(!isFinite(c) || c < 0) {
+						         	error('Unterminated String: ', str, row);		                		
+		                        }
+		                        c = String.fromCharCode(c);
+		                        i+=4;
+		                        break;		                    
+		                    }
+		                }
+		                str += c;
+		                i++;
+		            }
+		            i++;
+		            maketoken('string', str, from, i, row);
+    		        c = instring.charAt(i);
+				// Comment of // type ... does not cover block comments
+		        } else if (c == '/' && instring.charAt(i+1) == '/') {								
+		            i++;
+		            for(;;) {
+		    		    c=instring.charAt(i);
+		                if(c == '\n' || c == '\r' || c == '') {
+		                    row++;
+		                    break;
+		                }
+		                i++;
+		            }
 				// Block comment of /* type
-		} else if (c == '/' && instring.charAt(i+1) == '*') {								
-		    i++;
-		    for(;;) {
-				c=instring.charAt(i);
-		        if((c == '*' && instring.charAt(i+1) == '/') || (i == length)) {
-		            i+=2;
-					c=instring.charAt(i);
-		            break;
-				}
-		        if(c == '\n' || c == '\r' || c == '') {
-		            row++;
-				}
-		        i++;
-		    }
-			// Multi-character Operators
-		} else if (inprefix.indexOf(c) >= 0) {											
-			str = c;
-            i++;
-            while(true) {
-		        c=instring.charAt(i);
-               	if(i >= length || insuffix.indexOf(c) < 0) {
-               		break;
-               	}
-               	str += c;
-               	i++;
-            }
-			// Single-character Operators
-           	makeToken('operator', str, from, i, row);
-        } else {																									
-           	i++;
-           	makeToken('operator', c, from, i, row);
-           	c = instring.charAt(i);
-        }
-	}
-}
-
-function newButton() {
-	var funclist;
-	var oplist;
-	oplist = document.getElementById('infobox');
-	string_tokenize = "foo // Lederhosen\nsin'foo'(200.0*r)+(-21.4/1.51e-6)+/*Plodder*/(Feeeb+400)*ln(3000);\ncos(200.1-atan2(41.0,51.0));\nHello+85-4*2.6-1.51e-6;";
-	tokenize(string_tokenize, "<>+-&","=>&:");				
-	// Iterate over token objects and print kind of each token and token type in window 
-	printout = document.getElementById('infobox');
-	for(i = 0;i < tokens.length;i++) {
-		printout.innerHTML += tokens[i].kind + " " + tokens[i].val + " (" + tokens[i].from + "-" + tokens[i].to + ") at: " + tokens[i].row + "<br>";
-	}	
-}		
+		        } else if (c == '/' && instring.charAt(i+1) == '*') {								
+		            i++;
+		            for(;;) {
+		    		    c=instring.charAt(i);
+		                if((c == '*' && instring.charAt(i+1) == '/') || (i == length)) {
+		                    i+=2;
+				    		c=instring.charAt(i);
+		                    break;
+		                }
+		                if(c == '\n' || c == '\r' || c == '') {
+		                    row++;
+		                }
+		                i++;
+		            }
+				// Multi-character Operators
+        		} else if (inprefix.indexOf(c) >= 0) {											
+            		str = c;
+            		i++;
+            		while(true) {
+		    		    c=instring.charAt(i);
+                		if(i >= length || insuffix.indexOf(c) < 0) {
+                    		break;
+                		}
+                		str += c;
+                		i++;
+            		}
+					// Single-character Operators
+            		maketoken('operator', str, from, i, row);
+        		} else {																									
+            		i++;
+            		maketoken('operator', c, from, i, row);
+            		c = instring.charAt(i);
+        		}
+			}
+		}
+		function newButton()
+		{
+			var funclist;
+			var oplist;
+			oplist = document.getElementById('infobox');
+			string_tokenize = "foo // Lederhosen\nsin'foo'(200.0*r)+(-21.4/1.51e-6)+/*Plodder*/(Feeeb+400)*ln(3000);\ncos(200.1-atan2(41.0,51.0));\nHello+85-4*2.6-1.51e-6;";
+			tokenize(string_tokenize, "<>+-&","=>&:");				
+			// Iterate over token objects and print kind of each token and token type in window 
+			printout = document.getElementById('infobox');
+			for(i = 0;i < tokens.length;i++) {
+				printout.innerHTML += tokens[i].kind + " " + tokens[i].val + " (" + tokens[i].from + "-" + tokens[i].to + ") at: " + tokens[i].row + "<br>";
+			}	
+		}		

=== added file 'Code Viewer Alt/.DS_Store'
Binary files Code Viewer Alt/.DS_Store and Code Viewer Alt/.DS_Store differ
=== modified file 'Code Viewer Alt/AJAX/AjaxDemoApp0_getCustomer.php'
--- Code Viewer Alt/AJAX/AjaxDemoApp0_getCustomer.php	2013-04-05 08:35:29 +0000
+++ Code Viewer Alt/AJAX/AjaxDemoApp0_getCustomer.php	2013-04-04 09:29:10 +0000
@@ -8,11 +8,7 @@
 
 	include("../Codeviewer/showcode.php");
 	
-<<<<<<< TREE
-	menulayout("AjaxDemoApp1_storeCustomer.php","","AjaxDemoApp0_getCustomer.txt","AJAX Example 0: Get Customer AJAX API","AjaxDemoApp0_getCustomer.html","AjaxDemoApp0_getCustomer.html");
-=======
 	menulayout("AjaxDemoApp1_storeCustomer.php","","AjaxDemoApp0_getCustomer.txt","AJAX Example 0: Get Customer AJAX API","AjaxDemoApp0_getCustomer.html","AjaxDemoApp0_getCustomer_description.html");
->>>>>>> MERGE-SOURCE
 	
 	$interestingrows = array(array(8,18,"Ajax function"),array(20,34,"Ajax return function"));
 	$keywords = array("showCustomer","ResultCustomer",'"Haakon"');

=== modified file 'Code Viewer Alt/AJAX/AjaxDemoApp1_storeCustomer.php'
--- Code Viewer Alt/AJAX/AjaxDemoApp1_storeCustomer.php	2013-04-05 08:35:29 +0000
+++ Code Viewer Alt/AJAX/AjaxDemoApp1_storeCustomer.php	2013-04-04 09:29:10 +0000
@@ -1,29 +1,8 @@
-<!DOCTYPE html>
 <html>
 	<head>
 		<link rel="stylesheet" type="text/css" href="../Codeviewer/showcode.css">
 		<script language="javascript" " src="../Codeviewer/showcode.js"></script>
 	</head>
-<<<<<<< TREE
-	<body>
-	<?php
-
-		include("../Codeviewer/showcode.php");
-		
-		menulayout("AjaxDemoApp2_getCustomerBookings.php","AjaxDemoApp0_getCustomer.php","AjaxDemoApp1_storeCustomer.txt","AJAX Example 1: Creation of Customer","AjaxDemoApp1_storeCustomer.html","AjaxDemoApp1_storeCustomer1.html");
-		
-		$interestingrows = array(array(7,26,"Ajax function"),array(28,36,"Ajax return function"));
-		$keywords = array("makeCustomer","storeCustomer","ResultCustomer","customerID");
-		$highlight = array(array("{","highlightnormal"),array("}","highlightnormal"),array("function","highlightspecial"));
-
-		showfile($interestingrows,$keywords,$highlight,"AjaxDemoApp1_storeCustomer.html");
-
-		menulayoutend();
-
-	?>
-
-	</body>
-=======
 
 <?php
 
@@ -42,5 +21,4 @@
 ?>
 
 </body>
->>>>>>> MERGE-SOURCE
 </html>

=== added file 'Code Viewer Alt/Codeviewer/.DS_Store'
Binary files Code Viewer Alt/Codeviewer/.DS_Store and Code Viewer Alt/Codeviewer/.DS_Store differ
=== modified file 'Code Viewer Alt/Codeviewer/showcode.php'
--- Code Viewer Alt/Codeviewer/showcode.php	2013-04-05 08:35:29 +0000
+++ Code Viewer Alt/Codeviewer/showcode.php	2013-04-04 18:10:23 +0000
@@ -13,13 +13,13 @@
 					
 					if($backward != "") {
 						echo "<td class='buttonstyle'>";
-							echo "<a href='".$backward."'><img src='../../media/codeviewer/CodeViewerLeftbutton.png'></a>";
+							echo "<a href='".$backward."'><img src='../img/prev.png'></a>";
 						echo "</td>";
 					}
 					
 					if($forward != "") {
 						echo "<td class='buttonstyle'>";
-							echo "<a href='".$forward."'><img src='../../media/codeviewer/CodeViewerRightbutton.png'></a>";
+							echo "<a href='".$forward."'><img src='../img/next.png'></a>";
 						echo "</td>";
 					}
 

=== modified file 'Code Viewer Alt/Codeviewer/showsource.php'
--- Code Viewer Alt/Codeviewer/showsource.php	2013-04-05 08:35:29 +0000
+++ Code Viewer Alt/Codeviewer/showsource.php	2013-04-03 13:00:19 +0000
@@ -5,12 +5,11 @@
 	</head>
 	<?php
 		include("showcode.php");
-		menulayout("innan.php","efter.php","test.txt","Example 1: Execution of AJAX API","example_code.txt","example_code_description.txt");
+		menulayout("innan.php","efter.php","test.txt","Example 1: Execution of AJAX API","Ponyo.txt");
 		$interestingrows = array(array(16,21,"Ajax function"),array(23,37,"Ajax return function"));
 		$keywords = array("showCustomer","ResultCustomer");
 		$highlight = array(array("{","highlightnormal"),array("}","highlightnormal"),array("function","highlightspecial"));
-		showfile($interestingrows,$keywords,$highlight,"example_code.php");
+		showfile($interestingrows,$keywords,$highlight);
 		menulayoutend();
 	?>
 </html>
-

=== modified file 'Code Viewer Alt/index.js'
--- Code Viewer Alt/index.js	2013-04-05 10:58:15 +0000
+++ Code Viewer Alt/index.js	2013-04-04 16:28:40 +0000
@@ -15,13 +15,11 @@
 		scrollTo(destination);
 	});
 	var sidebar = $('#sidebar');
-	$(window).bind('scroll', function() {
+	$(document).bind('scroll', function() {
 		sidebar.css("top", $(window).scrollTop());
 	});
-	$('.ieCSS3Fix, .group h2').each(function() {
-		if(PIE.attach) {
-			PIE.attach(this);
-		}
+	$('.ieCSS3Fix, .menuLink').each(function() {
+		PIE.attach(this);
 	});
 });
 

=== modified file 'Code Viewer Alt/style.css'
--- Code Viewer Alt/style.css	2013-04-08 08:05:58 +0000
+++ Code Viewer Alt/style.css	2013-04-04 16:28:40 +0000
@@ -31,18 +31,15 @@
 	background: #c0d0e0;
 	background-color: #c0d0e0;
 	text-shadow: 1px 1px 2px #000;
-	font-weight:normal;
+	font-weight:normal;            
 	background: linear-gradient(to top, #abc 10%, #89a 90%, #678 99% );
 	background: -webkit-linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
 	background: -moz-linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
-	-pie-background: linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
-	filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#6a7b8c', endColorstr='#aabbcc')
 	font-size: 1.4em;
 	margin-top: 1em;
 	margin-bottom: 0;
 	padding:3px;
 	padding-left:20px;
-	min-width:100%;
 }
 
 a {
@@ -78,10 +75,13 @@
 	position:absolute;
 	top:40px;
 	left:0px;
-	width:90%;
-	padding: 10px 0 8% 8%;
+	width:10.5%;
+	width:96%;
+	padding: 10px 0 1% 0.3%;
 	background: #c0d0e0;
 	background-color: #c0d0e0;
+	_border-bottom-right-radius: 1.3em;
+	_border-top-right-radius: 1.3em;
 	border-radius: 0 1.3em 1.3em 0;
 	border-bottom: 2px solid #000;
 	border-right: 1px solid #000;
@@ -90,21 +90,18 @@
 	font-weight:bolder;
 	background:#678;
 	background-color:#678;
-	filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#6a7b8c', endColorstr='#aabbcc')
 	background: linear-gradient(to top, #abc 10%, #89a 90%, #678 99% );
 	background: -webkit-linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
 	background: -moz-linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
-	-pie-background: linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
 }
 
 #menu #menuHeader{
 	margin:0 0 1.5% 0;
-	position:relative;
 	background:#333333;
 	width:97%;
 	height:31px;
-	padding-left:14px;
-	margin-left:-15px;
+	padding-left:10px;
+	margin-left:-10px;
 	border-radius: 0 10px 10px 0;
 	cursor:pointer;
 }
@@ -133,12 +130,6 @@
 	text-decoration: none; 
 	margin-left:1%;
 	font-size:100%
-	
-	/* For IE 8 */
-	-ms-filter: "progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=-90, Color='#444444')";
-	/* For IE 5.5 - 7 */
-	filter: progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=-90, Color='#444444');
-	filter:DropShadow(Color=#444444, OffX=1, OffY=2);
 }
 
 #menu a:hover {
@@ -156,7 +147,7 @@
 	left:0px;
 	top:0px;
 	float:left;
-	min-width:9.4em;
+	min-width:8em;
 	width:auto;
 	height:100%;
 	overflow:auto;
@@ -164,7 +155,7 @@
 
 #content { 
 	position:absolute;
-	left:9.5em;
+	left:8em;
 	max-width:75%;
 	min-width:20em;
 }
@@ -185,4 +176,4 @@
 	-webkit-transform:rotate(180deg);
 	-moz-transform:rotate(180deg); 
 	-o-transform:rotate(180deg);
-}
+}
\ No newline at end of file

=== removed file 'CodeViewer/Lindex.css'
--- CodeViewer/Lindex.css	2013-04-05 11:42:25 +0000
+++ CodeViewer/Lindex.css	1970-01-01 00:00:00 +0000
@@ -1,188 +0,0 @@
-.group {
-	display: block;
-	padding: 1em;
-	width: 100%;
-	margin: auto auto;
-	font-family: "Franklin Gothic Medium", "Franklin Gothic", "ITC Franklin Gothic", Arial, sans-serif;
-}
-
-.group h1 {
-	font-weight: normal;
-	font-size: 1.8em;
-	margin-bottom: 1em;
-	font-family: Cambria, Georgia, serif;
-}
-
-.group.info {
-	padding: 0.4em;
-	margin: 0.5em;
-	font-size: 1em;
-	color: #000;
-}
-
-.group .info:first-letter {
-	font-size:1.3em;
-}
-
-.group h2 {
-	font-family: Calibri, Candara, Segoe, "Segoe UI", Optima, Arial, sans-serif; 
-	border-bottom: 2px solid #000;
-	color: #fff;
-	background: #c0d0e0;
-	background-color: #c0d0e0;
-	text-shadow: 1px 1px 2px #000;
-	font-weight:normal;            
-	background: linear-gradient(to top, #abc 10%, #89a 90%, #678 99% );
-	background: -webkit-linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
-	background: -moz-linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
-	-pie-background: linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
-	font-size: 1.4em;
-	margin-top: 1em;
-	margin-bottom: 0;
-	padding:3px;
-	padding-left:20px;
-	min-width:100%;
-}
-
-a {
-	line-height: 2em;
-	margin-left: 1.3em;
-	color: black;
-	text-decoration: underline;
-	font-size: 1em;
-}
-
-li {
-	color: #555;
-}
-
-a:hover {
-	text-decoration: none;
-}
-
-.container {
-	border-left: 2px dotted #ddd;
-	margin-left: 8px;	
-}
-
-.container.demo {
-	float:right;
-}
-
-body{
-	margin:0;
-}
-
-#menu {
-	position:absolute;
-	top:40px;
-	left:0px;
-	width:10.5%;
-	width:96%;
-	padding: 10px 0 1% 0.3%;
-	background: #c0d0e0;
-	background-color: #c0d0e0;
-	border-radius: 0 1.3em 1.3em 0;
-	border-bottom: 2px solid #000;
-	border-right: 1px solid #000;
-	color: #fff;
-	text-shadow: 1px 1px 2px #000;
-	font-weight:bolder;
-	background:#678;
-	background-color:#678;
-	background: linear-gradient(to top, #abc 10%, #89a 90%, #678 99% );
-	background: -webkit-linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
-	background: -moz-linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
-	-pie-background: linear-gradient(bottom, #abc 10%, #89a 90%, #678 99%);
-}
-
-#menu #menuHeader{
-	margin:0 0 1.5% 0;
-	position:relative;
-	background:#333333;
-	width:97%;
-	height:31px;
-	padding-left:10px;
-	margin-left:-10px;
-	border-radius: 0 10px 10px 0;
-	cursor:pointer;
-}
-
-#menuHeader h3{
-	float:left;
-	font-family: Calibri, Candara, Segoe, "Segoe UI", Optima, Arial, sans-serif; 
-	font-size:1.2em;
-	background-color:#333;
-	color:#fff;
-	width:80%;
-	margin-top:4px;
-	padding:0;
-}
-
-#menuArrow {
-	float:left;
-	padding:0;
-	margin-top:8px;
-	width:15%;
-}
-
-#menu a {
-	display:block;color:#fff;
-	font-family: Calibri, Candara, Segoe, "Segoe UI", Optima, Arial, sans-serif; 
-	text-decoration: none; 
-	margin-left:1%;
-	font-size:100%
-	
-	/* For IE 8 */
-	-ms-filter: "progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=-90, Color='#444444')";
-	/* For IE 5.5 - 7 */
-	filter: progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=-90, Color='#444444');
-	filter:DropShadow(Color=#444444, OffX=1, OffY=2);
-}
-
-#menu a:hover {
-	font-weight:bolder;
-	text-decoration:underline;
-}
-
-#menuItems {
-	float:left;
-	width:80%;
-}
-
-#sidebar {
-	position:absolute;
-	left:0px;
-	top:0px;
-	float:left;
-	min-width:8em;
-	width:auto;
-	height:100%;
-	overflow:auto;
-}
-
-#content { 
-	position:absolute;
-	left:8em;
-	width:75%;
-	max-width:75%;
-	min-width:20em;
-}
-
-.arrow{
-	-webkit-transition-duration: 0.9s;
-	-moz-transition-duration: 0.9s;
-	-o-transition-duration: 0.9s;
-	transition-duration: 0.9s;
-	-webkit-transition-property: -webkit-transform;
-	-moz-transition-property: -moz-transform;
-	-o-transition-property: -o-transform;
-	transition-property: transform;
-	overflow:auto;
-}
-
-.rotateArrowCW {
-	-webkit-transform:rotate(180deg);
-	-moz-transform:rotate(180deg); 
-	-o-transform:rotate(180deg);
-}
\ No newline at end of file

=== modified file 'CodeViewer/Lindex.html'
--- CodeViewer/Lindex.html	2013-04-05 11:42:25 +0000
+++ CodeViewer/Lindex.html	2013-04-03 08:20:14 +0000
@@ -1,38 +1,37 @@
 <!DOCTYPE html>
 <html>
-	<head>
-		<title>Webbprogrammering DA330G</title>
-		<link rel="stylesheet" href="Lindex.css" type="text/css" media="screen" />
-		<script type="text/javascript" src="../js/jquery.js"></script>
-		<script type="text/javascript" src="../etc/PIE/PIE.js"></script>
-		<script type="text/javascript" src="Lindex.js"></script>
-	</head>
-	<body>
-		<div id="sidebar">
-			<div id="menu" class="ieCSS3Fix">
-				<div id="menuHeader" class="ieCSS3Fix">
-					<h3>Quick links</h3>
-					<img id="menuArrow" class="arrow" src="../media/codeviewer/CodeViewerLeftbutton.png" alt="arrow" />
-				</div>
-				<div id="menuItems">
-					<a href="#LectureSlides" class="menuLink">Lectures</a>
-					<a href="#Assignments" class="menuLink">Assignments</a>
-					<a href="#PHPIntro" class="menuLink">PHP Intro</a>
-					<a href="#SAXExamples" class="menuLink">SAX</a>
-					<a href="#DOMExamples" class="menuLink">DOM</a>
-					<a href="#XSLTExamples" class="menuLink">XSLT</a>
-					<a href="#NamespaceExamples" class="menuLink">Namespaces</a>
-					<a href="#Tips" class="menuLink">Tips</a>
-				</div>
-			</div>
+<head>
+    <title>Webbprogrammering DA330G</title>
+    <link rel="stylesheet" href="Lindex.css" type="text/css" media="screen" />
+</head>
+<body>
+	<div id="sidebar">
+		<div id="menu">
+			<div id="menuHeader">
+				<h3>Quick links</h3>
+			</div>
+			<div id="menuItems">
+				<a href="#LectureSlides" class="menuLink">Lectures</a>
+				<a href="#Assignments" class="menuLink">Assignments</a>
+				<br>
+				<a href="#PHPIntro" class="menuLink">PHP Intro</a>
+				<a href="#SAXExamples" class="menuLink">SAX</a>
+				<a href="#DOMExamples" class="menuLink">DOM</a>
+				<a href="#XSLTExamples" class="menuLink">XSLT</a>
+				<a href="#NamespaceExamples" class="menuLink">Namespaces</a>
+				<a href="#Tips" class="menuLink">Tips</a>
+			</div>
+			
 		</div>
-		<div id="content">
-			<div class="group">
-				<h1>Lectures and Assignments</h1>
-				<h2 id="LectureSlides">Lecture Slides</h2>
+	</div>
+	<div id="content">
+    <div class="group">
+    	<h1>Lectures and Assignments</h1>
+        <h2 id="LectureSlides">Lecture Slides</h2>
 				<div class="container">
-				</div>
-				<h2 id="Assignments">Assignments</h2>
+	    	</div>
+
+        <h2 id="Assignments">Assignments</h2>
 				<div class="container">
 					<a href='Assignment1a/Assignment1a.php'>Assignment 1A: PHP Forms and simple Arrays</a><br>	
 					<a href='Assignment1b/Assignment1b.php'>Assignment 1B: PHP Arrays and Tables</a><br>	
@@ -43,11 +42,12 @@
 					<a href='Assignment6/Assignment6.php'>Assignment 6: XSLT Iteration</a><br>	
 					<a href='Assignment7/Assignment7.php'>Assignment 7: XSLT Recursive Templates</a><br>	
 					<a href='Assignment8/Assignment8.php'>Assignment 8: Main Assignment</a><br>	
-				</div>
-			</div> <!-- End Group div --> 
-			<div class="group">
-				<h1>Code Examples</h1>
-				<h2 id="PHPIntro">PHP Introduction</h2>
+	    	</div>
+    </div> <!---- End Group div ----> 
+
+    <div class="group">
+    	<h1>Code Examples</h1>
+        <h2 id="PHPIntro">PHP Introduction</h2>
 				<div class="container">
 					<a href='IntroExample1/IntroExample1.php'>Introduction Example 1: PHP Startup</a><br>	
 					<a href='IntroExample2/IntroExample2.php'>Introduction Example 2: PHP Startup</a><br>	
@@ -62,8 +62,9 @@
 					<a href='IntroExample11/IntroExample11.php'>Introduction Example 11: Forms #5</a><br>	
 					<a href='IntroExample12/IntroExample12.php'>Introduction Example 12: Tables #1</a><br>	
 					<a href='IntroExample13/IntroExample13.php'>Introduction Example 13: Tables #2</a><br>	
-				</div>
-				<h2 id="SAXExamples">SAX Examples</h2>
+	    	</div>
+
+        <h2 id="SAXExamples">SAX Examples</h2>
 				<div class="container">
 					<a href='SAXExample1a/SAXExample1a.php'>SAX Example 1: Sax Initiation</a><br>	
 					<a href='SAXExample1b/SAXExample1b.php'>SAX Example 2: Removal of White Space Tags</a><br>	
@@ -71,22 +72,24 @@
 					<a href='SAXExample1d/SAXExample1d.php'>SAX Example 4: Print formatting</a><br>	
 					<a href='SAXExample1e/SAXExample1e.php'>SAX Example 5: Print formatting</a><br>	
 					<a href='SAXExample1f/SAXExample1f.php'>SAX Example 6: Indentation</a><br>	
-				</div>
-				<h2 id="DOMExamples">DOM Examples</h2>
+	    	</div>
+
+        <h2 id="DOMExamples">DOM Examples</h2>
 				<div class="container">
-					<a href='DomExample1/DomExample1.php'>DOM Example 1: Initiation and simple navigation</a><br>	
-					<a href='DomExample1b/DomExample1b.php'>DOM Example 2: Attribute navigation</a><br>	
-					<a href='DomExample1c/DomExample1c.php'>DOM Example 3: Advanced navigation</a><br>	
-					<a href='DomExample1d/DomExample1d.php'>DOM Example 4: Advanced navigation</a><br>	
-					<a href='DomExample2/DomExample2.php'>DOM Example 5: Validation #1</a><br>	
-					<a href='DomExample2b/DomExample2b.php'>DOM Example 6: Validation #2</a><br>	
-					<a href='DomExample2c/DomExample2c.php'>DOM Example 7: Validation #3</a><br>	
-					<a href='DomExample2d/DomExample2d.php'>DOM Example 8: Validation #4</a><br>	
-					<a href='DomExample2e/DomExample2e.php'>DOM Example 9: Validation #5 </a><br>	
-					<a href='DomExample3/DomExample3.php'>DOM Example 10: XPATH #1</a><br>	
-					<a href='DomExample3b/DomExample3b.php'>DOM Example 11: XPATH #2 Context Nodes</a><br>
-				</div>
-				<h2 id="XSLTExamples">XSLT Examples</h2>
+					<a href='DOMExample1/DOMExample1.php'>DOM Example 1: Initiation and simple navigation</a><br>	
+					<a href='DOMExample1b/DOMExample1b.php'>DOM Example 2: Attribute navigation</a><br>	
+					<a href='DOMExample1c/DOMExample1c.php'>DOM Example 3: Advanced navigation</a><br>	
+					<a href='DOMExample1d/DOMExample1d.php'>DOM Example 4: Advanced navigation</a><br>	
+					<a href='DOMExample2/DOMExample2.php'>DOM Example 5: Validation #1</a><br>	
+					<a href='DOMExample2b/DOMExample2b.php'>DOM Example 6: Validation #2</a><br>	
+					<a href='DOMExample2c/DOMExample2c.php'>DOM Example 7: Validation #3</a><br>	
+					<a href='DOMExample2d/DOMExample2d.php'>DOM Example 8: Validation #4</a><br>	
+					<a href='DOMExample2e/DOMExample2e.php'>DOM Example 9: Validation #5 </a><br>	
+					<a href='DOMExample3/DOMExample3.php'>DOM Example 10: XPATH #1</a><br>	
+					<a href='DOMExample3b/DOMExample3b.php'>DOM Example 11: XPATH #2 Context Nodes</a><br>
+	    	</div>
+
+        <h2 id="XSLTExamples">XSLT Examples</h2>
 				<div class="container">
 					<a href='XSLTExample1/XSLTExample1.php'>XSLT Example 1: Template Match</a><br>	
 					<a href='XSLTExample2/XSLTExample2.php'>XSLT Example 2: Simple Navigation</a><br>	
@@ -99,18 +102,22 @@
 					<a href='XSLTExample8b/XSLTExample8b.php'>XSLT Example 8b: Grouping using keys</a><br>	
 					<a href='XSLTExample9/XSLTExample9.php'>XSLT Example 9: Grouping</a><br>	
 					<a href='XSLTExample10/XSLTExample10.php'>XSLT Example 10: Variables</a><br>	
-				</div>
-				<h2 id="NamespaceExamples">Namespace Examples</h2>
+	    	</div>
+
+        <h2 id="NamespaceExamples">Namespace Examples</h2>
 				<div class="container">
 					<a href='NamespaceExample1/NamespaceExample1.php'>Namespace Example 1: Sax API</a><br>	
 					<a href='NamespaceExample2/NamespaceExample2.php'>Namespace Example 2: DOM API</a><br>	
 					<a href='NamespaceExample3/NamespaceExample3.php'>Namespace Example 3: DOM API with XPATH</a><br>	
 					<a href='NamespaceExample4/NamespaceExample4.php'>Namespace Example 4: XSLT</a><br>	
-				</div>
-				<h2 id="Tips">Tips and Tricks</h2>
+	    	</div>
+
+        <h2 id="Tips">Tips and Tricks</h2>
 				<div class="container">
-				</div>
-			</div> <!-- End Group div --> 
-		</div>
-	</body>
+	    	</div>
+
+    </div> <!---- End Group div ----> 
+
+	</div>
+</body>
 </html>

=== removed file 'CodeViewer/Lindex.js'
--- CodeViewer/Lindex.js	2013-04-05 11:42:25 +0000
+++ CodeViewer/Lindex.js	1970-01-01 00:00:00 +0000
@@ -1,55 +0,0 @@
-var menuTopOffset = 40;
-var menuLeftOffset = 25;
-
-$(document).ready(function() {
-//	window.onresize = fixMenuLeft;
-	//$('#menu').offset({ top: menuTopOffset, left: $('#menu').offset().left });
-	//window.onscroll = moveMenu;
-	$('#menuHeader').click(toggleMenu);/*
-	
-	*/
-	$("a.menuLink").click(function(event) {
-		event.preventDefault();
-		event.stopPropagation();
-		var destination = event.target.href.substring(event.target.href.lastIndexOf('#') + 1);
-		scrollTo(destination);
-	});
-	var sidebar = $('#sidebar');
-	$(window).bind('scroll', function() {
-		sidebar.css("top", $(window).scrollTop());
-	});
-	$('.ieCSS3Fix, .group h2').each(function() {
-		PIE.attach(this);
-	});
-});
-
-function fixMenuLeft(ev) {
-	//$('#menu').offset({ top: bodyelem.scrollTop()+menuTopOffset, left: -($('#menu').width()-30) });
-	if($('#menu').offset().left != 0) {
-		$('#menu').offset({ top: $('#menu').offset().top, left: -($('#menu').width()-menuLeftOffset) });
-	}
-}
-
-function toggleMenu(ev) {
-	if($('#menu').offset().left == 0) {
-		$('#menu').stop().animate({ left: -($('#menu').width()-menuLeftOffset) },{duration:900});
-		$("#menuArrow").addClass("rotateArrowCW");
-	} else {
-		$('#menu').stop().animate({ left: 0 },{duration:900});
-		$("#menuArrow").removeClass("rotateArrowCW");
-	}
-}
-
-function moveMenu(ev){
-	if($.browser.webkit) {
-		bodyelem = $("body");
-	} else {
-		bodyelem = $("html,body");
-	}
-	$('#menu').offset({ top: bodyelem.scrollTop()+menuTopOffset, left: $('#menu').offset().left });
-}
-
-function scrollTo(id){
-	$('html,body').animate({scrollTop: $("#"+id).offset().top},{duration:900});
-	return false;
-}
\ No newline at end of file

=== modified file 'CodeViewer/codeviewer.js'
--- CodeViewer/codeviewer.js	2013-04-05 08:08:29 +0000
+++ CodeViewer/codeviewer.js	2013-04-03 11:51:49 +0000
@@ -1,45 +1,50 @@
-﻿var mb = 0;
-var panelWidth = 450;
-var mx;
-var my;
+﻿var mb=0;
+var panelwidth=450;
+var mx, my;
 
 function resize() {
 	document.getElementById("bottom").style.height = (document.body.clientHeight - 44) + "px";
 	document.getElementById("panel").style.height = (document.body.clientHeight - 44) + "px";
-}
-
-function resizePanel(ev) {
-	var panel =	document.getElementById('panel');
+}			
+
+function resizepanel(ev) {
+	var panel=document.getElementById('panel');
+
 	// Firefox
-	if(ev.layerX || ev.layerX == 0) {
-		mx = ev.layerX - panel.offsetLeft;
-		my = ev.layerY - panel.offsetTop;
-	//Opera
-	} else if(ev.offsetX || ev.offsetX == 0) {
-		mx = ev.offsetX - panel.offsetLeft;
-		my = ev.offsetY - panel.offsetTop;
+	if (ev.layerX || ev.layerX == 0) {
+		mx=ev.layerX-panel.offsetLeft;
+		my=ev.layerY-panel.offsetTop;
+	} 
+
+	// Opera
+	else if (ev.offsetX || ev.offsetX == 0) {
+		mx=ev.offsetX-panel.offsetLeft;
+		my=ev.offsetY-panel.offsetTop;
 	}			
-	if((mx > (panelWidth - 4)) && ( mx < (panelWidth + 4) )) {
-		panel.style.cursor = "col-resize";					
+
+	if( (mx > (panelwidth-4) ) && ( mx < ( panelwidth + 4) ) ){
+		panel.style.cursor="col-resize";					
 	} else {
-		panel.style.cursor = "default";
+		panel.style.cursor="default";
 	}
+
 	if(mb) {
-		panel.style.width = mx + 4;
-		panelWidth = mx + 4;
-		panel.style.cursor = "col-resize";
+		panel.style.width=mx+4;
+		panelwidth=mx+4;
+		panel.style.cursor="col-resize";
 		return false;
 	} else {
 		return true;
 	}
+
 }
 
-function mdPanel(ev) {
-	if((mx > (panelWidth-4 )) && (mx < (panelWidth + 4 ))) {
-		mb = 1;
+function mdpanel(ev) {
+	if((mx > (panelwidth-4)) && (mx < (panelwidth + 4))) {
+		mb=1;
 	}
 }
 
-function muPanel(ev) {
-	mb = 0;
-}
\ No newline at end of file
+function mupanel(ev) {
+	mb=0;
+}

=== modified file 'CodeViewer/codeviewer.php'
--- CodeViewer/codeviewer.php	2013-04-05 08:08:29 +0000
+++ CodeViewer/codeviewer.php	2013-04-04 17:50:47 +0000
@@ -4,18 +4,27 @@
 		<link rel="stylesheet" type="text/css" href="codeviewer.css">
 		<script type="text/javascript" src="codeviewer.js"></script>
 	</head>
-	<?php
-		include("codeviewerfunctions.php");
-		
-		menulayout("innan.php", "efter.php", "example_code.txt", "Example 1: Execution of AJAX API", "example_code.txt", "example_code_description.txt");
-		
-		$interestingRows = array(array(6, 9, "Interesting row array"), array(11,14,"Keywords"));
-	
-		$keywords = array("showCustomer", "ResultCustomer");
-	
-		$highlight = array(array("array", "highlightnormal"), array("showfile", "highlightspecial"));
-	
-		showfile($interestingRows, $keywords, $highlight, "example_code.txt");
-		menulayoutEnd();
-	?>
+<?php
+	include("codeviewerfunctions.php");
+	
+	menulayout("innan.php","efter.php","example_code.txt","Example 1: Execution of AJAX API","example_code.txt", "example_code_description.txt");
+	
+	$interestingrows = array(
+		array(6,9,"Interesting row array"),
+		array(11,14,"Keywords")
+	);
+
+	$keywords = array(
+		"showCustomer",
+		"ResultCustomer"
+	);
+
+	$highlight = array(
+		array("array", "highlightnormal"),
+		array("showfile", "highlightspecial")
+	);
+
+	showfile($interestingrows,$keywords,$highlight, "example_code.txt");
+	menulayoutend();
+?>
 </html>

=== modified file 'CodeViewer/codeviewerfunctions.php'
--- CodeViewer/codeviewerfunctions.php	2013-04-05 08:08:29 +0000
+++ CodeViewer/codeviewerfunctions.php	2013-04-04 08:31:00 +0000
@@ -1,32 +1,32 @@
 <?php
-/* function menulayout
- * Takes 6 arguments and outputs a HTML navigation menu
-* $forwardLink = link to "next page", i.e. "nextPage.html"
-* $backwardLink = link to "previous page", i.e. "previousPage.html"
-* $downloadLink = link to download source file, on download button, i.e. "sourceFile.txt"
-* headingLink = link in heading, i.e. "sourceFile.txt"
-* fileContent = file containing info in the left panel, i.e. "panelContent.txt"
-*/
-function menulayout($forwardLink, $backwardLink, $downloadLink, $heading, $headingLink, $fileContent) {
-	if($backwardLink != "") {
-		$backwardButton = "<a href='".$backwardLink."'><img src='../media/codeviewer/CodeViewerLeftbutton.png'></a>";
-	} else {
-		$backwardButton = "<img src='../media/codeviewer/CodeViewerLeftbuttonGrayed.png'>";
-	}
-
-	if($forwardLink != "") {
-		$forwardButton = "<a href='".$forwardLink."'><img src='../media/codeviewer/CodeViewerRightbutton.png'></a>";
-	} else {
-		$forwardButton = "<img src='../media/codeviewer/CodeViewerLeftbuttonGrayed.png'>";
-	}
-
-	if($downloadLink != "") {
-		$downloadButton = "<a href='".$downloadLink."'><img src='../media/codeviewer/CodeViewerDownloadbutton.png'></a>";
-	} else {
-		$downloadButton = "<img src='../media/codeviewer/CodeViewerLeftbuttonGrayed.png'>";
-	}
-
-	echo '<body onload="resize();" onresize="resize();">
+	/* function menulayout
+	 * Takes 6 arguments and outputs a HTML navigation menu 
+	 * $forward = link to "next page", i.e. "nextPage.html"
+	 * $backward = link to "previous page", i.e. "previousPage.html"
+	 * $downloadlink = link to download source file, on download button, i.e. "sourceFile.txt"
+	 * headinglink = link in heading, i.e. "sourceFile.txt"
+	 * filecontent = file containing info in the left panel, i.e. "panelContent.txt"
+	*/
+	function menulayout($forward,$backward,$downloadlink,$heading,$headinglink,$filecontent) {
+		if($backward != ""){
+			$backwardButton = "<a href='".$backward."'><img src='../media/codeviewer/CodeViewerLeftbutton.png'></a>";
+		}else{
+			$backwardButton = "<img src='../media/codeviewer/CodeViewerLeftbuttonGrayed.png'>";
+		}
+
+		if($forward != ""){
+			$forwardButton = "<a href='".$forward."'><img src='../media/codeviewer/CodeViewerRightbutton.png'></a>";
+		}else{
+			$forwardButton = "<img src='../media/codeviewer/CodeViewerLeftbuttonGrayed.png'>";
+		}
+
+		if($downloadlink != ""){
+			$downloadButton = "<a href='".$downloadlink."'><img src='../media/codeviewer/CodeViewerDownloadbutton.png'></a>";
+		}else{
+			$downloadButton = "<img src='../media/codeviewer/CodeViewerLeftbuttonGrayed.png'>";
+		}
+
+		echo '		<body onload="resize();" onresize="resize();">
 			<div class="Topmenu">
 				<table style="width:100%;height:100%;border:solid 1px;">
 					<tr>
@@ -40,7 +40,7 @@
 							<a href="../Lindex.html"><img src="../media/codeviewer/CodeViewerRightbutton.png"></a>
 						</td>
 						<td class="verticalaligntext">
-							<a href="'. $headingLink .'" style="text-decoration: none">'. $heading .'</a>
+							<a href="'. $headinglink .'" style="text-decoration: none">'. $heading .'</a>
 						</td>
 						<td class="buttonstyle">
 							'. $downloadButton .'
@@ -51,143 +51,144 @@
 			<div id="bottom" class="restContainer">
 				<div style="float: left;">
 					<div id="panel" class="panel" onmousemove="resizepanel(event)" onmousedown="mdpanel(event)" onmouseup="mupanel(event)">';
-						include($fileContent);
-				echo '</div>
-				</div>
-			<div class="codecontent">';
-}
-
-/* function menulayoutend
- * Outputs ending tags in HTML
-*/
-function menulayoutEnd() {
-	echo '</div>
-		</div>
-		<div style="clear: both;">
-		</div>
-	</body>';
-}
-
-/* function showfile
- * Outputs html with syntax highlighting.
-* Takes 4 arguments_
-* interestingRows: array containing arrays, each with 3 set values -- start line number, end line number, comment
-* keywords: array containing keywords
-* highlight: array containing arrays, each with two values - string to highlight, and HTML class to apply to highlight */
-function showfile($interestingRows, $keywords, $highlight, $fileName) {
-	echo "<pre>";
-	$handle = @fopen($fileName, "r");
-	if ($handle) {
-
-		$lineNumber = 1;
-		$commentKind = 0;
-		$commentOn = 0;
-
-		while (($buffer = fgets($handle, 4096)) !== false) {
-			$buffer = str_replace("\n", "", $buffer);
-			$buffer = str_replace("\r", "", $buffer);
-			$buffer = str_pad($buffer, 150, " ", STR_PAD_RIGHT);
-			$buffer = str_replace("&", "&amp;", $buffer);
-			$buffer = str_replace("<", "&lt;", $buffer);
-			$buffer = str_replace(">", "&gt;", $buffer);
-			$buffer = str_replace("\t", "&nbsp;", $buffer);
-
-			$interesting = 0;
-			$startspan = 0;
-			foreach($interestingRows as $row) {
-				if($lineNumber >= $row[0] && $lineNumber <= $row[1]) {
-					$interesting = true;
-				}
-			}
-
-			foreach($keywords as $keyword) {
-				if($interesting) {
-					$buffer = str_replace($keyword,"<span class='keywordinteresting'>".$keyword."</span>", $buffer);
+						include($filecontent);
+					echo '				</div>
+				</div>
+				<div class="codecontent">';
+	}
+
+	/* function menulayoutend
+	 * Outputs ending tags in HTML
+	 */
+	function menulayoutend() {
+		echo '
+				</div>
+			</div>
+			<div style="clear: both;"></div>
+		</body>
+		';
+	}
+
+	/* function showfile 
+	 * Outputs html with syntax highlighting.
+	 * Takes 4 arguments_
+	 * interestingrows: array containing arrays, each with 3 set values -- start line number, end line number, comment
+	 * keywords: array containing keywords 
+	 * highlight: array containing arrays, each with two values - string to highlight, and HTML class to apply to highlight */
+	function showfile($interestingrows,$keywords,$highlight,$filename) {
+		echo "<pre>";
+		$handle = @fopen($filename, "r");
+		if ($handle) {
+
+			$lineno = 1;
+			$commentkind = 0;
+			$commenton = 0;
+
+			while (($buffer = fgets($handle, 4096)) !== false) {
+				$buffer = str_replace("\n", "", $buffer);
+				$buffer = str_replace("\r", "", $buffer);
+				$buffer = str_pad($buffer, 150, " ", STR_PAD_RIGHT);
+				$buffer = str_replace("&", "&amp;", $buffer);
+				$buffer = str_replace("<", "&lt;", $buffer);
+				$buffer = str_replace(">", "&gt;", $buffer);
+				$buffer = str_replace("\t", "&nbsp;", $buffer);
+
+				$interesting = 0;
+				$startspan = 0;
+				foreach($interestingrows as $row){
+					if($lineno >= $row[0] && $lineno <= $row[1]){
+						$interesting = true;
+					}
+				}
+
+				foreach($keywords as $keyword){
+					if($interesting){
+						$buffer = str_replace($keyword,"<span class='keywordinteresting'>".$keyword."</span>", $buffer);
+					}else{
+						$buffer = str_replace($keyword,"<span class='keyword'>".$keyword."</span>", $buffer);
+					}
+				}
+
+				// Detect comments - 0 == No comment 1 == Line comment 2 == Start Comment 3 == End Comment
+				$commentkind = 0;
+				$commentpos = strpos($buffer,"/*");
+
+				if($commentpos >= 0){
+					$subby = substr($buffer,$commentpos+2,1);
+				}else{
+					$subby = "Foo";
+				}
+
+				if($commentpos && $subby != '"'){
+					$commentkind = 2;
+					$commenton = 1;
+				}							
+
+				$commentpos = strpos($buffer,"*/");
+
+				if($commentpos){
+					$commentkind = 3;
+					$commenton = 0;
+				}							
+
+				$commentpos=strpos($buffer,"//");
+
+				if($commentpos){
+					$commentkind = 1;
+					$commenton = 0;
+				}							
+
+				foreach($highlight as $highlightkeyword){
+					$foundpos = strpos($buffer, $highlightkeyword[0]);
+
+					// If line comment and keyword before comment marker
+					if(($foundpos <= $commentpos && ($commentkind == 1 || $commentkind == 2)) || ($commentkind == 0) || ($foundpos > $commentpos && $commentkind == 3)) {
+						if(!($commentkind==0&&$commenton==1)) {
+							$buffer = str_replace($highlightkeyword[0],"<span class='".$highlightkeyword[1]."'>".$highlightkeyword[0]."</span>",$buffer);
+						}
+					}
+
+				}
+
+				// echo $commentkind.$commenton;
+				if($commentkind > 0){
+					if($commentkind == 1){
+						$buffer = str_replace("//","<span class='commented'>//",$buffer);
+						$buffer .= "</span>";
+					}
+					if($commentkind==2) {
+						$buffer=str_replace("/*","<span class='commented'>/*",$buffer);
+					} 
+					if($commentkind==3) {
+						$buffer=str_replace("*/","*/</span>",$buffer);
+					}
+				}
+
+				$linenostr = $lineno;
+				$linenostr = str_pad($linenostr,3," ",STR_PAD_RIGHT);
+				
+				if($interesting){
+					echo "<span class='interesting'>";
+					echo "<span class='linenointeresting'>".$linenostr."</span>&nbsp;";
+					$startspan = 1;
 				} else {
-					$buffer = str_replace($keyword,"<span class='keyword'>".$keyword."</span>", $buffer);
-				}
-			}
-
-			// Detect comments - 0 == No comment 1 == Line comment 2 == Start Comment 3 == End Comment
-			$commentKind = 0;
-			$commentPos = strpos($buffer,"/*");
-
-			if($commentPos >= 0) {
-				$subby = substr($buffer, $commentPos+2, 1);
-			} else {
-				$subby = "Foo";
-			}
-
-			if($commentPos && $subby != '"') {
-				$commentKind = 2;
-				$commentOn = 1;
-			}
-
-			$commentPos = strpos($buffer, "*/");
-
-			if($commentPos) {
-				$commentKind = 3;
-				$commentOn = 0;
-			}
-
-			$commentPos=strpos($buffer, "//");
-
-			if($commentPos) {
-				$commentKind = 1;
-				$commentOn = 0;
-			}
-
-			foreach($highlight as $highlightkeyword) {
-				$foundpos = strpos($buffer, $highlightkeyword[0]);
-
-				// If line comment and keyword before comment marker
-				if(($foundpos <= $commentPos && ($commentKind == 1 || $commentKind == 2)) || ($commentKind == 0) || ($foundpos > $commentPos && $commentKind == 3)) {
-					if(!($commentKind == 0 && $commentOn == 1)) {
-						$buffer = str_replace($highlightkeyword[0], "<span class='".$highlightkeyword[1]."'>".$highlightkeyword[0]."</span>", $buffer);
-					}
-				}
-
-			}
-
-			// echo $commentKind.$commentOn;
-			if($commentKind > 0) {
-				if($commentKind == 1) {
-					$buffer = str_replace("//","<span class='commented'>//", $buffer);
-					$buffer .= "</span>";
-				}
-				if($commentKind == 2) {
-					$buffer=str_replace("/*","<span class='commented'>/*", $buffer);
-				}
-				if($commentKind == 3) {
-					$buffer=str_replace("*/","*/</span>", $buffer);
-				}
-			}
-
-			$linenostr = $lineNumber;
-			$linenostr = str_pad($linenostr, 3, " ", STR_PAD_RIGHT);
-
-			if($interesting) {
-				echo "<span class='interesting'>";
-				echo "<span class='linenointeresting'>".$linenostr."</span>&nbsp;";
-				$startspan = 1;
-			} else {
-				echo "<span class='lineno'>".$linenostr."</span>&nbsp;";
-			}
-
-			echo $buffer;
-
-			if($startspan) {
-				echo "</span>";
-			}
-
-			$lineNumber++;
-			echo "<br>";
-		}
-		if (!feof($handle)) {
-			echo "Error: unexpected fgets() fail\n";
-		}
-		fclose($handle);
+					echo "<span class='lineno'>".$linenostr."</span>&nbsp;";				
+				}
+				
+				echo $buffer;
+				
+				if($startspan) {
+					echo "</span>";
+				}
+				
+				$lineno++;
+				echo "<br>";
+			}
+			if (!feof($handle)) {
+				echo "Error: unexpected fgets() fail\n";
+			}
+			fclose($handle);
+		}
+		echo "</pre>";	
 	}
-	echo "</pre>";
-}
 ?>
\ No newline at end of file

=== renamed file 'DuggaSys/changePassword/pageframe.php' => 'DuggaSys/changePassword/pageframe.html.php'
=== renamed file 'DuggaSys/changePassword/password.php' => 'DuggaSys/changePassword/password.html.php'
=== modified file 'DuggaSys/duggor/Dugga 3 Datorgrafik - Transformationer/dugga_datorgrafik_1_transforms.php'
--- DuggaSys/duggor/Dugga 3 Datorgrafik - Transformationer/dugga_datorgrafik_1_transforms.php	2013-04-04 08:41:39 +0000
+++ DuggaSys/duggor/Dugga 3 Datorgrafik - Transformationer/dugga_datorgrafik_1_transforms.php	2013-04-03 12:44:23 +0000
@@ -1,10 +1,10 @@
 <?php 
 
-include "dugga_checklogin.php";
+ //include "dugga_checklogin.php";
 
 	$accountname="EgonKleveen";
 
-if($accountname=checkLogin($errorMsg): ?>
+if (true): ?>
 
 <html>
 	<head>

=== modified file 'DuggaSys/duggor/index.html'
--- DuggaSys/duggor/index.html	2013-04-05 08:45:18 +0000
+++ DuggaSys/duggor/index.html	2013-04-04 08:53:46 +0000
@@ -37,4 +37,4 @@
 		<p>Glöm inte att spara svarskoden!</p>
 	</fieldset>
 	</body>
-</html>
+</html>
\ No newline at end of file

=== modified file 'DuggaSys/index.php'
--- DuggaSys/index.php	2013-04-04 09:01:10 +0000
+++ DuggaSys/index.php	2013-04-03 12:44:23 +0000
@@ -9,4 +9,4 @@
 	<body>
 		<h1>Quiz server</h1>
 	</body>
-</html>
+</html>
\ No newline at end of file

=== renamed file 'DuggaSys/quizSystem/course/courses.php' => 'DuggaSys/quizSystem/course/courses.html.php'
=== renamed file 'DuggaSys/quizSystem/data/displayData.php' => 'DuggaSys/quizSystem/data/displayData.html.php'
=== renamed file 'DuggaSys/quizSystem/login/login.php' => 'DuggaSys/quizSystem/login/login.html.php'
=== renamed file 'DuggaSys/quizSystem/pageframe.php' => 'DuggaSys/quizSystem/pageframe.html.php'
=== renamed file 'DuggaSys/quizSystem/quiz/addEditQuiz.php' => 'DuggaSys/quizSystem/quiz/addEditQuiz.html.php'
=== renamed file 'DuggaSys/quizSystem/quiz/editVariants.php' => 'DuggaSys/quizSystem/quiz/editVariants.html.php'
=== renamed file 'DuggaSys/quizSystem/quiz/listDataObjects.php' => 'DuggaSys/quizSystem/quiz/listDataObjects.html.php'
=== renamed file 'DuggaSys/quizSystem/quiz/listQuizzes.php' => 'DuggaSys/quizSystem/quiz/listQuizzes.html.php'
=== renamed file 'DuggaSys/quizSystem/quizChecking/listQuizAnswers.php' => 'DuggaSys/quizSystem/quizChecking/listQuizAnswers.html.php'
=== renamed file 'DuggaSys/quizSystem/quizChecking/quizAnswerDetails.php' => 'DuggaSys/quizSystem/quizChecking/quizAnswerDetails.html.php'
=== renamed file 'DuggaSys/quizSystem/quizChecking/selectCourse.php' => 'DuggaSys/quizSystem/quizChecking/selectCourse.html.php'
=== renamed file 'DuggaSys/quizSystem/quizChecking/selectQuiz.php' => 'DuggaSys/quizSystem/quizChecking/selectQuiz.html.php'
=== renamed file 'DuggaSys/quizSystem/registerStudents/parsingResult.php' => 'DuggaSys/quizSystem/registerStudents/parsingResult.html.php'
=== renamed file 'DuggaSys/quizSystem/registerStudents/print.php' => 'DuggaSys/quizSystem/registerStudents/print.html.php'
=== renamed file 'DuggaSys/quizSystem/search/search.php' => 'DuggaSys/quizSystem/search/search.html.php'
=== renamed file 'DuggaSys/quizSystem/students/listStudents.php' => 'DuggaSys/quizSystem/students/listStudents.html.php'
=== modified file 'ErModeller/canvas.css'
--- ErModeller/canvas.css	2013-04-05 07:45:38 +0000
+++ ErModeller/canvas.css	2013-04-04 08:48:09 +0000
@@ -1,13 +1,3 @@
-#a {
-	border:2px solid black;
-}
-
-#infobox {
-	padding:4px;
-}
-
-#background {
-	border:2px solid black;
-	background-color:#fed;
-	width:300px;height:450px;
-}
\ No newline at end of file
+#a			{border:2px solid black;}
+#infobox	{padding:4px;}
+#background		{border:2px solid black;background-color:#fed; width:300px;height:450px;}

=== modified file 'ErModeller/canvas.js'
--- ErModeller/canvas.js	2013-04-05 07:45:38 +0000
+++ ErModeller/canvas.js	2013-04-03 09:15:09 +0000
@@ -1,612 +1,604 @@
-var startx = 0;
-var starty = 0;
-var deltax = 0;
-var deltay = 0;	
-var gridsize = 20;
-
-// Multi-select move offset
-var offsx = 0;
-var offsy = 0;
-
-// Drawing Globals -- For while in transit drawing
-var drawlinesx;
-var drawlinesy;
-var drawlinedx;
-var drawlinedy;
-var drawlinekind = 0;
-
-// List of objects
-var Objects = new Array();
-
-// List of identifiers 
-var Selected = new Array();
-
-// List of selected object identifiers 
-var Identifiers = new Array();
-
-// The context object
-var ContextObj;
-
-// Mouse Down Result
-var downRes;
-// User Interface Mode Variables
-var multiselect = 0;
-var dragsensitivity = 12;
-var sidetol = 12;
-var printstr;
-
-/*
- *  User interface callbacks
- */
-function handler_mouseup() {
-	if(clickstate == 1) {
-
-		// Either select on/off for multi or single select
-		if(multiselect) {
-			if(Selected[downRes.objid]) {
-				Selected[downRes.objid] = false;
-			} else {
-				Selected[downRes.objid] = true;
-			}
-		} else {
-			if(ContextObj == downRes.objid) {
-					ContextObj = "";
-			} else {
-				ContextObj = downRes.objid;
-			}
-		}
-	} else if(clickstate == 8) {
-
-		// Draw Attribute Line
-		upRes=mouseover(gridx,gridy);
-		if(upRes.code != "None") {
-			obj = Objects[downRes.objid];
-			if(upRes.typ == "ERAttribute" || upRes.typ == "Entity" || upRes.typ == "ERRel") {
-				obj.DrawtoID = upRes.objid;
-				obj.DrawfromSide = downRes.side;
-				if(upRes.side != "None") {
-					obj.DrawtoSide = upRes.side;
-					obj.DrawtoPerc = upRes.sideperc;
-				} else {
-					upobj = Objects[downRes.objid];
-					var sid = 1;
-					var	perco = 0.5;
-					var x1g = Math.abs(upRes.x1 - gridx);
-					var x2g = Math.abs(upRes.x2 - gridx);
-					var y1g = Math.abs(upRes.y1 - gridy);
-					var y2g = Math.abs(upRes.y2 - gridy);
-					if(x1g <= x2g && x1g <= y1g && x1g <= y2g){
-						sid = 1;
-						perco = makesideperc(gridy, upRes.y1, upRes.y2);
-					} else if(x2g <= x1g && x2g <= y1g && x2g <= y2g){
-						sid = 3;
-						perco = makesideperc(gridy, upRes.y1, upRes.y2);
-					} else if(y1g <= x1g && y1g <= x2g && y1g <= y2g){
-						sid = 4;
-						perco = makesideperc(gridx, upRes.x1, upRes.x2);
-					} else if(y2g <= x1g && y2g <= x2g && y2g <= y1g){
-						sid = 2;
-						perco = makesideperc(gridx, upRes.x1, upRes.x2);
-					}
-					obj.DrawtoSide = sid;
-					obj.DrawtoPerc = perco;
-				}
-				if(upRes.typ == "ERAttribute" || upRes.typ == "ERRel") obj.DrawtoPerc = 0.5;
-			}
-		}
-	} else if(clickstate == 9) {
-
-		// Draw Relationship line
-		upRes = mouseover(gridx, gridy);
-		if(upRes.code != "None") {
-			obj = Objects[downRes.objid];
-			if(upRes.side != "None") {
-				if(obj.DrawtoID == "None") {
-					obj.DrawtoID = upRes.objid;
-					obj.DrawtoSide = upRes.side;
-					obj.DrawtoPerc = upRes.sideperc;
-					obj.DrawfromSide = downRes.side;
-				} else {
-					obj.DrawtoIDDest = upRes.objid;
-					obj.DrawtoSideDest = upRes.side;
-					obj.DrawtoPercDest = upRes.sideperc;
-					obj.DrawfromSideDest = downRes.side;										
-				}
-			} else {
-				upobj = Objects[downRes.objid];
-				var sid = 1;
-				var	perco = 0.5;
-				var x1g = Math.abs(upRes.x1-gridx);
-				var x2g = Math.abs(upRes.x2-gridx);
-				var y1g = Math.abs(upRes.y1-gridy);
-				var y2g = Math.abs(upRes.y2-gridy);
-				if(x1g <= x2g && x1g <= y1g && x1g <= y2g) {
-					sid = 1;
-					perco = makesideperc(gridy, upRes.y1, upRes.y2);
-				} else if(x2g <= x1g && x2g <= y1g && x2g <= y2g) {
-					sid = 3;
-					perco = makesideperc(gridy, upRes.y1, upRes.y2);
-				} else if(y1g <= x1g && y1g <= x2g && y1g <= y2g) {
-					sid = 4;
-					perco = makesideperc(gridx, upRes.x1, upRes.x2);
-				} else if(y2g <= x1g && y2g <= x2g && y2g <= y1g){
-					sid = 2;
-					perco = makesideperc(gridx, upRes.x1, upRes.x2);
-				}									
-				if(obj.DrawtoID == "None") {
-					obj.DrawtoID = upRes.objid;
-					obj.DrawtoSide = sid;
-					obj.DrawtoPerc = perco;
-					obj.DrawfromSide = downRes.side;										
-				} else {
-					obj.DrawtoIDDest = upRes.objid;
-					obj.DrawtoSideDest = sid;
-					obj.DrawtoPercDest = perco;
-					obj.DrawfromSideDest = downRes.side;										
-				}
-			}								
-		}
-	}
-	clickstate = 0;
-	cpsel = 0;
-	drawlinekind = 0;		
-}
-/*
- *	Mouse down state
- */
-function handler_mousedown() {
-	clickstate = 1;
-	downRes = mouseover(gridx, gridy);
-	startx = gridx;
-	starty = gridy;	
-}
-
-/*
- *	Mouse move
- */
-function handler_mousemove(cx, cy) {
+		var startx = 0;
+		var starty = 0;
+		var deltax = 0;
+		var deltay = 0;	
+		var gridsize = 20;
+		
+		// Multi-select move offset
+		var offsx = 0;
+		var offsy = 0;
+		// Drawing Globals -- For while in transit drawing
+		var drawlinesx;
+		var drawlinesy;
+		var drawlinedx;
+		var drawlinedy;
+		var drawlinekind = 0;
+		// List of objects
+		// List of identifiers 
+		// List of selected object identifiers 
+		// The context object
+		var Objects = new Array();
+		var Selected = new Array();
+		var Identifiers = new Array();
+		var ContextObj;
+		// Mouse Down Result
+		var downRes;
+		// User Interface Mode Variables
+		var multiselect = 0;
+		var dragsensitivity = 12;
+		var sidetol = 12;
+		var printstr;
+
+		/*
+		User interface callbacks
+		*/
+		function handler_mouseup()
+		{
+			if(clickstate == 1) {
+				// Either select on/off for multi or single select
+				if(multiselect) {
+					if(Selected[downRes.objid]) {
+						Selected[downRes.objid] = false;
+					} else {
+						Selected[downRes.objid] = true;
+					}
+				} else {
+					if(ContextObj == downRes.objid) {
+							ContextObj = "";
+					} else {
+						ContextObj = downRes.objid;
+					}
+				}
+			} else if(clickstate == 8) {
+				// Draw Attribute Line
+				upRes=mouseover(gridx,gridy);
+				if(upRes.code != "None") {
+					obj = Objects[downRes.objid];
+					if(upRes.typ == "ERAttribute" || upRes.typ == "Entity" || upRes.typ == "ERRel") {
+						obj.DrawtoID = upRes.objid;
+						obj.DrawfromSide = downRes.side;
+						if(upRes.side != "None") {
+							obj.DrawtoSide = upRes.side;
+							obj.DrawtoPerc = upRes.sideperc;
+						} else {
+							upobj = Objects[downRes.objid];
+							var sid = 1;
+							var	perco = 0.5;
+							var x1g = Math.abs(upRes.x1 - gridx);
+							var x2g = Math.abs(upRes.x2 - gridx);
+							var y1g = Math.abs(upRes.y1 - gridy);
+							var y2g = Math.abs(upRes.y2 - gridy);
+							if(x1g <= x2g && x1g <= y1g && x1g <= y2g){
+								sid = 1;
+								perco = makesideperc(gridy, upRes.y1, upRes.y2);
+							} else if(x2g <= x1g && x2g <= y1g && x2g <= y2g){
+								sid = 3;
+								perco = makesideperc(gridy, upRes.y1, upRes.y2);
+							} else if(y1g <= x1g && y1g <= x2g && y1g <= y2g){
+								sid = 4;
+								perco = makesideperc(gridx, upRes.x1, upRes.x2);
+							} else if(y2g <= x1g && y2g <= x2g && y2g <= y1g){
+								sid = 2;
+								perco = makesideperc(gridx, upRes.x1, upRes.x2);
+							}
+							obj.DrawtoSide = sid;
+							obj.DrawtoPerc = perco;
+						}
+						if(upRes.typ == "ERAttribute" || upRes.typ == "ERRel") obj.DrawtoPerc = 0.5;
+					}
+				}
+			} else if(clickstate == 9) {
+				// Draw Relationship line
+				upRes = mouseover(gridx, gridy);
+				if(upRes.code != "None") {
+					obj = Objects[downRes.objid];
+					if(upRes.side != "None") {
+						if(obj.DrawtoID == "None") {
+							obj.DrawtoID = upRes.objid;
+							obj.DrawtoSide = upRes.side;
+							obj.DrawtoPerc = upRes.sideperc;
+							obj.DrawfromSide = downRes.side;
+						} else {
+							obj.DrawtoIDDest = upRes.objid;
+							obj.DrawtoSideDest = upRes.side;
+							obj.DrawtoPercDest = upRes.sideperc;
+							obj.DrawfromSideDest = downRes.side;										
+						}
+					} else {
+						upobj = Objects[downRes.objid];
+						var sid = 1;
+						var	perco = 0.5;
+						var x1g = Math.abs(upRes.x1-gridx);
+						var x2g = Math.abs(upRes.x2-gridx);
+						var y1g = Math.abs(upRes.y1-gridy);
+						var y2g = Math.abs(upRes.y2-gridy);
+						if(x1g <= x2g && x1g <= y1g && x1g <= y2g) {
+							sid = 1;
+							perco = makesideperc(gridy, upRes.y1, upRes.y2);
+						} else if(x2g <= x1g && x2g <= y1g && x2g <= y2g) {
+							sid = 3;
+							perco = makesideperc(gridy, upRes.y1, upRes.y2);
+						} else if(y1g <= x1g && y1g <= x2g && y1g <= y2g) {
+							sid = 4;
+							perco = makesideperc(gridx, upRes.x1, upRes.x2);
+						} else if(y2g <= x1g && y2g <= x2g && y2g <= y1g){
+							sid = 2;
+							perco = makesideperc(gridx, upRes.x1, upRes.x2);
+						}									
+						if(obj.DrawtoID == "None") {
+							obj.DrawtoID = upRes.objid;
+							obj.DrawtoSide = sid;
+							obj.DrawtoPerc = perco;
+							obj.DrawfromSide = downRes.side;										
+						} else {
+							obj.DrawtoIDDest = upRes.objid;
+							obj.DrawtoSideDest = sid;
+							obj.DrawtoPercDest = perco;
+							obj.DrawfromSideDest = downRes.side;										
+						}
+					}								
+				}
+			}
+			clickstate = 0;
+			cpsel = 0;
+			drawlinekind = 0;		
+		}
+		/*
+		 *	Mouse down state
+		 */
+		function handler_mousedown() {
+			clickstate = 1;
+			downRes = mouseover(gridx, gridy);
+			startx = gridx;
+			starty = gridy;	
+		}
+		
+		/*
+		 *	Mouse move
+		 */
+		function handler_mousemove(cx, cy) {
 //			gridx=Math.round((cx-(gridsize/2.0))/gridsize)*gridsize;
 //			gridy=Math.round((cy-(gridsize/2.0))/gridsize)*gridsize;				
-	gridx = cx;
-	gridy = cy;
-	deltax = startx - gridx;
-	deltay = starty - gridy;		
-	// We start drag mode
-	if((distance(gridx, gridy, startx, starty) > dragsensitivity) && clickstate == 1) {
-		clickstate = 2;
-	}
-	// We are in drag mode				
-	if(clickstate == 2) {																										
-		// Single Object Move - If Not Selected, Or if Selected and Center Area Is Dragged
-		if((downRes.typ == "Entity" || downRes.typ == "ERAttribute" || downRes.typ == "ERRel") && (downRes.code == "NonSel" || (downRes.code == "Cont" && downRes.side == "None") || (downRes.code == "ContDraw" && downRes.side == "None"))) {
-			clickstate = 3;
-		}
-		// Single Object Scale Left
-		if((downRes.typ == "Entity" || downRes.typ == "ERAttribute") && (downRes.code == "Cont" && downRes.side == "1")) {
-			clickstate=4;
-		}
-		// Single Object Scale Bottom
-		if((downRes.typ == "Entity" || downRes.typ == "ERAttribute") && (downRes.code == "Cont" && downRes.side == "2")) {
-			clickstate=5;
-		}
-		// Single Object Scale Right
-		if((downRes.typ == "Entity" || downRes.typ == "ERAttribute") && (downRes.code == "Cont" && downRes.side == "3")) {
-			clickstate=6;
-		}
-		// Single Object Scale Top
-		if((downRes.typ == "Entity" || downRes.typ == "ERAttribute") && (downRes.code == "Cont" && downRes.side == "4")) {
-			clickstate=7;
-		}
-		if(downRes.typ == "ERAttribute" && downRes.code == "ContDraw" && downRes.side != "None") {													
-			clickstate=8; // Attribute Connection Draw
-			drawlinekind=1;	// Tell drawing engine to draw attribute line symbol
-			if(downRes.side == "1") {
-				drawlinesx = downRes.x1; // Initiate start parameters for line drawing left side
-				drawlinesy = downRes.y1 + ((downRes.y2 - downRes.y1) * 0.5);									
-			} else if(downRes.side == "2") {
-				drawlinesx = downRes.x1 + ((downRes.x2 - downRes.x1) * 0.5); // Initiate start parameters for line drawing bottom side
-				drawlinesy = downRes.y2;
-			} else if(downRes.side == "3") {
-				drawlinesx = downRes.x2; // Initiate start parameters for line drawing left side
-				drawlinesy = downRes.y1 + ((downRes.y2 - downRes.y1) * 0.5);									
-			} else if(downRes.side == "4") {
-				drawlinesx = downRes.x1 + ((downRes.x2 - downRes.x1) * 0.5); // Initiate start parameters for line drawing bottom side
-				drawlinesy = downRes.y1;
-			}
-			drawlinedx = drawlinesx;
-			drawlinedy = drawlinesy;	
-		}
-		if(downRes.typ == "ERRel" && downRes.code == "ContDraw" && downRes.side != "None") {						
-			var obj=Objects[downRes.objid];													
-			if(downRes.side != obj.DrawfromSide && downRes.side != obj.DrawfromSideDest) {
-				clickstate = 9; // Attribute Connection Draw
-				drawlinekind = 1; // Tell drawing engine to draw relation line symbol 
-				if(downRes.side == "1") {
-					drawlinesx = downRes.x1; // Initiate start parameters for line drawing left side
-					drawlinesy = downRes.y1 + ((downRes.y2 - downRes.y1) * 0.5);									
-				} else if(downRes.side == "2") {
-					drawlinesx = downRes.x1 + ((downRes.x2 - downRes.x1) * 0.5); // Initiate start parameters for line drawing bottom side
-					drawlinesy = downRes.y2;
-				} else if(downRes.side == "3") {
-					drawlinesx = downRes.x2; // Initiate start parameters for line drawing left side
-					drawlinesy = downRes.y1 + ((downRes.y2 - downRes.y1) * 0.5);									
-				} else if(downRes.side == "4") {
-					drawlinesx = downRes.x1 + ((downRes.x2 - downRes.x1) * 0.5); // Initiate start parameters for line drawing bottom side
-					drawlinesy = downRes.y1;
-				}
-				drawlinedx = drawlinesx;
-				drawlinedy = drawlinesy;
-			}
-		}				
-	}
-	if(clickstate > 2) {
-		var obj = Objects[downRes.objid];
-	}
-	if(clickstate == 3) { // We are in single rectangular object move 
-		obj.x1 = downRes.x1 - deltax;
-		obj.y1 = downRes.y1 - deltay;
-		obj.x2 = downRes.x2 - deltax;
-		obj.y2 = downRes.y2 - deltay;
-	} else if(clickstate == 4) { // We are in single rectangular object scale left 
-		if((obj.x2 - downRes.x1 + deltax) > 60) obj.x1 = downRes.x1 - deltax;
-	} else if(clickstate == 5) { // We are in single rectangular object scale bottom
-		if((downRes.y2 - obj.y1 - deltay) > 40) obj.y2 = downRes.y2 - deltay;
-	} else if(clickstate==6) {	// We are in single rectangular object scale right
-		if((downRes.x2 - obj.x1 - deltax) > 60) obj.x2 = downRes.x2 - deltax;
-	} else if(clickstate == 7) { // We are in single rectangular object scale top
-		if((obj.y2 - downRes.y1 + deltay) > 40) obj.y1 = downRes.y1 - deltay;
-	} else if(clickstate == 8 || clickstate == 9) { // We are in straight connective line drawing mode 
-		drawlinedx = gridx;
-		drawlinedy = gridy;
-	}
-}
-
-/*
- *	Call-forward for mouse-over event
- */
-function mouseover(x, y) {
-	// Code of touch, and if available object id and id of side of object that was touched
-	// Tolerances included as constant
-	var obj_code = "None";
-	var obj_id = "None";
-	var obj_sidentifier =" None";
-	var obj_sideperc = 0;
-	var obj_centerdist = 0;
-	var obj_type = "None";
-	var obj_x1 = 0; 
-	var obj_y1 = 0; 
-	var obj_x2 = 0; 
-	var obj_y2 = 0;
-	var Cont;
-	var found = 0;
-	var side;
-	for(j = 0; j < Identifiers.length; j++) {
-		var objid = Identifiers[j];
-		var obj = Objects[objid];				
-		var Sel = Selected[objid];
-		if(ContextObj == objid) {
-			Cont = 1;
-		} else {
-			Cont = 0;
-		}
-		// Compute coordinates including offset
-		if(obj.type == "Entity" || obj.type == "ERAttribute" || obj.type == "ERRel") {										
-			x1 = obj.x1 + offsx;
-			y1 = obj.y1 + offsy;
-			x2 = obj.x2 + offsx;
-			y2 = obj.y2 + offsy;
-			rx = (x2 - x1) * 0.5;
-			ry = (y2 - y1) * 0.5;
-		}
-		found = 0;
-		// For each kind of clickable object, check if we are inside object and if so assign variables
-		// Any general properties for all object types are set when "found" is true
-		if(obj.type == "Entity") {				
-			if(x > (x1 - sidetol) && y > (y1 - sidetol ) && x < (x2 + sidetol) && y < (y2 + sidetol)) {
-				obj_code = "NonSel";
-				if(Sel) {
-					obj_code = "Sel";
-				}
-				if(Cont) {
-					obj_code = "Cont";
-				}
-				side = computeside(x, y, x1, y1, x2, y2, sidetol);
-				obj_sidentifier = side.side;
-				obj_sideperc = side.perc;
-				obj_centerdist = side.dist;					
-				found = 1;																	
-			}
-		} else if(obj.type=="ERAttribute") {
-				if(x > (x1 - sidetol) && y > (y1 - sidetol) && x < (x2 + sidetol) && y < (y2 + sidetol)) {
-					obj_code = "NonSel";
-					if(Sel) {
-						obj_code="Sel";
-					}							
-					if(Cont) {
-						if(obj.DrawtoID == "None") {
-							obj_code = "ContDraw";											
-						} else {
-							obj_code = "Cont";
-						}
-					} 
-					side = computeside(x, y, x1, y1, x2, y2, sidetol);
-					obj_sidentifier = side.side;
-					obj_sideperc = side.perc;
-					obj_centerdist = side.dist;
-					found = 1;
-				}
-		} else if(obj.type == "ERRel") {
-			if(x > (x1 - sidetol) && y > (y1 - sidetol) && x < (x2 + sidetol) && y < (y2 + sidetol)) {
-				xk = x - x1;
-				// Colision detection against diamond
-				var inside = 0;																		
-				if(xk <= rx) {
-					if(y > (y1 + ry - xk - sidetol) && y < (y1 + ry + xk + sidetol)) {
-						inside = 1;
-					}
-				} else {
-					if(y > (y1 - rx + xk - sidetol) && y < ( y2 + rx - xk + sidetol)) {
-						inside = 1;
-					}
-				}
-				if(inside) {	
-					if((x > (x1 - sidetol)) && (x < (x1 + sidetol)) && (y > (y1 + ry - sidetol)) && (y < (y1 + ry + sidetol))) {
-						obj_sidentifier = 1;
-					}
-					if((x > (x1 + rx - sidetol)) && (x < (x1 + rx + sidetol)) && (y > (y2 - sidetol)) && (y < (y2 + sidetol))) {
-						obj_sidentifier = 2;
-					}
-					if((x > (x2 - sidetol)) && (x < (x2 + sidetol)) && (y > (y1 + ry - sidetol)) && (y < (y1 + ry + sidetol))) {
-						obj_sidentifier = 3;
-					}
-					if((x > (x1 + rx - sidetol)) && (x < (x1 + rx + sidetol)) && (y > (y1 - sidetol)) && (y < (y1 + sidetol))) {
-						obj_sidentifier = 4;
-					}
-					obj_code = "NonSel";
-					if(Sel) {
-						obj_code = "Sel";
-					}
-					if(Cont) {
-						if(obj.DrawtoID == "None"){
-							obj_code = "ContDraw";											
-						} else if(obj.DrawtoIDDest == "None") {
-							obj_code = "ContDraw";											
-						} else {
-							obj_code = "Cont";
-						}
-					} 
-					obj_sideperc = 0.5;
-					found = 1;
-				}
-			}			
-		}
-		if(found == 1) {
-			// Save coordinates at time of click									
-			obj_x1 = x1;
-			obj_y1 = y1;
-			obj_x2 = x2;
-			obj_y2 = y2;						
-			obj_id = objid;
-			obj_type = obj.type;
-			printstr=obj_id + " " + obj_sidentifier + " " + obj_sideperc;
-		}
-	}						
-	return {
-		objid:obj_id,
-		code:obj_code,
-		side:obj_sidentifier,
-		sideperc:obj_sideperc,
-		centerdist:obj_centerdist,
-		typ:obj_type,
-		x1:obj_x1,
-		y1:obj_y1,
-		x2:obj_x2,
-		y2:obj_y2
-	}
-}
-
-/*
- * Turns JSON data into jQuery objects 
- */
-function importdata() {				
-	for(i = 0; i < 7; i++) {
-		if(i == 0) {
-			obj = jQuery.parseJSON('{"type":"ERAttribute","id":"ATT1","kind":"Multiple","name":"Addressfosoppooo","x1":220,"y1":100,"x2":300,"y2":140, "DrawtoID":"None", "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"None", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":""}');
-		}
-		if(i == 1) {
-			obj = jQuery.parseJSON('{"type":"Entity","id":"ENT2","kind":"Weak","name":"Carsmashoepppoloo","x1":100,"y1":160,"x2":220,"y2":220}');
-		}
-		if(i == 2) {
-			obj = jQuery.parseJSON('{"type":"ERAttribute","id":"ATT3","kind":"Key","name":"SSNFooomesPoo","x1":160,"y1":260,"x2":260,"y2":300, "DrawtoID":"None", "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"None", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":""}');
-		}
-		if(i == 3) {
-			obj = jQuery.parseJSON('{"type":"Entity","id":"ENT4","kind":"Strong","name":"Trailerfpdddpeoooooe","x1":320,"y1":260,"x2":420,"y2":320}');
-		}
-		if(i == 4) {
-			obj = jQuery.parseJSON('{"type":"Entity","id":"ENT5","kind":"Strong","name":"Grail","x1":120,"y1":440,"x2":220,"y2":480}');
-		}
-		if(i == 5) {
-			obj = jQuery.parseJSON('{"type":"ERRel","id":"REL6","kind":"Strong","name":"FGFool","x1":460,"y1":160,"x2":520,"y2":220, "DrawtoID":"None", "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"0", "DrawtoCard":"N", "DrawtoRole":"Fumo", "DrawtoXoffs":"20", "DrawtoYoffs":"50", "DrawtoIDDest":"None",  "DrawfromSideDest":"None","DrawtoSideDest":"None", "DrawtoPercDest":"0", "DrawtoDestCard":"N", "DrawtoDestRole":"Luma", "DrawtoDestXoffs":"0", "DrawtoDestYoffs":"-50", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":"","DrawX3":"", "DrawY3":"", "DrawX4":"","DrawY4":""}');
-		}
-		if(i == 6) {
-			obj = jQuery.parseJSON('{"type":"ERRel","id":"REL7","kind":"Weak","name":"PODrool","x1":360,"y1":360,"x2":420,"y2":420, "DrawtoID":"None",  "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"0", "DrawtoCard":"N", "DrawtoRole":"Kumo", "DrawtoXoffs":"60", "DrawtoYoffs":"70", "DrawtoIDDest":"None",  "DrawfromSideDest":"None","DrawtoSideDest":"None", "DrawtoPercDest":"0", "DrawtoDestCard":"N", "DrawtoDestRole":"Zuuma", "DrawtoDestXoffs":"40", "DrawtoDestYoffs":"50", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":"","DrawX3":"", "DrawY3":"", "DrawX4":"","DrawY4":""}');
-		}
-		objid = obj.id;
-		Objects[objid] = obj;
-		Identifiers.push(objid);
-	}
-}
-
-/* 
- * 	prepareobj
- * 	Prepares all kinds of objects, with local movement-offset (scrolling offset is handled with transforms??)
- * 	Ofss in prepare are not finished.
- */
-function prepareobj(obji) {
-	var fromobj = Objects[obji];
-	// Attributes are prepared by re-pointing the DrawX1, DrawY1, DrawX2 and DrawY2 variables and Relationships are prepared by re-pointing DrawX1-DrawX4 and DrawY1-DrawY4
-	if((fromobj.type == "ERAttribute" || fromobj.type == "ERRel") && fromobj.DrawtoID != "None") {									
-		var toid = fromobj.DrawtoID;
-		var toobj = Objects[toid];
-		var sidek;
-		if(fromobj.DrawtoIDDest != "None" && fromobj.DrawtoIDDest != undefined) {
-			var toiddest = fromobj.DrawtoIDDest;
-			var toobjdest = Objects[toiddest];						
-			sidek = makeside(fromobj.DrawfromSideDest, fromobj.x1, fromobj.y1, fromobj.x2, fromobj.y2, 0.5);
-			fromobj.DrawX3 = sidek.x;
-			fromobj.DrawY3 = sidek.y;
-			sidek = makeside(fromobj.DrawtoSideDest, toobjdest.x1, toobjdest.y1, toobjdest.x2, toobjdest.y2, fromobj.DrawtoPercDest);
-			fromobj.DrawX4 = sidek.x;
-			fromobj.DrawY4 = sidek.y;
-		}
-		//printstr=fromobj.DrawfromSide+" "+fromobj.x1+" "+fromobj.y1+" "+fromobj.x2+" "+fromobj.y2+" :: "+fromobj.DrawtoSide+" "+toobj.x1+" "+toobj.y1+" "+toobj.x2+" "+toobj.y2+" "+fromobj.DrawtoPerc;				
-		sidek = makeside(fromobj.DrawfromSide, fromobj.x1, fromobj.y1, fromobj.x2, fromobj.y2, 0.5);
-		fromobj.DrawX1 = sidek.x;
-		fromobj.DrawY1 = sidek.y;				
-		sidek = makeside(fromobj.DrawtoSide, toobj.x1, toobj.y1, toobj.x2, toobj.y2, fromobj.DrawtoPerc);
-		fromobj.DrawX2 = sidek.x; 
-		fromobj.DrawY2 = sidek.y;						
-	}
-}
-
-/*
- * 	Drawobj
- * 	Draws all kinds of objects, with local movement-offset (scrolling offset is handled with transforms??)
- */
-function drawobj(obji) {
-	var obj = Objects[obji];
-	var Sel = Selected[obji];
-	if(ContextObj == obji) {
-		Cont = 1;
-	} else {
-		Cont = 0;
-	}
-	context.strokeStyle = '#000';
-	context.lineWidth = 2.0;
-	// Compute coordinates including offset
-	if(obj.type == "Entity" || obj.type == "ERAttribute" || obj.type == "ERRel") {									
-		x1 = obj.x1 + offsx;
-		y1 = obj.y1 + offsy;
-		x2 = obj.x2 + offsx;
-		y2 = obj.y2 + offsy;
-		rx = (x2 - x1) * 0.5;
-		ry = (y2 - y1) * 0.5;
-	}
-	if(obj.type == "Entity") {				
-		//Draw Local Graphic
-		drawrect(x1, y1, x2, y2, "#000");
-		if(obj.kind == "Weak") {
-			drawrect(x1 + 5, y1 + 5, x2 - 5, y2 - 5, "#000");
-			cliptext(x1 + 5, y1 + 5, x2 - 5, y2 - 5, obj.name, "20px Calibri", "center", 8, 6, "#000", 1, 0);		
-
-		} else {
-			cliptext(x1, y1, x2, y2, obj.name, "20px Calibri", "center", 8, 6, "#000", 1, 0);						
-		}
-		// Draw Select Marker
-		if(Sel || Cont) {
-			fourpoints(x1, y1 + ry, x2, y1 + ry, x1 + rx, y1, x1 + rx, y2, "#5f8");								
-		}
-	} else if(obj.type == "ERAttribute") {
-		drawellipse(x1, y1, x2, y2);
-		if(obj.kind == "Key") {
-			cliptext(x1, y1, x2, y2, obj.name, "20px Calibri", "center", 8, 6, "#000", 2, 1);						
-		} else {
-			cliptext(x1, y1, x2, y2, obj.name, "20px Calibri", "center", 8, 6, "#000", 2, 0);												
-		}
-		if(obj.DrawtoID != "None") {
-			drawline(obj.DrawX1, obj.DrawY1, obj.DrawX2, obj.DrawY2, "#000", 2.0);
-		}
-		// Draw Select Marker
-		if(Cont && obj.DrawtoID == "None") {
-			fourpoints(x1, y1 + ry, x2, y1 + ry, x1 + rx, y1, x1 + rx, y2, "#fa2");
-		} else if(Sel || (Cont && obj.DrawtoID != "None")) {
-			fourpoints(x1, y1 + ry, x2, y1 + ry, x1 + rx, y1, x1 + rx, y2, "#5f8");
-		}
-	} else if(obj.type == "ERRel") {
-		if(obj.DrawtoID != "None") {
-			drawline(obj.DrawX1, obj.DrawY1, obj.DrawX2, obj.DrawY2, "#000", 2.0);
-			drawcardinality(obj.DrawX2, obj.DrawY2, obj.DrawtoSide, obj.DrawtoCard, obj.DrawtoXoffsCard, obj.DrawtoYoffsCard, "20px Calibri", 20, 1, "#0a0");
-			drawcardinality(obj.DrawX2, obj.DrawY2, obj.DrawtoSide, obj.DrawtoRole, obj.DrawtoXoffsRole, obj.DrawtoYoffsRole, "20px Calibri", 20, 2, "#0a0");
-			//function drawcardinality(x,y,side,tex,xoffs,yoffs,font,baseline,sign,color)
-			//if(i==5) obj = jQuery.parseJSON('{"type":"ERRel","id":"REL6","kind":"Strong","name":"FGFool","x1":460,"y1":160,"x2":520,"y2":220, "DrawtoID":"None", "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"0", "DrawtoCard":"N", "DrawtoRole":"Fumo", "DrawtoXoffsCard":"20", "DrawtoYoffsCard":"50","DrawtoXoffsRole":"20", "DrawtoYoffsRole":"-50", "DrawtoIDDest":"None",  "DrawfromSideDest":"None","DrawtoSideDest":"None", "DrawtoPercDest":"0", "DrawtoDestCard":"1", "DrawtoDestRole":"Luma", "DrawtoDestXoffsCard":"0", "DrawtoDestYoffsCard":"-50","DrawtoDestXoffsRole":"0", "DrawtoDestYoffsRole":"-50", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":"","DrawX3":"", "DrawY3":"", "DrawX4":"","DrawY4":""}');
-			//if(i==6) obj = jQuery.parseJSON('{"type":"ERRel","id":"REL7","kind":"Weak","name":"PODrool","x1":360,"y1":360,"x2":420,"y2":420, "DrawtoID":"None",  "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"0", "DrawtoCard":"1", "DrawtoRole":"Kumo", "DrawtoXoffsCard":"60", "DrawtoYoffsCard":"70", "DrawtoXoffsCard":"80", "DrawtoYoffsCard":"-70", "DrawtoIDDest":"None",  "DrawfromSideDest":"None","DrawtoSideDest":"None", "DrawtoPercDest":"0", "DrawtoDestCard":"N", "DrawtoDestRole":"Zuuma", "DrawtoDestXoffsCard":"40", "DrawtoDestYoffsCard":"50", "DrawtoDestXoffsRole":"40", "DrawtoDestYoffsRole":"50", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":"","DrawX3":"", "DrawY3":"", "DrawX4":"","DrawY4":""}');
-		}
-		if(obj.DrawtoIDDest != "None") {
-			drawline(obj.DrawX3, obj.DrawY3, obj.DrawX4, obj.DrawY4, "#000", 2.0);
-		}
-		if(obj.kind == "Weak") {
-			drawdiamond(x1 - 4, y1 - 4, x2 + 4, y2 + 4);
-			drawdiamond(x1 + 4, y1 + 4, x2 - 4, y2 - 4);
-			cliptext(x1 + 8, y1 + 8, x2 - 8, y2 - 8, obj.name, "20px Calibri", "center", 8, 6, "#000", 3, 0);												
-		} else {
-			drawdiamond(x1, y1, x2, y2, 0);
-			cliptext(x1, y1, x2, y2, obj.name, "20px Calibri", "center", 8, 6, "#000", 3, 0);												
-		}
-		// Draw Select Markers
-		if(Sel || (Cont && obj.DrawtoID != "None" && obj.DrawtoIDDest != "None")) {
-			fourpoints(x1, y1 + ry, x2, y1 + ry, x1 + rx, y1, x1 + rx, y2, "#5f8");
-		} else if(Cont) {
-			if(obj.DrawfromSide != 1 && obj.DrawfromSideDest != 1) {
-				point(x1, y1 + ry, "#fa2");
-			}
-			if(obj.DrawfromSide != 2 && obj.DrawfromSideDest != 2) {
-				point(x1 + rx, y2, "#fa2");
-			}
-			if(obj.DrawfromSide != 3 && obj.DrawfromSideDest != 3) {
-				point(x2, y1 + ry, "#fa2");
-			}
-			if(obj.DrawfromSide != 4 && obj.DrawfromSideDest != 4) {
-				point(x1 + rx, y1, "#fa2");
-			}
-		}
-	}
-}
-importdata();
-
-/*
- * 
- */
-function foo() {
-	context.clearRect(0, 0, 600, 600);
+			gridx = cx;
+			gridy = cy;
+			deltax = startx - gridx;
+			deltay = starty - gridy;		
+			// We start drag mode
+			if((distance(gridx, gridy, startx, starty) > dragsensitivity) && clickstate == 1) {
+				clickstate = 2;
+			}
+			// We are in drag mode				
+			if(clickstate == 2) {																										
+				// Single Object Move - If Not Selected, Or if Selected and Center Area Is Dragged
+				if((downRes.typ == "Entity" || downRes.typ == "ERAttribute" || downRes.typ == "ERRel") && (downRes.code == "NonSel" || (downRes.code == "Cont" && downRes.side == "None") || (downRes.code == "ContDraw" && downRes.side == "None"))) {
+					clickstate = 3;
+				}
+				// Single Object Scale Left
+				if((downRes.typ == "Entity" || downRes.typ == "ERAttribute") && (downRes.code == "Cont" && downRes.side == "1")) {
+					clickstate=4;
+				}
+				// Single Object Scale Bottom
+				if((downRes.typ == "Entity" || downRes.typ == "ERAttribute") && (downRes.code == "Cont" && downRes.side == "2")) {
+					clickstate=5;
+				}
+				// Single Object Scale Right
+				if((downRes.typ == "Entity" || downRes.typ == "ERAttribute") && (downRes.code == "Cont" && downRes.side == "3")) {
+					clickstate=6;
+				}
+				// Single Object Scale Top
+				if((downRes.typ == "Entity" || downRes.typ == "ERAttribute") && (downRes.code == "Cont" && downRes.side == "4")) {
+					clickstate=7;
+				}
+				if(downRes.typ == "ERAttribute" && downRes.code == "ContDraw" && downRes.side != "None") {													
+					clickstate=8; // Attribute Connection Draw
+					drawlinekind=1;	// Tell drawing engine to draw attribute line symbol
+					if(downRes.side == "1") {
+						drawlinesx = downRes.x1; // Initiate start parameters for line drawing left side
+						drawlinesy = downRes.y1 + ((downRes.y2 - downRes.y1) * 0.5);									
+					} else if(downRes.side == "2") {
+						drawlinesx = downRes.x1 + ((downRes.x2 - downRes.x1) * 0.5); // Initiate start parameters for line drawing bottom side
+						drawlinesy = downRes.y2;
+					} else if(downRes.side == "3") {
+						drawlinesx = downRes.x2; // Initiate start parameters for line drawing left side
+						drawlinesy = downRes.y1 + ((downRes.y2 - downRes.y1) * 0.5);									
+					} else if(downRes.side == "4") {
+						drawlinesx = downRes.x1 + ((downRes.x2 - downRes.x1) * 0.5); // Initiate start parameters for line drawing bottom side
+						drawlinesy = downRes.y1;
+					}
+					drawlinedx = drawlinesx;
+					drawlinedy = drawlinesy;	
+				}
+				if(downRes.typ == "ERRel" && downRes.code == "ContDraw" && downRes.side != "None") {						
+					var obj=Objects[downRes.objid];													
+					if(downRes.side != obj.DrawfromSide && downRes.side != obj.DrawfromSideDest) {
+						clickstate = 9; // Attribute Connection Draw
+						drawlinekind = 1; // Tell drawing engine to draw relation line symbol 
+						if(downRes.side == "1") {
+							drawlinesx = downRes.x1; // Initiate start parameters for line drawing left side
+							drawlinesy = downRes.y1 + ((downRes.y2 - downRes.y1) * 0.5);									
+						} else if(downRes.side == "2") {
+							drawlinesx = downRes.x1 + ((downRes.x2 - downRes.x1) * 0.5); // Initiate start parameters for line drawing bottom side
+							drawlinesy = downRes.y2;
+						} else if(downRes.side == "3") {
+							drawlinesx = downRes.x2; // Initiate start parameters for line drawing left side
+							drawlinesy = downRes.y1 + ((downRes.y2 - downRes.y1) * 0.5);									
+						} else if(downRes.side == "4") {
+							drawlinesx = downRes.x1 + ((downRes.x2 - downRes.x1) * 0.5); // Initiate start parameters for line drawing bottom side
+							drawlinesy = downRes.y1;
+						}
+						drawlinedx = drawlinesx;
+						drawlinedy = drawlinesy;
+					}
+				}				
+			}
+			if(clickstate > 2) {
+				var obj = Objects[downRes.objid];
+			}
+			if(clickstate == 3) { // We are in single rectangular object move 
+				obj.x1 = downRes.x1 - deltax;
+				obj.y1 = downRes.y1 - deltay;
+				obj.x2 = downRes.x2 - deltax;
+				obj.y2 = downRes.y2 - deltay;
+			} else if(clickstate == 4) { // We are in single rectangular object scale left 
+				if((obj.x2 - downRes.x1 + deltax) > 60) obj.x1 = downRes.x1 - deltax;
+			} else if(clickstate == 5) { // We are in single rectangular object scale bottom
+				if((downRes.y2 - obj.y1 - deltay) > 40) obj.y2 = downRes.y2 - deltay;
+			} else if(clickstate==6) {	// We are in single rectangular object scale right
+				if((downRes.x2 - obj.x1 - deltax) > 60) obj.x2 = downRes.x2 - deltax;
+			} else if(clickstate == 7) { // We are in single rectangular object scale top
+				if((obj.y2 - downRes.y1 + deltay) > 40) obj.y1 = downRes.y1 - deltay;
+			} else if(clickstate == 8 || clickstate == 9) { // We are in straight connective line drawing mode 
+				drawlinedx = gridx;
+				drawlinedy = gridy;
+			}
+		}
+		
+		/*
+		 *	Call-forward for mouse-over event
+		 */
+		function mouseover(x, y) {
+			// Code of touch, and if available object id and id of side of object that was touched
+			// Tolerances included as constant
+			var obj_code = "None";
+			var obj_id = "None";
+			var obj_sidentifier =" None";
+			var obj_sideperc = 0;
+			var obj_centerdist = 0;
+			var obj_type = "None";
+			var obj_x1 = 0; 
+			var obj_y1 = 0; 
+			var obj_x2 = 0; 
+			var obj_y2 = 0;
+			var Cont;
+			var found = 0;
+			var side;
+			for(j = 0; j < Identifiers.length; j++) {
+				var objid = Identifiers[j];
+				var obj = Objects[objid];				
+				var Sel = Selected[objid];
+				if(ContextObj == objid) {
+					Cont = 1;
+				} else {
+					Cont = 0;
+				}
+				// Compute coordinates including offset
+				if(obj.type == "Entity" || obj.type == "ERAttribute" || obj.type == "ERRel") {										
+					x1 = obj.x1 + offsx;
+					y1 = obj.y1 + offsy;
+					x2 = obj.x2 + offsx;
+					y2 = obj.y2 + offsy;
+					rx = (x2 - x1) * 0.5;
+					ry = (y2 - y1) * 0.5;
+				}
+				found = 0;
+				// For each kind of clickable object, check if we are inside object and if so assign variables
+				// Any general properties for all object types are set when "found" is true
+				if(obj.type == "Entity") {				
+					if(x > (x1 - sidetol) && y > (y1 - sidetol ) && x < (x2 + sidetol) && y < (y2 + sidetol)) {
+						obj_code = "NonSel";
+						if(Sel) {
+							obj_code = "Sel";
+						}
+						if(Cont) {
+							obj_code = "Cont";
+						}
+						side = computeside(x, y, x1, y1, x2, y2, sidetol);
+						obj_sidentifier = side.side;
+						obj_sideperc = side.perc;
+						obj_centerdist = side.dist;					
+						found = 1;																	
+					}
+				} else if(obj.type=="ERAttribute") {
+						if(x > (x1 - sidetol) && y > (y1 - sidetol) && x < (x2 + sidetol) && y < (y2 + sidetol)) {
+							obj_code = "NonSel";
+							if(Sel) {
+								obj_code="Sel";
+							}							
+							if(Cont) {
+								if(obj.DrawtoID == "None") {
+									obj_code = "ContDraw";											
+								} else {
+									obj_code = "Cont";
+								}
+							} 
+							side = computeside(x, y, x1, y1, x2, y2, sidetol);
+							obj_sidentifier = side.side;
+							obj_sideperc = side.perc;
+							obj_centerdist = side.dist;
+							found = 1;
+						}
+				} else if(obj.type == "ERRel") {
+					if(x > (x1 - sidetol) && y > (y1 - sidetol) && x < (x2 + sidetol) && y < (y2 + sidetol)) {
+						xk = x - x1;
+						// Colision detection against diamond
+						var inside = 0;																		
+						if(xk <= rx) {
+							if(y > (y1 + ry - xk - sidetol) && y < (y1 + ry + xk + sidetol)) {
+								inside = 1;
+							}
+						} else {
+							if(y > (y1 - rx + xk - sidetol) && y < ( y2 + rx - xk + sidetol)) {
+								inside = 1;
+							}
+						}
+						if(inside) {	
+							if((x > (x1 - sidetol)) && (x < (x1 + sidetol)) && (y > (y1 + ry - sidetol)) && (y < (y1 + ry + sidetol))) {
+								obj_sidentifier = 1;
+							}
+							if((x > (x1 + rx - sidetol)) && (x < (x1 + rx + sidetol)) && (y > (y2 - sidetol)) && (y < (y2 + sidetol))) {
+								obj_sidentifier = 2;
+							}
+							if((x > (x2 - sidetol)) && (x < (x2 + sidetol)) && (y > (y1 + ry - sidetol)) && (y < (y1 + ry + sidetol))) {
+								obj_sidentifier = 3;
+							}
+							if((x > (x1 + rx - sidetol)) && (x < (x1 + rx + sidetol)) && (y > (y1 - sidetol)) && (y < (y1 + sidetol))) {
+								obj_sidentifier = 4;
+							}
+							obj_code = "NonSel";
+							if(Sel) {
+								obj_code = "Sel";
+							}
+							if(Cont) {
+								if(obj.DrawtoID == "None"){
+									obj_code = "ContDraw";											
+								} else if(obj.DrawtoIDDest == "None") {
+									obj_code = "ContDraw";											
+								} else {
+									obj_code = "Cont";
+								}
+							} 
+							obj_sideperc = 0.5;
+							found = 1;
+						}
+					}			
+				}
+				if(found == 1) {
+					// Save coordinates at time of click									
+					obj_x1 = x1;
+					obj_y1 = y1;
+					obj_x2 = x2;
+					obj_y2 = y2;						
+					obj_id = objid;
+					obj_type = obj.type;
+					printstr=obj_id + " " + obj_sidentifier + " " + obj_sideperc;
+				}
+			}						
+			return {
+				objid:obj_id,
+				code:obj_code,
+				side:obj_sidentifier,
+				sideperc:obj_sideperc,
+				centerdist:obj_centerdist,
+				typ:obj_type,
+				x1:obj_x1,
+				y1:obj_y1,
+				x2:obj_x2,
+				y2:obj_y2
+			}
+		}
+		
+		/*
+		 *
+		 */
+		function importdata() {				
+			for(i = 0; i < 7; i++) {
+				if(i == 0) {
+					obj = jQuery.parseJSON('{"type":"ERAttribute","id":"ATT1","kind":"Multiple","name":"Addressfosoppooo","x1":220,"y1":100,"x2":300,"y2":140, "DrawtoID":"None", "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"None", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":""}');
+				}
+				if(i == 1) {
+					obj = jQuery.parseJSON('{"type":"Entity","id":"ENT2","kind":"Weak","name":"Carsmashoepppoloo","x1":100,"y1":160,"x2":220,"y2":220}');
+				}
+				if(i == 2) {
+					obj = jQuery.parseJSON('{"type":"ERAttribute","id":"ATT3","kind":"Key","name":"SSNFooomesPoo","x1":160,"y1":260,"x2":260,"y2":300, "DrawtoID":"None", "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"None", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":""}');
+				}
+				if(i == 3) {
+					obj = jQuery.parseJSON('{"type":"Entity","id":"ENT4","kind":"Strong","name":"Trailerfpdddpeoooooe","x1":320,"y1":260,"x2":420,"y2":320}');
+				}
+				if(i == 4) {
+					obj = jQuery.parseJSON('{"type":"Entity","id":"ENT5","kind":"Strong","name":"Grail","x1":120,"y1":440,"x2":220,"y2":480}');
+				}
+				if(i == 5) {
+					obj = jQuery.parseJSON('{"type":"ERRel","id":"REL6","kind":"Strong","name":"FGFool","x1":460,"y1":160,"x2":520,"y2":220, "DrawtoID":"None", "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"0", "DrawtoCard":"N", "DrawtoRole":"Fumo", "DrawtoXoffs":"20", "DrawtoYoffs":"50", "DrawtoIDDest":"None",  "DrawfromSideDest":"None","DrawtoSideDest":"None", "DrawtoPercDest":"0", "DrawtoDestCard":"N", "DrawtoDestRole":"Luma", "DrawtoDestXoffs":"0", "DrawtoDestYoffs":"-50", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":"","DrawX3":"", "DrawY3":"", "DrawX4":"","DrawY4":""}');
+				}
+				if(i == 6) {
+					obj = jQuery.parseJSON('{"type":"ERRel","id":"REL7","kind":"Weak","name":"PODrool","x1":360,"y1":360,"x2":420,"y2":420, "DrawtoID":"None",  "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"0", "DrawtoCard":"N", "DrawtoRole":"Kumo", "DrawtoXoffs":"60", "DrawtoYoffs":"70", "DrawtoIDDest":"None",  "DrawfromSideDest":"None","DrawtoSideDest":"None", "DrawtoPercDest":"0", "DrawtoDestCard":"N", "DrawtoDestRole":"Zuuma", "DrawtoDestXoffs":"40", "DrawtoDestYoffs":"50", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":"","DrawX3":"", "DrawY3":"", "DrawX4":"","DrawY4":""}');
+				}
+				objid = obj.id;
+				Objects[objid] = obj;
+				Identifiers.push(objid);
+			}
+		}
+		
+		/* 
+		 * 	prepareobj
+		 * 	Prepares all kinds of objects, with local movement-offset (scrolling offset is handled with transforms??)
+		 * 	Ofss in prepare are not finished.
+		 */
+		function prepareobj(obji) {
+			var fromobj = Objects[obji];
+			// Attributes are prepared by re-pointing the DrawX1, DrawY1, DrawX2 and DrawY2 variables and Relationships are prepared by re-pointing DrawX1-DrawX4 and DrawY1-DrawY4
+			if((fromobj.type == "ERAttribute" || fromobj.type == "ERRel") && fromobj.DrawtoID != "None") {									
+				var toid = fromobj.DrawtoID;
+				var toobj = Objects[toid];
+				var sidek;
+				if(fromobj.DrawtoIDDest != "None" && fromobj.DrawtoIDDest != undefined) {
+					var toiddest = fromobj.DrawtoIDDest;
+					var toobjdest = Objects[toiddest];						
+					sidek = makeside(fromobj.DrawfromSideDest, fromobj.x1, fromobj.y1, fromobj.x2, fromobj.y2, 0.5);
+					fromobj.DrawX3 = sidek.x;
+					fromobj.DrawY3 = sidek.y;
+					sidek = makeside(fromobj.DrawtoSideDest, toobjdest.x1, toobjdest.y1, toobjdest.x2, toobjdest.y2, fromobj.DrawtoPercDest);
+					fromobj.DrawX4 = sidek.x;
+					fromobj.DrawY4 = sidek.y;
+				}
+				//printstr=fromobj.DrawfromSide+" "+fromobj.x1+" "+fromobj.y1+" "+fromobj.x2+" "+fromobj.y2+" :: "+fromobj.DrawtoSide+" "+toobj.x1+" "+toobj.y1+" "+toobj.x2+" "+toobj.y2+" "+fromobj.DrawtoPerc;				
+				sidek = makeside(fromobj.DrawfromSide, fromobj.x1, fromobj.y1, fromobj.x2, fromobj.y2, 0.5);
+				fromobj.DrawX1 = sidek.x;
+				fromobj.DrawY1 = sidek.y;				
+				sidek = makeside(fromobj.DrawtoSide, toobj.x1, toobj.y1, toobj.x2, toobj.y2, fromobj.DrawtoPerc);
+				fromobj.DrawX2 = sidek.x; 
+				fromobj.DrawY2 = sidek.y;						
+			}
+		}
+		
+		/*
+		 * 	Drawobj
+		 * 	Draws all kinds of objects, with local movement-offset (scrolling offset is handled with transforms??)
+		 */
+		function drawobj(obji) {
+			var obj = Objects[obji];
+			var Sel = Selected[obji];
+			if(ContextObj == obji) {
+				Cont = 1;
+			} else {
+				Cont = 0;
+			}
+			context.strokeStyle = '#000';
+			context.lineWidth = 2.0;
+			// Compute coordinates including offset
+			if(obj.type == "Entity" || obj.type == "ERAttribute" || obj.type == "ERRel") {									
+				x1 = obj.x1 + offsx;
+				y1 = obj.y1 + offsy;
+				x2 = obj.x2 + offsx;
+				y2 = obj.y2 + offsy;
+				rx = (x2 - x1) * 0.5;
+				ry = (y2 - y1) * 0.5;
+			}
+			if(obj.type == "Entity") {				
+				//Draw Local Graphic
+				drawrect(x1, y1, x2, y2, "#000");
+				if(obj.kind == "Weak") {
+					drawrect(x1 + 5, y1 + 5, x2 - 5, y2 - 5, "#000");
+					cliptext(x1 + 5, y1 + 5, x2 - 5, y2 - 5, obj.name, "20px Calibri", "center", 8, 6, "#000", 1, 0);		
+
+				} else {
+					cliptext(x1, y1, x2, y2, obj.name, "20px Calibri", "center", 8, 6, "#000", 1, 0);						
+				}
+				// Draw Select Marker
+				if(Sel || Cont) {
+					fourpoints(x1, y1 + ry, x2, y1 + ry, x1 + rx, y1, x1 + rx, y2, "#5f8");								
+				}
+			} else if(obj.type == "ERAttribute") {
+				drawellipse(x1, y1, x2, y2);
+				if(obj.kind == "Key") {
+					cliptext(x1, y1, x2, y2, obj.name, "20px Calibri", "center", 8, 6, "#000", 2, 1);						
+				} else {
+					cliptext(x1, y1, x2, y2, obj.name, "20px Calibri", "center", 8, 6, "#000", 2, 0);												
+				}
+				if(obj.DrawtoID != "None") {
+					drawline(obj.DrawX1, obj.DrawY1, obj.DrawX2, obj.DrawY2, "#000", 2.0);
+				}
+				// Draw Select Marker
+				if(Cont && obj.DrawtoID == "None") {
+					fourpoints(x1, y1 + ry, x2, y1 + ry, x1 + rx, y1, x1 + rx, y2, "#fa2");
+				} else if(Sel || (Cont && obj.DrawtoID != "None")) {
+					fourpoints(x1, y1 + ry, x2, y1 + ry, x1 + rx, y1, x1 + rx, y2, "#5f8");
+				}
+			} else if(obj.type == "ERRel") {
+				if(obj.DrawtoID != "None") {
+					drawline(obj.DrawX1, obj.DrawY1, obj.DrawX2, obj.DrawY2, "#000", 2.0);
+					drawcardinality(obj.DrawX2, obj.DrawY2, obj.DrawtoSide, obj.DrawtoCard, obj.DrawtoXoffsCard, obj.DrawtoYoffsCard, "20px Calibri", 20, 1, "#0a0");
+					drawcardinality(obj.DrawX2, obj.DrawY2, obj.DrawtoSide, obj.DrawtoRole, obj.DrawtoXoffsRole, obj.DrawtoYoffsRole, "20px Calibri", 20, 2, "#0a0");
+//					function drawcardinality(x,y,side,tex,xoffs,yoffs,font,baseline,sign,color)
+//					if(i==5) obj = jQuery.parseJSON('{"type":"ERRel","id":"REL6","kind":"Strong","name":"FGFool","x1":460,"y1":160,"x2":520,"y2":220, "DrawtoID":"None", "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"0", "DrawtoCard":"N", "DrawtoRole":"Fumo", "DrawtoXoffsCard":"20", "DrawtoYoffsCard":"50","DrawtoXoffsRole":"20", "DrawtoYoffsRole":"-50", "DrawtoIDDest":"None",  "DrawfromSideDest":"None","DrawtoSideDest":"None", "DrawtoPercDest":"0", "DrawtoDestCard":"1", "DrawtoDestRole":"Luma", "DrawtoDestXoffsCard":"0", "DrawtoDestYoffsCard":"-50","DrawtoDestXoffsRole":"0", "DrawtoDestYoffsRole":"-50", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":"","DrawX3":"", "DrawY3":"", "DrawX4":"","DrawY4":""}');
+//					if(i==6) obj = jQuery.parseJSON('{"type":"ERRel","id":"REL7","kind":"Weak","name":"PODrool","x1":360,"y1":360,"x2":420,"y2":420, "DrawtoID":"None",  "DrawfromSide":"None","DrawtoSide":"None", "DrawtoPerc":"0", "DrawtoCard":"1", "DrawtoRole":"Kumo", "DrawtoXoffsCard":"60", "DrawtoYoffsCard":"70", "DrawtoXoffsCard":"80", "DrawtoYoffsCard":"-70", "DrawtoIDDest":"None",  "DrawfromSideDest":"None","DrawtoSideDest":"None", "DrawtoPercDest":"0", "DrawtoDestCard":"N", "DrawtoDestRole":"Zuuma", "DrawtoDestXoffsCard":"40", "DrawtoDestYoffsCard":"50", "DrawtoDestXoffsRole":"40", "DrawtoDestYoffsRole":"50", "DrawX1":"", "DrawY1":"", "DrawX2":"","DrawY2":"","DrawX3":"", "DrawY3":"", "DrawX4":"","DrawY4":""}');
+				}
+				if(obj.DrawtoIDDest != "None") {
+					drawline(obj.DrawX3, obj.DrawY3, obj.DrawX4, obj.DrawY4, "#000", 2.0);
+				}
+				if(obj.kind == "Weak") {
+					drawdiamond(x1 - 4, y1 - 4, x2 + 4, y2 + 4);
+					drawdiamond(x1 + 4, y1 + 4, x2 - 4, y2 - 4);
+					cliptext(x1 + 8, y1 + 8, x2 - 8, y2 - 8, obj.name, "20px Calibri", "center", 8, 6, "#000", 3, 0);												
+				} else {
+					drawdiamond(x1, y1, x2, y2, 0);
+					cliptext(x1, y1, x2, y2, obj.name, "20px Calibri", "center", 8, 6, "#000", 3, 0);												
+				}
+				// Draw Select Markers
+				if(Sel || (Cont && obj.DrawtoID != "None" && obj.DrawtoIDDest != "None")) {
+					fourpoints(x1, y1 + ry, x2, y1 + ry, x1 + rx, y1, x1 + rx, y2, "#5f8");
+				} else if(Cont) {
+					if(obj.DrawfromSide != 1 && obj.DrawfromSideDest != 1) {
+						point(x1, y1 + ry, "#fa2");
+					}
+					if(obj.DrawfromSide != 2 && obj.DrawfromSideDest != 2) {
+						point(x1 + rx, y2, "#fa2");
+					}
+					if(obj.DrawfromSide != 3 && obj.DrawfromSideDest != 3) {
+						point(x2, y1 + ry, "#fa2");
+					}
+					if(obj.DrawfromSide != 4 && obj.DrawfromSideDest != 4) {
+						point(x1 + rx, y1, "#fa2");
+					}
+				}
+			}
+		}
+		importdata();
+		
+		/*
+		 *
+		 */
+		function foo() {
+			context.clearRect(0, 0, 600, 600);
 //			overline(gridx,gridy,150,550,550,300,8.0);
-	// Draw grid lines				
-	context.strokeStyle = '#ddd';
-	context.lineWidth = 0.5;
-	context.beginPath();
-	for(i = 0; i < 600; i += 20) {
-		context.moveTo(i, 0);
-		context.lineTo(i, 600);
-		context.moveTo(0, i);
-		context.lineTo(600, i);
-	}
-	context.stroke();			
-	// Draw drawing line				
-	if(drawlinekind == 1) {
-		drawline(drawlinesx, drawlinesy, drawlinedx, drawlinedy, "#000", 1.0);
-	}
-	// Prepare model objects
-	for(i = 0; i < Identifiers.length; i++){
-		var objid = Identifiers[i];
-		prepareobj(objid);
-	}
-	// Draw model objects
-	for(i = 0; i < Identifiers.length; i++){
-		var objid = Identifiers[i];
-		drawobj(objid);
-	}								
-	// Draw Crosshair
-	context.beginPath();
-	context.strokeStyle = '#444';
-	context.lineWidth   = 1.0;
-	context.moveTo(gridx - gridsize, gridy);
-	context.lineTo(gridx + gridsize, gridy);
-	context.moveTo(gridx, gridy - gridsize);
-	context.lineTo(gridx, gridy + gridsize);
-	context.stroke();											
-	context.strokeStyle = '#ddd';
-	context.fillStyle = '#000';
-	context.font = "bold 16px Arial";
-	context.textAlign = "left";
-	context.fillText("currop: " + printstr, 20, 576);
-	setTimeout("foo();", 100);
-}
\ No newline at end of file
+			// Draw grid lines				
+			context.strokeStyle = '#ddd';
+			context.lineWidth = 0.5;
+			context.beginPath();
+			for(i = 0; i < 600; i += 20) {
+				context.moveTo(i, 0);
+				context.lineTo(i, 600);
+				context.moveTo(0, i);
+				context.lineTo(600, i);
+			}
+			context.stroke();			
+			// Draw drawing line				
+			if(drawlinekind == 1) {
+				drawline(drawlinesx, drawlinesy, drawlinedx, drawlinedy, "#000", 1.0);
+			}
+			// Prepare model objects
+			for(i = 0; i < Identifiers.length; i++){
+				var objid = Identifiers[i];
+				prepareobj(objid);
+			}
+			// Draw model objects
+			for(i = 0; i < Identifiers.length; i++){
+				var objid = Identifiers[i];
+				drawobj(objid);
+			}								
+			// Draw Crosshair
+			context.beginPath();
+			context.strokeStyle = '#444';
+			context.lineWidth   = 1.0;
+			context.moveTo(gridx - gridsize, gridy);
+			context.lineTo(gridx + gridsize, gridy);
+			context.moveTo(gridx, gridy - gridsize);
+			context.lineTo(gridx, gridy + gridsize);
+			context.stroke();											
+			context.strokeStyle = '#ddd';
+			context.fillStyle = '#000';
+			context.font = "bold 16px Arial";
+			context.textAlign = "left";
+			context.fillText("currop: " + printstr, 20, 576);
+			setTimeout("foo();", 100);
+		}
\ No newline at end of file

=== modified file 'ErModeller/canvas_ER_demo_duggajs.html'
--- ErModeller/canvas_ER_demo_duggajs.html	2013-04-05 07:45:38 +0000
+++ ErModeller/canvas_ER_demo_duggajs.html	2013-04-03 09:20:17 +0000
@@ -4,7 +4,7 @@
 	<link rel="stylesheet" type="text/css" href="canvas.css">
 	<script type="text/javascript" src="../js/jquery.js"></script>
 	<script type="text/javascript" src="canvas.js"></script>
-	<script type="text/javascript" src="../js/dugga.js"></script>
+	<script type="text/javascript" src="dugga.js"></script>
 	</head>
 	<body onload="setupcanvas();">
 		<table>

=== added file 'ErModeller/dugga.js'
--- ErModeller/dugga.js	1970-01-01 00:00:00 +0000
+++ ErModeller/dugga.js	2013-03-28 16:01:26 +0000
@@ -0,0 +1,608 @@
+/********************************************************************************
+  Mouse coordinate and canvas globals
+  Handles both Touch and Mouse/Keyboard input at the same time
+ *********************************************************************************/
+
+// Mouse coordinate globals
+var gridx, gridy;
+var clickstate = 0;
+var acanvas;
+var context;
+
+/********************************************************************************
+  Canvas Setup and Click Handling Code
+
+  Handles both Touch and Mouse/Keyboard input at the same time and executes 
+  handler callbacks.
+  Also declares canvas globals
+ *********************************************************************************/
+
+function setupcanvas() {
+	acanvas = document.getElementById('a');
+	context = acanvas.getContext("2d");		
+	setTimeout("foo();",50);
+	setupClickHandling();		
+}
+
+function setupClickHandling() {
+	// Mouse and Keyboard Events
+	acanvas.addEventListener('mousemove', ev_mousemove, false);
+	acanvas.addEventListener('mouseup', ev_mouseup, false);
+	acanvas.addEventListener('mousedown', ev_mousedown, false);
+
+	// Touch Events
+	acanvas.addEventListener('touchstart', ev_touchstart, false);
+	acanvas.addEventListener('touchend', ev_touchend, false);
+	acanvas.addEventListener('touchmove', ev_touchmove, false);		
+}						
+
+// Keyboard/Mouse Mouse Up Handler
+function ev_mouseup(ev) {
+	handler_mouseup();
+}
+
+// Keyboard/Mouse Mouse Down Handler
+function ev_mousedown(ev) {
+	handler_mousedown();		
+}
+
+// Keyboard/Mouse Mouse Move Handler
+function ev_mousemove (ev) {
+	var cx, cy = 0;
+	if (ev.layerX || ev.layerX == 0) { // Firefox
+		cx = ev.layerX - acanvas.offsetLeft;
+		cy = ev.layerY - acanvas.offsetTop;
+	} else if (ev.offsetX || ev.offsetX == 0) { // Opera
+		cx = ev.offsetX - acanvas.offsetLeft;
+		cy = ev.offsetY - acanvas.offsetTop;
+	}
+	coord = findPos(acanvas);
+	cx = cx - coord.x;
+	cy = cy - coord.y;
+	handler_mousemove(cx, cy);
+}		
+
+// Touch start event
+function ev_touchstart(event) {  
+	event.preventDefault();  
+	var numtouch = event.touches.length;  
+	targetEvent =  event.touches.item(0);
+	var cx = targetEvent.pageX;
+	var cy = targetEvent.pageY;
+	gridx = cx;
+	gridy = cy;
+	handler_mousedown();
+};  
+
+// Touch end event
+function ev_touchend(event) {  
+	event.preventDefault();  
+	var numtouch = event.touches.length;  
+	handler_mouseup();
+};
+
+// Touch move event
+function ev_touchmove(event) {  
+	event.preventDefault();  
+	var numtouch = event.touches.length;  
+	targetEvent =  event.touches.item(0);
+	var cx = targetEvent.pageX;
+	var cy = targetEvent.pageY;
+	handler_mousemove(cx, cy);				
+};
+
+// Fix scrolling on touch devices
+var ScrollFix = function(elem) {
+	// Variables to track inputs
+	var startY, startTopScroll;
+	elem = elem || document.querySelector(elem);
+
+	// If there is no element, then do nothing  
+	if(!elem) {
+		return;
+	}
+
+	// Handle the start of interactions
+	elem.addEventListener('touchstart', function(event) {
+		startY = event.touches[0].pageY;
+		startTopScroll = elem.scrollTop;
+
+		if(startTopScroll <= 0) {
+			elem.scrollTop = 1;
+		}
+
+		if(startTopScroll + elem.offsetHeight >= elem.scrollHeight) {
+			elem.scrollTop = elem.scrollHeight - elem.offsetHeight - 1;
+		}
+	}, false);
+};
+
+/********************************************************************************
+  Canvas Diagram Drawing Code
+ *********************************************************************************/
+
+// Draws a stroked rectangle of certain thicknes and color
+function drawrect(x1, y1, x2, y2, color) {
+	context.lineWidth = 1.5;
+	context.strokeStyle = color;
+	context.strokeRect(x1, y1, x2 - x1, y2 - y1);
+}
+
+// Draws a perfect round circle
+function drawcircle(radius, color) {
+	context.lineWidth = 1.5;
+	context.strokeStyle = color;
+	context.arc(0, 0, radius, 0 , 2 * Math.PI, false);
+}
+
+// Draws 90 degree arc
+function drawellipse(x1, y1, x2, y2) {
+	var rx = (x2 - x1) * 0.5;
+	var ry = (y2 - y1) * 0.5;
+	context.beginPath();					
+	context.moveTo(x1, y1 + ry);
+	context.quadraticCurveTo(x1, y1, x1 + rx, y1);
+	context.quadraticCurveTo(x2, y1, x2, y1 + ry);
+	context.quadraticCurveTo(x2, y2, x2 - rx, y2);
+	context.quadraticCurveTo(x1, y2, x1, y1 + ry);
+	context.stroke();
+}	
+
+// Draw a point		
+function point(x, y, col) {
+	context.strokeStyle = "#000";
+	context.lineWidth = 1;
+	context.fillStyle = col;
+	context.fillRect(x - 4, y - 4, 8, 8);		
+	context.strokeRect(x - 4, y - 4, 8, 8);						
+}
+
+// Draw a box around a point to indicate highlight
+function highlight(px, py) {
+	context.strokeStyle = "#aaa";
+	context.lineWidth = 1;
+	context.strokeRect(px - 8, py - 8, 16, 16);						
+}
+
+// Draw a line using current context
+function drawline(x1, y1, x2, y2, strokestyle, linewidth) {
+	context.strokeStyle = strokestyle;
+	context.lineWidth = linewidth;
+	context.beginPath();
+	context.moveTo(x1, y1);
+	context.lineTo(x2, y2);
+	context.stroke();
+}
+
+function fourpoints(x1, y1, x2, y2, x3, y3, x4, y4, col) {
+	point(x1, y1, col);
+	point(x2, y2, col);
+	point(x3, y3, col);
+	point(x4, y4, col);				
+}
+
+function drawdiamond(x1, y1, x2, y2) {
+	var rx = (x2 - x1) * 0.5;
+	var ry = (y2 - y1) * 0.5;
+	context.beginPath();					
+	context.moveTo(x1, y1 + ry);
+	context.lineTo(x1 + rx, y2);
+	context.lineTo(x2, y1 + ry);
+	context.lineTo(x1 + rx, y1);
+	context.lineTo(x1, y1 + ry);			
+	context.stroke();											
+}
+
+// Dashed Line in Segments of given size
+function dashedline(sx, sy, ex, ey, dashlen, linewidth, col) {
+	var dx = ex - sx;
+	var dy = ey - sy;
+	len = Math.sqrt((dx * dx) + (dy * dy));
+	notimes = Math.round(len / dashlen);
+	dx = dx / notimes;
+	dy = dy / notimes;
+	context.lineWidth = linewidth;
+	context.strokeStyle = col;
+	context.beginPath();
+	var xk, yk;
+	xk = sx;
+	yk = sy;
+	xh = dx / 2.0;
+	yh = dy / 2.0;
+	for(var i = 0; i < notimes; i++) {
+		context.moveTo(xk, yk);				
+		context.lineTo(xk + xh, yk + yh);
+		xk += dx;
+		yk += dy;
+	}
+	context.stroke();
+}
+
+// Arcto only works if both x1 and y2 are on circle border
+function arcto(x0, y0, x1, y1, x2, y2) {
+	var r = Math.sqrt((x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0));
+	var x = x0 - r;
+	var y = y0 - r;
+	var startAngle = (180 / Math.PI * Math.atan2(y1 - y0, x1 - x0));
+	var endAngle = (180 / Math.PI * Math.atan2(y2 - y0, x2 - x0));
+	context.arc(x0, y0, r, 0, Math.PI * 2.0, 1.0);
+}
+
+// Draws 90 degree arc
+function arcdeg(x1, y1, x2, y2, x3, y3) {
+	// First quadrant positive positive			
+	dashedline(x1, y1, x2, y2, 8, 1.0, "#999");
+	dashedline(x3, y3, x2, y2, 8, 1.0, "#999");					
+	point(x1, y1, "#ff5");
+	point(x2, y2, "#f55");
+	point(x3, y3, "#f55");
+
+	k = (y3 - y1) / (x3 - x1);					
+	yk = y1 + ((x2 - x1) * k);
+	rx = x3 - x1;
+	ry = y3 - y1;
+	point(x2, yk, "#f5f");
+
+	context.strokeStyle = '#49f';
+	context.lineWidth = 1.0;					
+	context.beginPath();					
+	context.moveTo(x1, y1);
+	for(i = 0; i < 48; i++) {
+		if(y3 >= y1) {
+			if(yk >= y2) {
+				context.lineTo(x1 + (Math.sin(((Math.PI / 96.0) * -i) + (Math.PI * 1.0)) * rx), y3 + (Math.cos(((Math.PI / 96.0) * -i) + (Math.PI * 1.0)) * ry));
+			} else {
+				context.lineTo(x3 + (Math.sin(((Math.PI / 96.0) * i) + (Math.PI * 1.5)) * rx), y1 + (Math.cos(((Math.PI / 96.0) * i) + (Math.PI * 1.5)) * ry));
+			}
+		} else {
+			if(yk <= y2) {
+				context.lineTo(x1 + (Math.sin(((Math.PI / 96.0) * -i) + (Math.PI * 1.0)) * rx), y3 + (Math.cos(((Math.PI / 96.0) * -i) + (Math.PI * 1.0)) * ry));
+			} else {
+				context.lineTo(x3 + (Math.sin(((Math.PI / 96.0) * i) + (Math.PI * 1.5)) * rx), y1 + (Math.cos(((Math.PI / 96.0) * i) + (Math.PI * 1.5)) * ry));
+			}
+		}
+	}
+	context.stroke();
+}
+
+// function that draws one part of the sun	
+function sundial(radius, angle, scale) {
+	cosv = Math.cos(angle);
+	sinv = Math.sin(angle);
+	yaddx = scale * cosv;
+	yaddy = scale * sinv;
+	xaddx = -scale * sinv;
+	xaddy = scale * cosv;
+	xk = cosv * radius;
+	yk = sinv * radius;
+
+	context.bezierCurveTo((-1.5 * xaddx) + (yaddx * 1.5) + xk, (-1.5 * xaddy) + (yaddy * 1.5) + yk, xaddx + (yaddx * 2.0) + xk, xaddy + (yaddy * 2.0) + yk, xaddx + (yaddx * 3.0) + xk, xaddy + (yaddy * 3.0) + yk);
+	context.bezierCurveTo(xaddx + yaddx + xk, xaddy + yaddy + yk, (1.5 * xaddx) + yaddx + xk, (1.5 * xaddy) + yaddy + yk, (3.0 * xaddx) + xk, (3.0 * xaddy) + yk);
+}
+
+// function that daws the sun
+function drawsun() {
+	context.fillStyle = "#fe9";
+	context.strokeStyle = "#d82";
+	context.lineWidth = 1.5;
+	context.beginPath();
+	context.moveTo(30, 0);
+	for(i = 0.0; i < 360.0; i += 22.5) {
+		angle = (i / 360.0) * 2 * Math.PI;
+		sundial(30, angle, 3);
+	}
+	context.stroke();
+	context.fill();															
+}
+
+// Draws the ball (used in various examples)
+function drawball(cx, cy, radie, innerradie, ballradie, col1, inangle, inangleadd) {
+
+	angleadd = (inangleadd / 360.0) * 2 * Math.PI;
+	context.fillStyle = col1;					
+	for(i = 0; i < 360; i += inangle) {
+		angle = (i / 360.0) * 2 * Math.PI;
+		angle2 = angle + angleadd;
+		angle3 = angle + (angleadd * 2.0);
+		angle4 = angle - angleadd;
+
+		cosv = Math.cos(angle);
+		sinv = Math.sin(angle);
+
+		cosv2 = Math.cos(angle2);
+		sinv2 = Math.sin(angle2);
+
+		cosv4 = Math.cos(angle4);
+		sinv4 = Math.sin(angle4);
+
+		context.beginPath();
+
+		context.moveTo(cx, cy);
+		context.quadraticCurveTo(cx + (cosv * innerradie), cy + (sinv * innerradie), cx + (cosv2 * radie), cy + (sinv2 * radie));							
+		context.arc(cx, cy, radie, angle2, angle, 1.0);
+		context.quadraticCurveTo(cx + (cosv4 * innerradie), cy + (sinv4 * innerradie), cx, cy);							
+		context.fill();	
+	}
+
+	context.beginPath();
+	context.arc(cx, cy, radie, 0, Math.PI * 2.0, 1.0);												
+	context.stroke();															
+}
+
+// Draws underlined/dashed underlined text clipped inside a rectangle, a quadratic curve ellipsis or a diamond
+function cliptext(x1, y1, x2, y2, tex, font, align, edgeoffs, baseline, color, clipkind, underlinekind) {
+	var rx = (x2 - x1) * 0.5;
+	var ry = (y2 - y1) * 0.5;
+	var tx = x1;    		
+
+	if(clipkind != 0) {
+		context.save();
+		context.beginPath();				
+	}
+
+	// Make Rectangle / Ellipse / Diamond Clipping Paths
+	if(clipkind == 1) {
+		context.moveTo(x1, y1);
+		context.lineTo(x1, y2);
+		context.lineTo(x2 - edgeoffs, y2);
+		context.lineTo(x2 - edgeoffs, y1);
+		context.lineTo(x1, y1);
+	} else if(clipkind == 2) {
+		context.moveTo(x1, y1 + ry);
+		context.quadraticCurveTo(x1 + edgeoffs, y1 + edgeoffs, x1 + edgeoffs + rx, y1 + edgeoffs);
+		context.quadraticCurveTo(x2 - edgeoffs, y1 + edgeoffs, x2 - edgeoffs , y1 + ry + edgeoffs);
+		context.quadraticCurveTo(x2 - edgeoffs, y2 - edgeoffs, x2 - rx - edgeoffs, y2 - edgeoffs);
+		context.quadraticCurveTo(x1 + edgeoffs, y2 - edgeoffs, x1 + edgeoffs, y1 + ry + edgeoffs);
+	} else if(clipkind == 3) {
+		context.moveTo(x1, y1 + ry);
+		context.lineTo(x1 + rx, y2);
+		context.lineTo(x2, y1 + ry);
+		context.lineTo(x1 + rx, y1);
+		context.lineTo(x1, y1 + ry);			
+	}
+
+	if(clipkind != 0) {
+		context.clip();				
+	}
+
+	context.font = font;
+	context.textAlign = "left";
+	context.fillStyle = color;
+
+	var metrics = context.measureText(tex);
+	var hwidth = metrics.width * 0.5;
+
+	// Compute left-justified centered coordinate    		
+	if((rx - hwidth - edgeoffs) < 0) {
+		tx = x1 + edgeoffs;
+	} else {
+		tx = x1 + rx - hwidth;
+	}
+
+	context.fillText(tex, tx, y2 - ry + baseline);
+
+	// Draw underlining - can handle dashed underline!
+	if(underlinekind == 1) {
+		drawline(tx, y2 - ry + baseline + 5.0, tx + (hwidth*2), y2 - ry + baseline + 5.0, "#000", 2.0);										
+	}
+
+	if(clipkind != 0) context.restore(); 
+
+}
+
+// Draws cardinality at a certain offset from a coordinate
+function drawcardinality(x, y, side, tex, xoffs, yoffs, font, baseline, sign, color)
+{
+	// Xoffs is along line
+	xoffs = 0;
+	// Yoffs is distance from line
+	yoffs = 10;
+
+	var metrics = context.measureText(tex);
+	var twidth = metrics.width;
+	var theight = 12;
+
+	point(x, y, "#f8f");
+
+	context.font = font;
+	context.textAlign = "left";
+	context.fillStyle = color;
+
+	if(side == 1 && sign == 1){
+		context.fillText(tex, x - twidth - xoffs, y - yoffs);
+		drawrect(x - twidth - xoffs, y - yoffs,x - xoffs, y - yoffs - theight);
+	}else if(side == 2 && sign == 1){
+		context.fillText(tex, x + yoffs, y + xoffs + theight);					
+		drawrect(x + yoffs, y + xoffs + theight,x + yoffs + twidth, y + xoffs);
+	}else if(side == 3 && sign == 1){
+		context.fillText(tex, x + xoffs, y - yoffs);
+	}else if(side == 4 && sign == 1){
+		context.fillText(tex, x + yoffs, y - xoffs);					
+	}else if(side == 1 && sign == 2){
+		context.fillText(tex, x - twidth - xoffs, y + theight + yoffs);					
+		drawrect(x - twidth - xoffs, y + yoffs,x - xoffs, y + theight + yoffs);
+	}else if(side == 2 && sign == 2){
+		context.fillText(tex, x - yoffs - twidth, y + xoffs + theight);					
+		drawrect(x - yoffs - twidth, y + xoffs,x - yoffs, y + xoffs + theight);
+	}else if(side == 3 && sign == 2){
+		context.fillText(tex, x + xoffs, y + theight + yoffs);
+	}else if(side == 4 && sign == 2){
+		context.fillText(tex, x - yoffs - twidth, y - xoffs);					
+	}
+}
+
+/********************************************************************************
+  Canvas and Diagram Measuring Functions
+
+  These functions allow us to measure pixels in diagram and other apps
+ *********************************************************************************/
+
+// Recursive Pos of div in document - should work in most browsers
+function findPos(obj) {
+	var curleft = curtop = 0;
+	if(obj.offsetParent) {
+		curleft = obj.offsetLeft;
+		curtop = obj.offsetTop;
+		while (obj = obj.offsetParent) {
+			curleft += obj.offsetLeft;
+			curtop += obj.offsetTop;
+		}
+	}
+	return {
+		x:curleft,
+		y:curtop
+	};
+}
+
+// Make side coordinates for drawing Model
+function makeside(side, x1, y1, x2, y2, perc) {
+	var xk = 0;
+	var yk = 0;
+
+	if(side == 1) {
+		xk = x1;
+		yk = y1  +  ((y2 - y1) * perc);
+	} else if(side == 2) {
+		xk = x1 + ((x2 - x1) * perc);
+		yk = y2;
+	} else if(side == 3){
+		xk = x2;
+		yk = y1 + ((y2 - y1) * perc);						
+	} else if(side == 4){
+		xk = x1 + ((x2 - x1) * perc)
+		yk = y1;
+	}
+
+	return {
+		x:xk, 
+		y:yk
+	};
+}		
+
+// Computes side identifier for a mouse coordinate and object coordinates
+function computeside(x, y, x1, y1, x2, y2, sidetol) {
+	var obj_sidentifier = "None";
+	var obj_sideperc = 0;
+	var obj_centerdist = 0;
+
+	// Left Side
+	if(x > x1 - sidetol && x < x1 + sidetol && y > y1 - sidetol && y < y2 + sidetol) {
+		obj_sidentifier = 1;
+		obj_sideperc = makesideperc(y, y1, y2);
+		obj_centerdist = centerdist(y, y1, y2);
+	}
+
+	// Bottom Not Including Left Side or Right Side
+	if(x > x1 + sidetol && x < x2 - sidetol && y > y2 - sidetol && y < y2 + sidetol) {
+		obj_sidentifier = 2;
+		obj_sideperc = makesideperc(x, x1, x2);
+		obj_centerdist = centerdist(x, x1, x2);
+	}
+
+	// Right Side
+	if(x > x2 - sidetol && x < x2 + sidetol && y > y1 - sidetol && y < y2 + sidetol) {
+		obj_sidentifier = 3;
+		obj_sideperc = makesideperc(y, y1, y2);
+		obj_centerdist=centerdist(y, y1, y2);
+	}
+
+	// Top Not Including Left Side or Right Side
+	if(x > x1 + sidetol && x < x2 - sidetol && y > y1 - sidetol && y < y1 + sidetol) {
+		obj_sidentifier = 4;
+		obj_sideperc = makesideperc(x, x1, x2);
+		obj_centerdist=centerdist(x, x1, x2);
+	}
+
+	return {
+		side:obj_sidentifier,
+		perc:obj_sideperc,
+		dist:obj_centerdist
+	};
+}		
+
+// Make side perc for ER model
+function makesideperc(x, x1, x2) {
+	r = x2 - x1;
+	perc = (x - x1) / r;
+
+	if(perc > 1.0) perc = 1.0;
+	if(perc < 0.0) perc = 0.0;
+
+	return perc;
+}
+
+function centerdist(x, x1, x2){
+	r = x1 + ((x2 - x1) * 0.5);
+
+	return (x - r);
+}
+
+// Euclidian distance - Yo!
+function distance(x1, y1, x2, y2) {
+	var dist = Math.sqrt(((y2 - y1) * (y2 - y1)) + ((x2 - x1) * (x2 - x1)));
+
+	return dist;
+}
+
+// Are we over a line or not.
+function overline(x, y, x1, y1, x2, y2, tolerance) {
+	var distance = 10000;
+	dx = x2 - x1;
+	dy = y2- y1;
+
+	straighttolerance = 2.0;
+
+	var box1, boy1, box2, boy2;
+
+	if(x1 > x2) {
+		box1 = x2;
+		box2 = x1;
+	} else {
+		box1 = x1;
+		box2 = x2;				
+	}
+
+	if(y1 > y2) {
+		boy1 = y2;
+		boy2 = y1;
+	} else {
+		boy1 = y1;
+		boy2 = y2;				
+	}
+
+	//drawrect(box1-tolerance,boy1-tolerance,box2+tolerance,boy2+tolerance,"#aaa");
+	if((x > (box1 - tolerance)) && (x < (box2 + tolerance)) && (y > (boy1 - tolerance)) && (y < (boy2 + tolerance))) {
+		// Straight X, Straight Y or Positive or Negative Incline
+		if(Math.abs(dx) < straighttolerance) {
+			if(y1 < y2) {
+				if(y > y1 - tolerance && y < y2 + tolerance) {
+					distance = Math.abs(x1 - x);
+				}
+			} else {
+				if(y > y2 - tolerance && y < y1 + tolerance) {
+					distance = Math.abs(x1 - x);
+				}		
+			}
+		} else if(Math.abs(dy) < straighttolerance) {
+			if(x1 < x2){
+				if(x > x1 - tolerance && x < x2 + tolerance) {
+					distance = Math.abs(y1 - y);
+				}
+			} else {
+				if(x > x2 - tolerance && x < x1 + tolerance) {
+					distance = Math.abs(y1 - y);
+				}
+			}
+		} else if(Math.abs(dx) >= Math.abs(dy)) {
+			k = dy / dx;								
+			yk = y1 + ((x - x1) * k);
+			distance = Math.abs(yk - y);
+		} else {
+			k = dx / dy;
+			xk = x1 + ((y - y1) * k);
+			distance = Math.abs(xk - x);						
+		}
+	}
+
+	return distance;
+}

=== modified file 'WebGL and Benchmarking/Benchy.php'
--- WebGL and Benchmarking/Benchy.php	2013-04-05 08:39:40 +0000
+++ WebGL and Benchmarking/Benchy.php	2013-03-28 14:57:59 +0000
@@ -103,7 +103,7 @@
 			$bversion = versi($sst, "/", 1);
 		}
 		if(strpos($sst, "Safari/")  !== false) {
-			if(strcmp($browser, "Chrome") != 0) {
+			if(strcmp($browser, "Chrome")! = 0) {
 				$browser = "Safari";
 				$bversion = versi($sst, "/", 1);
 			}

=== renamed file 'js/httpAjax.js' => 'WebGL and Benchmarking/httpAjax.js'
=== modified file 'WebGL and Benchmarking/test1shaderstartup.html'
--- WebGL and Benchmarking/test1shaderstartup.html	2013-04-09 09:21:05 +0000
+++ WebGL and Benchmarking/test1shaderstartup.html	2013-04-03 08:12:59 +0000
@@ -5,10 +5,10 @@
 	<title>Shader Startup Benchmark</title>
 	<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
 
-	<script type="text/javascript" src="../js/glMatrix-0.9.5.min.js"></script>
-	<script type="text/javascript" src="../js/webgl-utils.js"></script>
-	<script type="text/javascript" src="../js/webgl-helpers.js"></script>
-	<script type="text/javascript" src="../js/httpAjax.js"></script>
+	<script type="text/javascript" src="glMatrix-0.9.5.min.js"></script>
+	<script type="text/javascript" src="webgl-utils.js"></script>
+	<script type="text/javascript" src="webgl-helpers.js"></script>
+	<script type="text/javascript" src="httpAjax.js"></script>
 
 	<script id="shader-fs" type="x-shader/x-fragment">
 		precision mediump float;

=== renamed file 'js/webgl-helpers.js' => 'WebGL and Benchmarking/webgl-helpers.js'
=== added file 'codehighlighterimpl/DomExample1.htm'
--- codehighlighterimpl/DomExample1.htm	1970-01-01 00:00:00 +0000
+++ codehighlighterimpl/DomExample1.htm	2013-04-04 16:19:07 +0000
@@ -0,0 +1,28 @@
+<span class="description">
+<br>
+<div class="descriptionheading">Overview</div>
+This example shows how to navigate a DOM document.
+<br><br>
+<div class="descriptionheading">Initiation</div>
+The first part of the code (rows 8-10) creates the DOM document object. The DOM object has all the functionality needed to 
+load and parse a document. We use the load function (row 10) to load the data into memory. When this is done, the DOM object contains
+a reference to the data that has been loaded into memory. <a href="#" onclick="highlight(['ace_showcodephp'],'str_replace')">str_replace</a>
+<br><br>
+<div class="descriptionheading">Element Navigation</div>
+The <span class="interestingdescription">documentElement</span> (row 12) attribute of the DOMDocument object contains a reference
+to the root node of the dom document. In this case it is a person element. <a href="#" onclick="highlight(['ace_showcodephp'],'buffer')">buffer</a>
+<br><br>
+In the following row (row 12) we print the name of the element using the <span class="interestingdescription">tagName</span> attribute (for this file <a href='../XMLData/example1.xml'>example1.xml</a> the root element is a person element)  <a href="#" onclick="highlight(['ace_showcodephp','ace_indexphp'],'script');">script</a>
+<br><br>
+The foreach statement on row (13-17) iterates over the <span class="interestingdescription">childNodes</span> of the root node that was retrieved on row 12.
+The childNodes attribute returns an array of the child nodes of the node. If there are no child nodes, an empty array is returned.
+<br><br>
+The <span class="interestingdescription">nodeValue</span> attribute (row 16) of a document element gives us the text content of any elements
+below the referenced element. In this case the nodeValue for the "car" element returns  the value "Red!!" even though the contents inside the car element 
+is a color element which contains the text "Red!!".
+<br><br>
+<div class='exampleheading'>Web Page Output:<br><br>
+<img src='DomExample1.png'>
+</div>
+																	
+</span>
\ No newline at end of file

=== removed file 'codehighlighterimpl/DomExample1.php'
--- codehighlighterimpl/DomExample1.php	2013-04-05 14:57:58 +0000
+++ codehighlighterimpl/DomExample1.php	1970-01-01 00:00:00 +0000
@@ -1,30 +0,0 @@
-
-<span class="description">
-<br>
-<div class="descriptionheading">Overview</div>
-This example shows how to navigate a DOM document.
-<br><br>
-<div class="descriptionheading">Initiation</div>
-The first part of the code (rows 8-10) creates the DOM document object. The DOM object has all the functionality needed to 
-load and parse a document. We use the load function (row 10) to load the data into memory. When this is done, the DOM object contains
-a reference to the data that has been loaded into memory. <a href="#" onclick="highlight(['ace_showcodephp'],'str_replace')">str_replace</a>
-<br><br>
-<div class="descriptionheading">Element Navigation</div>
-The <span class="interestingdescription">documentElement</span> (row 12) attribute of the DOMDocument object contains a reference
-to the root node of the dom document. In this case it is a person element. <a href="#" onclick="highlight(['ace_showcodephp'],'buffer')">buffer</a>
-<br><br>
-In the following row (row 12) we print the name of the element using the <span class="interestingdescription">tagName</span> attribute (for this file <a href='../XMLData/example1.xml'>example1.xml</a> the root element is a person element)  <a href="#" onclick="highlight(['ace_showcodephp','ace_indexphp'],'script');">script</a>
-<br><br>
-<?php	showfile("js.txt", "javascript");?>
-The foreach statement on row (13-17) iterates over the <span class="interestingdescription">childNodes</span> of the root node that was retrieved on row 12.
-The childNodes attribute returns an array of the child nodes of the node. If there are no child nodes, an empty array is returned. <a href="#" onclick="highlightrows(['ace_showcodephp'],0, 5)">str_replace</a>
-<br><br>
-The <span class="interestingdescription">nodeValue</span> attribute (row 16) of a document element gives us the text content of any elements
-below the referenced element. In this case the nodeValue for the "car" element returns  the value "Red!!" even though the contents inside the car element 
-is a color element which contains the text "Red!!".
-<br><br>
-<div class='exampleheading'>Web Page Output:<br><br>
-<img src='DomExample1.png'>
-</div>
-																	
-</span>
\ No newline at end of file

=== removed directory 'codehighlighterimpl/css'
=== removed file 'codehighlighterimpl/css/codeviewer.css'
--- codehighlighterimpl/css/codeviewer.css	2013-04-05 14:57:58 +0000
+++ codehighlighterimpl/css/codeviewer.css	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-body {
-	margin:  0;
-	padding: 0;
-}
-
-#header {
-	clear:both;
-	float:left;
-	width:100%;
-	background-color:  #eee;
-}
-.colleft {
-	float:left;
-	width:100%;
-	position:relative;
-}
-.col1,
-.col2,
-.col3 {
-	float:left;
-	position:relative;
-	padding:0 0 0 0;
-	overflow:hidden;
-}
-
-/* column container */
-.colmask {
-	position:relative;	/* This fixes the IE7 overflow hidden bug */
-	clear:both;
-	float:left;
-	width:100%;			/* width of whole page */
-	overflow:hidden;		/* This chops off any overhanging divs */
-}
-
-/* 2 Column (left menu) settings */
-.leftmenu {
-	background:#fff;		/* right column background colour */
-}
-.leftmenu .colleft {
-	right:60%;			/* right column width */
-	background:#f4f4f4;	/* left column background colour */
-}
-.leftmenu .col1 {
-	width:60%;			/* right column content width */
-	left:100%;			/* 100% plus left column left padding */
-}
-.leftmenu .col2 {
-	width:35%;			/* left column content width (column width minus left and right padding) */
-	left:2%;			/* (right column left and right padding) plus (left column left padding) */
-}
-.ace { 
-	height:500px;
-	width:100%;
-}
-
-.highlighted {
-	background-color:  #ff00ff;
-	opacity: 0.2;
-	position: absolute;
-	z-index: 4;
-}
-
-.interesting {
-	background-color:  #ffff00;
-	opacity: 0.2;
-	position: absolute;
-	z-index: 4;
-}
\ No newline at end of file

=== modified file 'codehighlighterimpl/index.php'
--- codehighlighterimpl/index.php	2013-04-05 14:57:58 +0000
+++ codehighlighterimpl/index.php	2013-04-04 16:19:07 +0000
@@ -1,11 +1,74 @@
 <?php include 'showcode.php'; ?>
-<!DOCTYPE html>
 <html>
 <head>
 	<script src="../js/ace/ace.js" type="text/javascript" charset="utf-8"></script>
 	<script src="../js/jquery-1.8.0.min.js" type="text/javascript" charset="utf-8"></script>
-	<script src="js/codeviewer.js" type="text/javascript" charset="utf-8"></script>
-	<link rel="stylesheet" type="text/css" href="css/codeviewer.css">
+	<script type="text/javascript">
+	aceeditors = [];
+	</script>
+	<style type="text/css" media="screen">
+	body {
+		margin:  0;
+		padding: 0;
+	}
+
+	#header {
+		clear:both;
+		float:left;
+		width:100%;
+		background-color:  #eee;
+	}
+	.colleft {
+		float:left;
+		width:100%;
+		position:relative;
+	}
+	.col1,
+	.col2,
+	.col3 {
+		float:left;
+		position:relative;
+		padding:0 0 0 0;
+		overflow:hidden;
+	}
+
+	/* column container */
+	.colmask {
+		position:relative;	/* This fixes the IE7 overflow hidden bug */
+		clear:both;
+		float:left;
+		width:100%;			/* width of whole page */
+		overflow:hidden;		/* This chops off any overhanging divs */
+	}
+
+	/* 2 Column (left menu) settings */
+	.leftmenu {
+		background:#fff;		/* right column background colour */
+	}
+	.leftmenu .colleft {
+		right:60%;			/* right column width */
+		background:#f4f4f4;	/* left column background colour */
+	}
+	.leftmenu .col1 {
+		width:60%;			/* right column content width */
+		left:100%;			/* 100% plus left column left padding */
+	}
+	.leftmenu .col2 {
+		width:31%;			/* left column content width (column width minus left and right padding) */
+		left:4%;			/* (right column left and right padding) plus (left column left padding) */
+	}
+	.ace { 
+		height:500px;
+		width:100%;
+	}
+
+	.highlighted {
+		background-color:  #ff00ff;
+		opacity: 0.5;
+		position: absolute;
+		z-index: 4;
+	}
+	</style>
 
 </head>
 <body>
@@ -23,7 +86,7 @@
 				
 				<div id="doc">
 					<?php
-						include("DomExample1.php");
+					showdoc("DomExample1.htm");
 					?>
 				</div>
 			</div>
@@ -33,5 +96,37 @@
 
 </body>
 
-
-</html>
\ No newline at end of file
+<script type="text/javascript">
+
+function highlight(id, word){
+	clearHighlights();
+	for(var x = 0; x < id.length; x++) {
+		var Range = require("ace/range").Range;
+		var Search = require("ace/search").Search;
+
+		var editor = ace.edit(id[x]);
+
+		srch = new Search();
+		srch.set({needle:word});
+		numbers = [];
+		numbers = srch.findAll(editor.getSession());
+
+
+		for(var i = 0; i < numbers.length;i++){
+			editor.getSession().addMarker(numbers[i], "highlighted", "text",false);
+		}}
+
+	}
+
+	function clearHighlights(){
+		for(var i = 0; i < aceeditors.length; i++){
+			var editor = ace.edit(aceeditors[i]);
+			markers = editor.getSession().getMarkers(false);
+
+			$.each(markers, function(index, value){
+				editor.getSession().removeMarker(index);
+			});
+		}
+	}
+	</script>
+	</html>
\ No newline at end of file

=== removed directory 'codehighlighterimpl/js'
=== removed file 'codehighlighterimpl/js.txt'
--- codehighlighterimpl/js.txt	2013-04-05 14:57:58 +0000
+++ codehighlighterimpl/js.txt	1970-01-01 00:00:00 +0000
@@ -1,3 +0,0 @@
-function test(testParam) {
-	alert('hej');
-}
\ No newline at end of file

=== removed file 'codehighlighterimpl/js/codeviewer.js'
--- codehighlighterimpl/js/codeviewer.js	2013-04-05 14:57:58 +0000
+++ codehighlighterimpl/js/codeviewer.js	1970-01-01 00:00:00 +0000
@@ -1,45 +0,0 @@
-aceeditors = [];
-
-function highlight(id, word){
-	clearHighlights();
-	for(var x = 0; x < id.length; x++) {
-		var Search = require("ace/search").Search;
-
-		var editor = ace.edit(id[x]);
-
-		srch = new Search();
-		srch.set({needle:word});
-		numbers = [];
-		numbers = srch.findAll(editor.getSession());
-
-
-		for(var i = 0; i < numbers.length;i++){
-			editor.getSession().addMarker(numbers[i], "highlighted", "text",false);
-		}
-	}
-
-}
-
-function highlightrows(id, from, to){
-	clearHighlights();
-	for(var x = 0; x < id.length; x++) {
-		var Range = require("ace/range").Range;
-
-		var editor = ace.edit(id[x]);
-
-		editor.getSession().addMarker(new Range(from, 0, to, Number.POSITIVE_INFINITY), "highlighted", "text",false);
-	}
-}
-
-function clearHighlights(){
-	for(var i = 0; i < aceeditors.length; i++){
-		var editor = ace.edit(aceeditors[i]);
-		markers = editor.getSession().getMarkers(false);
-
-		$.each(markers, function(index, value){
-			if(value.clazz == "highlighted") {
-				editor.getSession().removeMarker(index);
-			}
-		});
-	}
-}
\ No newline at end of file

=== modified file 'codehighlighterimpl/showcode.php'
--- codehighlighterimpl/showcode.php	2013-04-05 14:57:58 +0000
+++ codehighlighterimpl/showcode.php	2013-04-04 16:19:07 +0000
@@ -1,8 +1,8 @@
 <?php
 
-function showfile($filename, $lang, $interestingrows = array()) {
+function showfile($filename, $lang) {
 	echo "<strong>".$filename."</strong>";
-	echo '<div id="ace_'.str_replace(".", "", $filename).'" class="ace">';
+	echo '<div id="ace_'.str_replace(".", "", $filename).'"" class="ace">';
 	$handle = @fopen($filename, "r");
 	if ($handle) {
 
@@ -11,6 +11,7 @@
 			$buffer = str_replace("&", "&amp;", $buffer);
 			$buffer = str_replace("<", "&lt;", $buffer);
 			$buffer = str_replace(">", "&gt;", $buffer);
+			
 
 			echo $buffer;
 		}
@@ -21,23 +22,33 @@
 	}
 	echo '</div>';
 
-	echo  '<script type="text/javascript">
-	var Range = require("ace/range").Range;
+	echo  '
+<script type="text/javascript">
 	var editor = ace.edit("ace_'.str_replace(".", "", $filename).'");
-	editor.setTheme("ace/theme/merbivore");
+	editor.setTheme("ace/theme/monokai");
 	editor.getSession().setMode("ace/mode/'.$lang.'");
 	editor.setReadOnly(true);
 	editor.setShowPrintMargin(false);
 	editor.setDisplayIndentGuides(false);
-	editor.setHighlightSelectedWord(true);
-	lines = editor.getSession().getLength();
-	$("#ace_'.str_replace(".", "", $filename).'").height(Math.min(500,lines*16));
-	aceeditors.push("ace_'.str_replace(".", "", $filename).'");';
-	for($i = 0; $i < count($interestingrows); $i++) {
-		echo 'editor.getSession().addMarker(new Range('.$interestingrows[$i][0].', 0, '
-			.$interestingrows[$i][1].', Number.POSITIVE_INFINITY), "interesting", "text",false);';
+	aceeditors.push("ace_'.str_replace(".", "", $filename).'");
+	</script>
+';
+
+}
+
+function showdoc($filename) {
+
+	$handle = @fopen($filename, "r");
+	if ($handle) {
+
+
+		while (($buffer = fgets($handle, 4096)) !== false) {
+			echo $buffer;
+		}
+		if (!feof($handle)) {
+			echo "Error: unexpected fgets() fail\n";
+		}
+		fclose($handle);
 	}
-	echo '</script>';
-
 }
 ?>
\ No newline at end of file

=== modified file 'db.sql'
--- db.sql	2013-04-09 09:09:31 +0000
+++ db.sql	2013-04-04 12:31:59 +0000
@@ -10,7 +10,7 @@
     ssn CHAR(11), /*YYMMDD-XXXX*/
     name VARCHAR(100),
     loginName VARCHAR(50) UNIQUE, /*a02leifo */
-    passw VARCHAR(32), /*MD5 hashed password*/
+    passw VARCHAR(50), /*MD5 hashed password*/
     PRIMARY KEY(ssn)    
 ) ENGINE=INNODB CHARACTER SET utf8 COLLATE utf8_swedish_ci;
 
@@ -99,7 +99,7 @@
 
 CREATE TABLE QSystemUser(
     userName     VARCHAR(16) UNIQUE NOT NULL,
-    passw        VARCHAR(32) NOT NULL,
+    passw        VARCHAR(41) NOT NULL,
     userType     VARCHAR(10) NOT NULL,
     PRIMARY KEY(userName)
 ) ENGINE=INNODB CHARACTER SET utf8 COLLATE utf8_swedish_ci;

=== modified file 'js/dugga.js'
--- js/dugga.js	2013-04-05 08:23:42 +0000
+++ js/dugga.js	2013-04-03 12:44:23 +0000
@@ -7,8 +7,9 @@
 *********************************************************************************/
 
 		// Mouse coordinate globals
-		var gridx, gridy;
-		var clickstate = 0;
+		var gridx,gridy;
+		var clickstate=0;
+
 		var acanvas;
 		var context;
 
@@ -21,101 +22,121 @@
    Also declares canvas globals
 
 *********************************************************************************/
-		function setupCanvas() {
-			acanvas = document.getElementById( 'a' );
-			context = acanvas.getContext( "2d" );
-			setTimeout( "foo();", 50 );
-			setupClickHandling();
-		}
-		
-		function setupClickHandling() {
-			// Mouse and Keyboard Events
-			acanvas.addEventListener( 'mousemove', ev_mousemove, false );
-			acanvas.addEventListener( 'mouseup', ev_mouseup, false );
-			acanvas.addEventListener( 'mousedown', ev_mousedown, false );
-			// Touch Events
-			acanvas.addEventListener( 'touchstart', ev_touchstart, false);
-			acanvas.addEventListener( 'touchend', ev_touchend, false);
-			acanvas.addEventListener( 'touchmove', ev_touchmove, false);		
-		}
-		
+ 
+		function setupcanvas()
+		{
+				acanvas=document.getElementById('a');
+				context=acanvas.getContext("2d");		
+				
+				setTimeout("foo();",50);
+				
+				setupClickHandling();		
+		}
+		
+		function setupClickHandling()
+		{
+				// Mouse and Keyboard Events
+				acanvas.addEventListener('mousemove', ev_mousemove, false);
+				acanvas.addEventListener('mouseup', ev_mouseup, false);
+				acanvas.addEventListener('mousedown', ev_mousedown, false);
+				
+				// Touch Events
+				acanvas.addEventListener('touchstart', ev_touchstart, false);
+				acanvas.addEventListener('touchend', ev_touchend, false);
+				acanvas.addEventListener('touchmove', ev_touchmove, false);		
+		}						
+				
 		// Keyboard/Mouse Mouse Up Handler
-		function evMouseup(ev) {
-			handlerMouseup();
+		function ev_mouseup(ev)
+		{
+				handler_mouseup();
 		}
 		
 		// Keyboard/Mouse Mouse Down Handler
-		function evMousedown(ev) {
-			handlerMousedown(ev);		
+		function ev_mousedown(ev)
+		{
+				handler_mousedown(ev);		
 		}
 
 		// Keyboard/Mouse Mouse Move Handler
-		function evMouseMove(ev) {
-			var cx, cy = 0;
-			// Firefox
-			if( ev.layerX || ev.layerX == 0 ) { 
-				cx = ev.layerX - acanvas.offsetLeft;
-				cy = ev.layerY - acanvas.offsetTop;
-			// Opera
-			} else if( ev.offsetX || ev.offsetX == 0 ) { 
-				cx = ev.offsetX - acanvas.offsetLeft;
-				cy = ev.offsetY - acanvas.offsetTop;
-			}
-			coord = findPos(acanvas);
-			cx = cx - coord.x;
-			cy = cy - coord.y;
-			handler_mousemove( cx, cy );
+		function ev_mousemove (ev) 
+		{
+			  var cx,cy=0;
+			  if (ev.layerX||ev.layerX==0) { // Firefox
+				    cx=ev.layerX-acanvas.offsetLeft;
+				    cy=ev.layerY-acanvas.offsetTop;
+			  } else if (ev.offsetX || ev.offsetX == 0) { // Opera
+				    cx=ev.offsetX-acanvas.offsetLeft;
+				    cy=ev.offsetY-acanvas.offsetTop;
+			  }
+
+			  coord=findPos(acanvas);
+				cx=cx-coord.x;
+				cy=cy-coord.y;
+
+				handler_mousemove(cx,cy);
 		}		
 
 		// Touch start event
-		function evTouchStart( event ) {  
+		function ev_touchstart(event){  
     		event.preventDefault();  
      		var numtouch = event.touches.length;  
-			targetEvent =  event.touches.item( 0 );
-			var cx = targetEvent.pageX;
-			var cy = targetEvent.pageY;
-			gridx = cx;
-			gridy = cy;
-			handlerMouseDown();
-		}
+
+				targetEvent =  event.touches.item(0);
+
+				var cx = targetEvent.pageX;
+				var cy = targetEvent.pageY;
+ 				
+				gridx=cx;
+				gridy=cy;
+
+ 				handler_mousedown();
+
+		};  
 
 		// Touch end event
-		function evTouchEnd( event ) {  
+		function ev_touchend(event){  
     		event.preventDefault();  
-     		var numtouch = event.touches.length;
- 			handlerMouseUp();
-		}  
+     		var numtouch = event.touches.length;  
+
+ 				handler_mouseup();
+		};  
 		
 		// Touch move event
-		function evTouchMove( event ) {
-    		event.preventDefault();
+		function ev_touchmove(event){  
+    		event.preventDefault();  
      		var numtouch = event.touches.length;  
-			targetEvent =  event.touches.item( 0 );
-			var cx = targetEvent.pageX;
-			var cy = targetEvent.pageY;
-			handlerMouseMove( cx, cy );				
-		}  
+
+				targetEvent =  event.touches.item(0);
+
+				var cx = targetEvent.pageX;
+				var cy = targetEvent.pageY;
+				
+				handler_mousemove(cx,cy);				
+		};  
 
 		// Fix scrolling on touch devices
-		var scrollFix = function(elem) {
+		var ScrollFix = function(elem) {
 		    // Variables to track inputs
 		    var startY, startTopScroll;
-		    elem = elem || document.querySelector( elem );
+		
+		    elem = elem || document.querySelector(elem);
+		
 		    // If there is no element, then do nothing  
-		    if( !elem ){
+		    if(!elem)
 		        return;
-			}
+		
 		    // Handle the start of interactions
-		    elem.addEventListener( 'touchstart', function( event ) {
-		        startY = event.touches[ 0 ].pageY;
+		    elem.addEventListener('touchstart', function(event){
+		        startY = event.touches[0].pageY;
 		        startTopScroll = elem.scrollTop;
-		        if( startTopScroll <= 0 ) {
+		
+		        if(startTopScroll <= 0)
 		            elem.scrollTop = 1;
-				}
-		        if( startTopScroll + elem.offsetHeight >= elem.scrollHeight ) {
+		
+		        if(startTopScroll + elem.offsetHeight >= elem.scrollHeight)
 		            elem.scrollTop = elem.scrollHeight - elem.offsetHeight - 1;
-				}
-		    }, false );
+		    }, false);
 		};
 
 /********************************************************************************
@@ -125,290 +146,385 @@
 *********************************************************************************/
 
 		// Draws a stroked rectangle of certain thicknes and color
-		function drawrect( x1, y1, x2, y2, color ) {
-			context.lineWidth = 1.5;
-			context.strokeStyle = color;
-			context.strokeRect( x1, y1, x2 - x1, y2 - y1 );
+
+		function drawrect(x1,y1,x2,y2,color)
+		{
+				context.lineWidth   = 1.5;
+				context.strokeStyle = color;
+				context.strokeRect(x1,y1,x2-x1,y2-y1);
 		}
+
 		
+
 		// Draws a perfect round circle
-		function drawcircle( radius, color ) {
-			context.lineWidth = 1.5;
-			context.strokeStyle = color;
-			context.arc( 0, 0, radius, 0 , 2 * Math.PI, false );
+		
+		function drawcircle(radius,color)
+		{
+				context.lineWidth   = 1.5;
+				context.strokeStyle = color;
+				context.arc(0, 0, radius, 0 , 2 * Math.PI, false);
 		}
 
 		// Draws 90 degree arc
-		function drawellipse( x1, y1, x2, y2 ) {
-			var rx = ( x2 - x1 ) * 0.5;
-			var ry = ( y2 - y1 ) * 0.5;
-			context.beginPath();					
-			context.moveTo( x1, y1 + ry );
-			context.quadraticCurveTo( x1, y1, x1 + rx, y1);
-			context.quadraticCurveTo( x2, y1, x2, y1 + ry);
-			context.quadraticCurveTo( x2, y2, x2 - rx, y2);
-			context.quadraticCurveTo( x1, y2, x1, y1 + ry);
-			context.stroke();
+		
+		function drawellipse(x1,y1,x2,y2)
+		{
+
+					var rx=(x2-x1)*0.5;
+					var ry=(y2-y1)*0.5;
+
+					context.beginPath();					
+
+					context.moveTo(x1,y1+ry);
+					context.quadraticCurveTo(x1,y1,x1+rx,y1);
+					context.quadraticCurveTo(x2,y1,x2,y1+ry);
+					context.quadraticCurveTo(x2,y2,x2-rx,y2);
+					context.quadraticCurveTo(x1,y2,x1,y1+ry);
+
+					context.stroke();
 		}	
 		
 		// Draw a point		
-		function point( x, y, col ) {
-			context.strokeStyle = "#000";
-			context.lineWidth = 1;
-			context.fillStyle = col;
-			context.fillRect( x - 4, y - 4, 8, 8 );		
-			context.strokeRect( x - 4, y - 4, 8, 8 );
+		
+		function point(x,y,col)
+		{
+				context.strokeStyle="#000";
+				context.lineWidth = 1;
+			
+				context.fillStyle=col;
+				context.fillRect(x-4,y-4,8,8);		
+				context.strokeRect(x-4,y-4,8,8);						
 		}
 		
 		// Draw a box around a point to indicate highlight
-		function highlight( px, py ) {
-			context.strokeStyle = "#aaa";
-			context.lineWidth = 1;
-			context.strokeRect( px - 8, py - 8, 16, 16 );
+		
+		function highlight(px,py)
+		{
+				context.strokeStyle="#aaa";
+				context.lineWidth = 1;
+			
+				context.strokeRect(px-8,py-8,16,16);						
+				
 		}
 		
 		// Draw a line using current context
-		function drawline( x1, y1, x2, y2, strokestyle, linewidth ) {
-			context.strokeStyle = strokestyle;
-			context.lineWidth = linewidth;
-			context.beginPath();
-			context.moveTo( x1, y1 );
-			context.lineTo( x2, y2 );
-			context.stroke();							
-		}
-		
-		function fourpoints( x1, y1, x2, y2, x3, y3, x4, y4, col ) {
-			point( x1, y1, col );
-			point( x2, y2, col );
-			point( x3, y3, col );
-			point( x4, y4, col );				
-		}
-		
-		function drawdiamond( x1, y1, x2, y2 ) {
-			var rx = ( x2 - x1 ) * 0.5;
-			var ry = ( y2 - y1 ) * 0.5;
-			context.beginPath();					
-			context.moveTo( x1, y1 + ry);
-			context.lineTo( x1 + rx, y2);
-			context.lineTo( x2, y1 + ry);
-			context.lineTo( x1 + rx, y1);
-			context.lineTo( x1, y1 + ry);
-			context.stroke();
+		
+		function drawline(x1,y1,x2,y2,strokestyle,linewidth)
+		{
+						context.strokeStyle = strokestyle;
+						context.lineWidth   = linewidth;
+						context.beginPath();
+						context.moveTo(x1,y1);
+						context.lineTo(x2,y2);
+						context.stroke();							
+		}
+		
+		function fourpoints(x1,y1,x2,y2,x3,y3,x4,y4,col)
+		{
+				point(x1,y1,col);
+				point(x2,y2,col);
+				point(x3,y3,col);
+				point(x4,y4,col);				
+		}
+		
+		function drawdiamond(x1,y1,x2,y2)
+		{
+				var rx=(x2-x1)*0.5;
+				var ry=(y2-y1)*0.5;
+
+				context.beginPath();					
+				context.moveTo(x1,y1+ry);
+				context.lineTo(x1+rx,y2);
+				context.lineTo(x2,y1+ry);
+				context.lineTo(x1+rx,y1);
+				context.lineTo(x1,y1+ry);			
+				context.stroke();											
 		}
 		
 		// Dashed Line in Segments of given size
-		function dashedline( sx, sy, ex, ey, dashlen, linewidth, col ) {
-			var dx = ex - sx;
-			var dy = ey - sy;
-			len = Math.sqrt(( dx * dx ) + ( dy * dy ));
-			notimes = Math.round( len / dashlen );
-			dx = dx / notimes;
-			dy = dy / notimes;
+		
+		function dashedline(sx,sy,ex,ey,dashlen,linewidth,col)
+		{
+						
+			var dx=ex-sx;
+			var dy=ey-sy;
+							
+			len=Math.sqrt((dx*dx)+(dy*dy));
+			notimes=Math.round(len/dashlen);
+			
+			dx=dx/notimes;
+			dy=dy/notimes;
+			
 			context.lineWidth = linewidth;
-			context.strokeStyle = col;
+			context.strokeStyle=col;
+
 			context.beginPath();
-			var xk, yk;
-			xk = sx;
-			yk = sy;
-			xh = dx / 2.0;
-			yh = dy / 2.0;
-			for( var i = 0; i < notimes; i++ ) {
-				context.moveTo( xk, yk );				
-				context.lineTo( xk + xh, yk + yh );
-				xk += dx;
-				yk += dy;
+
+			var xk,yk;
+			xk=sx;
+			yk=sy;
+			xh=dx/2.0;
+			yh=dy/2.0;
+			for(var i=0;i<notimes;i++){
+
+					context.moveTo(xk,yk);				
+					context.lineTo(xk+xh,yk+yh);
+				
+					xk+=dx;
+					yk+=dy;
 			}
-			context.stroke();	
+							
+			context.stroke();
+				
 		}
+								
+		// Arcto only works if both x1 and y2 are on circle border
 		
-		// Arcto only works if both x1 and y2 are on circle border		
-		function arcTo( x0, y0, x1, y1, x2, y2 ) {
-			var r = Math.sqrt(( x1 - x0 ) * ( x1 - x0 ) + ( y1 - y0 ) * ( y1 - y0 ));
-			var x = x0 - r;
-			var y = y0 - r;
-			var startAngle = ( 180 / Math.PI * Math.atan2( y1 - y0, x1 - x0 ));
-			var endAngle = ( 180 / Math.PI * Math.atan2( y2 - y0, x2 - x0 ));
-			context.arc( x0, y0, r, 0, Math.PI * 2.0, 1.0);
+		function arcto(x0,y0,x1,y1,x2,y2)
+		{
+
+				var r = Math.sqrt((x1-x0)*(x1-x0) + (y1-y0)*(y1-y0));
+				var x = x0-r;
+				var y = y0-r;
+				var startAngle = (180/Math.PI*Math.atan2(y1-y0, x1-x0));
+				var endAngle = (180/Math.PI*Math.atan2(y2-y0, x2-x0));
+				
+				context.arc(x0, y0, r, 0, Math.PI*2.0, 1.0);
+
 		}
 
 		// Draws 90 degree arc
-		function arcDeg( x1, y1, x2, y2, x3, y3) {
-			// First quadrant positive positive			
-			dashedline( x1, y1, x2, y2, 8, 1.0, "#999" );
-			dashedline( x3, y3, x2, y2, 8, 1.0, "#999" );					
-			point( x1, y1, "#ff5");
-			point( x2, y2, "#f55");
-			point( x3, y3, "#f55");
-			k = ( y3 - y1 ) / ( x3 - x1);
-			yk = y1 + (( x2 - x1 ) * k );
-			rx = x3 - x1;
-			ry = y3 - y1;
-			point( x2, yk, "#f5f" );
-			context.strokeStyle = '#49f';
-			context.lineWidth = 1.0;					
-			context.beginPath();					
-			context.moveTo( x1, y1 );
-			for( i = 0; i < 48; i++ ) {
-				if( y3 >= y1 ) {
-					if( yk >= y2 ) {
-						context.lineTo( x1 + ( Math.sin((( Math.PI / 96.0 ) * -i ) + ( Math.PI * 1.0 )) * rx ), y3 + ( Math.cos((( Math.PI / 96.0 ) * -i ) + ( Math.PI * 1.0 )) * ry ));
-					} else {
-						context.lineTo( x3 + ( Math.sin((( Math.PI/96.0) * i ) + ( Math.PI * 1.5 )) * rx ), y1 + ( Math.cos((( Math.PI / 96.0 ) * i ) + ( Math.PI * 1.5 )) * ry));
+		
+		function arcdeg(x1,y1,x2,y2,x3,y3)
+		{
+					
+
+					// First quadrant positive positive			
+					dashedline(x1,y1,x2,y2,8,1.0,"#999");
+					dashedline(x3,y3,x2,y2,8,1.0,"#999");					
+
+					point(x1,y1,"#ff5");
+					point(x2,y2,"#f55");
+					point(x3,y3,"#f55");
+												
+					k=(y3-y1)/(x3-x1);					
+										
+					yk=y1+((x2-x1)*k);
+					
+					rx=x3-x1;
+					ry=y3-y1;
+
+					point(x2,yk,"#f5f");
+
+					context.strokeStyle = '#49f';
+					context.lineWidth   = 1.0;					
+					context.beginPath();					
+					context.moveTo(x1,y1);
+					for(i=0;i<48;i++){
+							if(y3>=y1){
+									if(yk>=y2){
+											context.lineTo(x1+(Math.sin(((Math.PI/96.0)*-i)+(Math.PI*1.0))*rx),y3+(Math.cos(((Math.PI/96.0)*-i)+(Math.PI*1.0))*ry));
+									}else{
+											context.lineTo(x3+(Math.sin(((Math.PI/96.0)*i)+(Math.PI*1.5))*rx),y1+(Math.cos(((Math.PI/96.0)*i)+(Math.PI*1.5))*ry));
+									}
+							}else{
+									if(yk<=y2){
+											context.lineTo(x1+(Math.sin(((Math.PI/96.0)*-i)+(Math.PI*1.0))*rx),y3+(Math.cos(((Math.PI/96.0)*-i)+(Math.PI*1.0))*ry));
+									}else{
+											context.lineTo(x3+(Math.sin(((Math.PI/96.0)*i)+(Math.PI*1.5))*rx),y1+(Math.cos(((Math.PI/96.0)*i)+(Math.PI*1.5))*ry));
+									}							
+							}
 					}
-				} else {
-					if( yk <= y2 ) {
-						context.lineTo( x1 + ( Math.sin((( Math.PI / 96.0 ) * -i ) + ( Math.PI * 1.0 )) * rx ), y3 + ( Math.cos((( Math.PI / 96.0) * -i ) + ( Math.PI * 1.0)) * ry ));
-					} else {
-						context.lineTo( x3 + ( Math.sin((( Math.PI / 96.0) * i ) + ( Math.PI * 1.5 )) * rx ), y1 + ( Math.cos((( Math.PI / 96.0) * i ) + ( Math.PI * 1.5 )) * ry ));
-					}							
-				}
-			}
-			context.stroke();
-		}
-		
+					context.stroke();
+
+		}		
+	
 		// function that draws one part of the sun	
-		function sunDial( radius, angle, scale ) {
-			cosv = Math.cos(angle);
-			sinv = Math.sin(angle);
-			yaddx = scale * cosv;
-			yaddy = scale * sinv;
-			xaddx = -scale * sinv;
-			xaddy = scale * cosv;
-			xk = cosv * radius;
-			yk = sinv * radius;
-			context.bezierCurveTo(( -1.5 * xaddx ) + ( yaddx * 1.5 ) + xk, ( -1.5 * xaddy ) + ( yaddy * 1.5 ) + yk, xaddx + ( yaddx * 2.0 ) + xk, xaddy + ( yaddy * 2.0 ) + yk, xaddx + ( yaddx * 3.0 ) + xk, xaddy + ( yaddy * 3.0 ) + yk );
-			context.bezierCurveTo( xaddx + yaddx + xk, xaddy + yaddy + yk, ( 1.5 * xaddx ) + yaddx + xk, ( 1.5 * xaddy ) + yaddy + yk, ( 3.0 * xaddx ) + xk, ( 3.0 * xaddy ) + yk );
-		}
-
-		// function that draws the sun
-		function drawSun() {
-			context.fillStyle = "#fe9";
-			context.strokeStyle = "#d82";
-			context.lineWidth = 1.5;
-			context.beginPath();
-			context.moveTo( 30, 0 );
-			for( i = 0.0; i < 360.0; i += 22.5 ) {
-				angle = ( i / 360.0 ) * 2 * Math.PI;
-				sundial( 30, angle, 3 );
-			}
-			context.stroke();
-			context.fill();															
-		}
-
+		
+		function sundial(radius,angle,scale)
+		{
+				
+					cosv=Math.cos(angle);
+					sinv=Math.sin(angle);
+										
+					yaddx=scale*cosv;
+					yaddy=scale*sinv;
+					
+					xaddx=-scale*sinv;
+					xaddy=scale*cosv;
+
+					xk=cosv*radius;
+					yk=sinv*radius;
+
+					context.bezierCurveTo((-1.5*xaddx)+(yaddx*1.5)+xk,(-1.5*xaddy)+(yaddy*1.5)+yk,xaddx+(yaddx*2.0)+xk,xaddy+(yaddy*2.0)+yk,xaddx+(yaddx*3.0)+xk,xaddy+(yaddy*3.0)+yk);
+					context.bezierCurveTo(xaddx+yaddx+xk,xaddy+yaddy+yk,(1.5*xaddx)+yaddx+xk,(1.5*xaddy)+yaddy+yk,(3.0*xaddx)+xk,(3.0*xaddy)+yk);
+		}
+
+		// function that daws the sun
+		
+		function drawsun()
+		{
+				context.fillStyle = "#fe9";
+				context.strokeStyle = "#d82";
+				context.lineWidth   = 1.5;
+								 
+				context.beginPath();
+				context.moveTo(30,0);
+				for(i=0.0;i<360.0;i+=22.5){
+						angle=(i/360.0)*2*Math.PI;
+						sundial(30,angle,3);
+				}
+				context.stroke();
+				context.fill();															
+		}
+		
 		// Draws the ball (used in various examples)
-		function drawball( cx, cy, radie, innerradie, ballradie, col1, inangle, inangleadd ) {
-			angleadd = ( inangleadd / 360.0 ) * 2 * Math.PI;
-			context.fillStyle = col1;
-			for( i = 0; i < 360; i += inangle ) {
-				angle = ( i / 360.0 ) * 2 * Math.PI;
-				angle2 = angle + angleadd;
-				angle3 = angle + ( angleadd * 2.0 );
-				angle4 = angle - angleadd;
-				cosv = Math.cos( angle );
-				sinv = Math.sin( angle );
-				cosv2 = Math.cos( angle2 );
-				sinv2 = Math.sin( angle2 );
-				cosv4 = Math.cos( angle4 );
-				sinv4 = Math.sin( angle4 );
-				context.beginPath();
-				context.moveTo( cx, cy );
-				context.quadraticCurveTo( cx + ( cosv * innerradie ), cy + ( sinv * innerradie ), cx + ( cosv2 * radie ), cy + ( sinv2 * radie ));
-				context.arc( cx, cy, radie, angle2, angle, 1.0 );
-				context.quadraticCurveTo( cx + ( cosv4 * innerradie ), cy + ( sinv4 * innerradie ), cx, cy );
-				context.fill();
-			}
-			context.beginPath();
-			context.arc( cx, cy, radie, 0, Math.PI * 2.0, 1.0 );
-			context.stroke();
+		
+		function drawball(cx,cy,radie,innerradie,ballradie,col1,inangle,inangleadd)
+		{
+					
+					angleadd=(inangleadd/360.0)*2*Math.PI;
+									
+					context.fillStyle = col1;					
+					
+					for(i=0;i<360;i+=inangle){
+														
+							angle=(i/360.0)*2*Math.PI;
+							angle2=angle+angleadd;
+							angle3=angle+(angleadd*2.0);
+							angle4=angle-angleadd;
+
+							cosv=Math.cos(angle);
+							sinv=Math.sin(angle);
+
+							cosv2=Math.cos(angle2);
+							sinv2=Math.sin(angle2);
+
+							cosv4=Math.cos(angle4);
+							sinv4=Math.sin(angle4);
+							
+							context.beginPath();
+
+							context.moveTo(cx,cy);
+							context.quadraticCurveTo(cx+(cosv*innerradie),cy+(sinv*innerradie),cx+(cosv2*radie),cy+(sinv2*radie));							
+							context.arc(cx,cy,radie,angle2,angle,1.0);
+							context.quadraticCurveTo(cx+(cosv4*innerradie),cy+(sinv4*innerradie),cx,cy);							
+														
+							context.fill();															
+							
+					}	
+													
+					context.beginPath();
+					context.arc(cx,cy,radie,0,Math.PI*2.0,1.0);												
+					context.stroke();															
+		
 		}
 		
 		// Draws underlined/dashed underlined text clipped inside a rectangle, a quadratic curve ellipsis or a diamond
-		function cliptext(x1,y1,x2,y2,tex,font,align,edgeoffs,baseline,color,clipkind,underlinekind) {
-			var rx = ( x2 - x1 ) * 0.5;
-			var ry = ( y2 - y1 ) * 0.5;
-			var tx = x1;
-			if( clipkind != 0 ) {
-				context.save();
-				context.beginPath();				
-			}
-			// Make Rectangle / Ellipse / Diamond Clipping Paths
-			if( clipkind == 1 ) {
-				context.moveTo( x1, y1 );
-				context.lineTo( x1, y2 );
-				context.lineTo( x2 - edgeoffs, y2 );
-				context.lineTo( x2 - edgeoffs, y1 );
-				context.lineTo( x1, y1 );
-			} else if( clipkind == 2 ) {
-				context.moveTo( x1, y1 + ry );
-				context.quadraticCurveTo( x1 + edgeoffs, y1 + edgeoffs, x1 + edgeoffs + rx, y1 + edgeoffs);
-				context.quadraticCurveTo( x2 - edgeoffs, y1 + edgeoffs, x2 - edgeoffs, y1 + ry + edgeoffs);
-				context.quadraticCurveTo( x2 - edgeoffs, y2 - edgeoffs, x2 - rx - edgeoffs, y2 - edgeoffs);
-				context.quadraticCurveTo( x1 + edgeoffs, y2 - edgeoffs, x1 + edgeoffs, y1 + ry + edgeoffs);
-			} else if( clipkind == 3 ) {
-				context.moveTo( x1, y1 + ry );
-				context.lineTo( x1 + rx, y2 );
-				context.lineTo( x2, y1 + ry );
-				context.lineTo( x1 + rx, y1 );
-				context.lineTo( x1, y1 + ry );			
-			}
-			if( clipkind != 0 ) {
-				context.clip();				
-			}
-			context.font = font;
-			context.textAlign = "left";
-			context.fillStyle = color;
-			var metrics = context.measureText( tex );
-			var hwidth = metrics.width * 0.5;
-			// Compute left-justified centered coordinate    		
-			if(( rx - hwidth - edgeoffs ) < 0 ) {
-				tx = x1 + edgeoffs;
-			} else {
-				tx = x1 + rx - hwidth;
-			}
-			context.fillText( tex, tx, y2 - ry + baseline );
-			// Draw underlining - can handle dashed underline!
-			if( underlinekind == 1 ) {
-				drawline( tx, y2 - ry + baseline + 5.0, tx + ( hwidth * 2 ), y2 - ry + baseline + 5.0, "#000", 2.0 );
-			}
-			if(clipkind != 0 ) {
-				context.restore();
-			}
+		
+		function cliptext(x1,y1,x2,y2,tex,font,align,edgeoffs,baseline,color,clipkind,underlinekind)
+		{
+
+				var rx=(x2-x1)*0.5;
+				var ry=(y2-y1)*0.5;
+				    		
+    		var tx=x1;    		
+
+				if(clipkind!=0){
+		      	context.save();
+		        context.beginPath();				
+				}
+				
+				// Make Rectangle / Ellipse / Diamond Clipping Paths
+				if(clipkind==1){
+		        context.moveTo(x1,y1);
+		        context.lineTo(x1,y2);
+		        context.lineTo(x2-edgeoffs,y2);
+		        context.lineTo(x2-edgeoffs,y1);
+		        context.lineTo(x1,y1);
+				}else if(clipkind==2){
+						context.moveTo(x1,y1+ry);
+						context.quadraticCurveTo(x1+edgeoffs,y1+edgeoffs,x1+edgeoffs+rx,y1+edgeoffs);
+						context.quadraticCurveTo(x2-edgeoffs,y1+edgeoffs,x2-edgeoffs,y1+ry+edgeoffs);
+						context.quadraticCurveTo(x2-edgeoffs,y2-edgeoffs,x2-rx-edgeoffs,y2-edgeoffs);
+						context.quadraticCurveTo(x1+edgeoffs,y2-edgeoffs,x1+edgeoffs,y1+ry+edgeoffs);
+				}else if(clipkind==3){
+						context.moveTo(x1,y1+ry);
+						context.lineTo(x1+rx,y2);
+						context.lineTo(x2,y1+ry);
+						context.lineTo(x1+rx,y1);
+						context.lineTo(x1,y1+ry);			
+				}
+
+				if(clipkind!=0){
+		        context.clip();				
+				}
+
+				context.font = font;
+    		context.textAlign = "left";
+    		context.fillStyle = color;
+
+        var metrics = context.measureText(tex);
+        var hwidth = metrics.width*0.5;
+    		
+    		// Compute left-justified centered coordinate    		
+    		if((rx-hwidth-edgeoffs)<0){
+    				tx=x1+edgeoffs;
+    		}else{
+    				tx=x1+rx-hwidth;
+    		}
+    		
+    		context.fillText(tex, tx, y2-ry+baseline);
+
+				// Draw underlining - can handle dashed underline!
+				if(underlinekind==1){
+						drawline(tx,y2-ry+baseline+5.0,tx+(hwidth*2),y2-ry+baseline+5.0,"#000",2.0);										
+				}
+								
+				if(clipkind!=0) context.restore(); 
+
 		}
-
+		
 		// Draws cardinality at a certain offset from a coordinate
-		function drawcardinality( x, y, side, tex, xoffs, yoffs, font, baseline, sign, color ) {
-			// Xoffs is along line
-			xoffs = 0;
-			// Yoffs is distance from line
-			yoffs = 10;
-			var metrics = context.measureText( tex );
-			var twidth = metrics.width;
-			var theight = 12;
-			point( x, y, "#f8f" );
-			context.font = font;
-			context.textAlign = "left";
-			context.fillStyle = color;
-			if( side == 1 && sign == 1 ) {
-				context.fillText( tex, x - twidth - xoffs, y - yoffs );
-				drawrect( x - twidth - xoffs, y - yoffs, x - xoffs, y - yoffs - theight);
-			} else if( side == 2 && sign == 1 ) {
-				context.fillText( tex, x + yoffs, y + xoffs + theight );					
-				drawrect( x + yoffs, y + xoffs + theight, x + yoffs + twidth, y + xoffs);
-			} else if( side == 3 && sign == 1 ) {
-				context.fillText( tex, x + xoffs, y - yoffs );
-			} else if( side == 4 && sign == 1 ) {
-				context.fillText( tex, x + yoffs, y - xoffs );					
-			} else if( side == 1 && sign == 2 ) {
-				context.fillText( tex, x - twidth - xoffs, y + theight + yoffs );					
-				drawrect( x - twidth - xoffs, y + yoffs, x - xoffs, y + theight + yoffs);
-			} else if( side == 2 && sign == 2 ) {
-				context.fillText( tex, x - yoffs - twidth, y + xoffs + theight );					
-				drawrect( x - yoffs - twidth, y + xoffs, x - yoffs, y + xoffs + theight );
-			} else if( side == 3 && sign == 2 ) {
-				context.fillText( tex, x + xoffs, y + theight + yoffs);
-			} else if( side == 4 && sign == 2 ) {
-				context.fillText( tex, x - yoffs - twidth, y - xoffs);					
-			}
+		function drawcardinality(x,y,side,tex,xoffs,yoffs,font,baseline,sign,color)
+		{
+				// Xoffs is along line
+				xoffs=0;
+				// Yoffs is distance from line
+				yoffs=10;
+				
+        var metrics = context.measureText(tex);
+        var twidth = metrics.width;
+        var theight = 12;
+
+				point(x,y,"#f8f");
+
+				context.font = font;
+    		context.textAlign = "left";
+    		context.fillStyle = color;
+
+				if(side==1&&sign==1){
+    			context.fillText(tex, x-twidth-xoffs, y-yoffs);
+    			drawrect(x-twidth-xoffs, y-yoffs,x-xoffs, y-yoffs-theight);
+				}else if(side==2&&sign==1){
+    			context.fillText(tex, x+yoffs, y+xoffs+theight);					
+    			drawrect(x+yoffs, y+xoffs+theight,x+yoffs+twidth, y+xoffs);
+				}else if(side==3&&sign==1){
+    			context.fillText(tex, x+xoffs, y-yoffs);
+				}else if(side==4&&sign==1){
+    			context.fillText(tex, x+yoffs, y-xoffs);					
+				}else if(side==1&&sign==2){
+    			context.fillText(tex, x-twidth-xoffs, y+theight+yoffs);					
+    			drawrect(x-twidth-xoffs, y+yoffs,x-xoffs, y+theight+yoffs);
+				}else if(side==2&&sign==2){
+    			context.fillText(tex, x-yoffs-twidth, y+xoffs+theight);					
+    			drawrect(x-yoffs-twidth, y+xoffs,x-yoffs, y+xoffs+theight);
+				}else if(side==3&&sign==2){
+    			context.fillText(tex, x+xoffs, y+theight+yoffs);
+				}else if(side==4&&sign==2){
+    			context.fillText(tex, x-yoffs-twidth, y-xoffs);					
+				}
+
 		}
 
 		
@@ -422,154 +538,187 @@
 		
 		
 		// Recursive Pos of div in document - should work in most browsers
-		function findPos( obj ){
+		
+		function findPos(obj) {
 			var curleft = curtop = 0;
-			if( obj.offsetParent ) {
-				curleft = obj.offsetLeft;
-				curtop = obj.offsetTop;
-				while( obj = obj.offsetParent ) {
-					curleft += obj.offsetLeft;
-					curtop += obj.offsetTop;
-				}
-			}
-			return{
-				x:curleft, y:curtop;
-			}
+			if (obj.offsetParent) {
+				curleft = obj.offsetLeft
+				curtop = obj.offsetTop
+				while (obj = obj.offsetParent) {
+					curleft += obj.offsetLeft
+					curtop += obj.offsetTop
+				}
+			}
+			return {
+						x:curleft,
+						y:curtop
+				}
 		}
 		
 		// Make side coordinates for drawing Model
+
 		function makeside(side,x1,y1,x2,y2,perc){
-			var xk = 0;
-			var yk = 0;
-			if( side == 1 ) {
-				xk = x1;
-				yk = y1 + (( y2-y1 ) * perc );
-			}else if( side == 2 ) {
-				xk = x1 + (( x2 - x1 ) * perc );
-				yk = y2;
-			}else if( side == 3 ) {
-				xk = x2;
-				yk = y1 + (( y2 - y1 ) * perc );
-			}else if( side == 4 ) {
-				xk = x1 + (( x2 - x1 ) * perc );
-				yk = y1;
-			}
-			return{
-			x:xk, y:yk;
-			}
-		}
-
+	
+				var xk=0;
+				var yk=0;
+	
+				if(side==1){
+						xk=x1;
+						yk=y1+((y2-y1)*perc);
+				}else if(side==2){
+						xk=x1+((x2-x1)*perc);
+						yk=y2;
+				}else if(side==3){
+						xk=x2;
+						yk=y1+((y2-y1)*perc);						
+				}else if(side==4){
+						xk=x1+((x2-x1)*perc)
+						yk=y1;
+				}
+				
+				return {
+							x:xk,
+							y:yk
+					}
+		
+		}		
+		
 		// Computes side identifier for a mouse coordinate and object coordinates
-		function computeside( x, y, x1, y1, x2, y2, sidetol ) {
-			var obj_sidentifier = "None";
-			var obj_sideperc = 0;
-			var obj_centerdist = 0;
-			// Left Side
-			if( x > x1 - sidetol && x < x1 + sidetol && y > y1 - sidetol && y < y2 + sidetol ) {
-				obj_sidentifier = 1;
-				obj_sideperc = makesideperc( y, y1, y2 );
-				obj_centerdist = centerdist( y, y1, y2 );
-			}
-			// Bottom Not Including Left Side or Right Side
-			if( x > x1 + sidetol && x < x2 - sidetol && y > y2 - sidetol && y < y2 + sidetol ) {
-				obj_sidentifier = 2;
-				obj_sideperc = makesideperc( x, x1, x2 );
-				obj_centerdist = centerdist( x, x1, x2 );
-			}
-			// Right Side
-			if( x > x2 - sidetol && x < x2 + sidetol && y > y1 - sidetol && y < y2 + sidetol ) {
-				obj_sidentifier = 3;
-				obj_sideperc = makesideperc( y, y1, y2 );
-				obj_centerdist = centerdist( y, y1, y2 );
-			}
-			// Top Not Including Left Side or Right Side
-			if( x > x1 + sidetol && x < x2 - sidetol && y > y1 - sidetol && y < y1 + sidetol ) {
-				obj_sidentifier = 4;
-				obj_sideperc = makesideperc( x, x1, x2 );
-				obj_centerdist = centerdist( x, x1, x2 );
-			}
-			return {
-				side:obj_sidentifier, perc:obj_sideperc, dist:obj_centerdist;
-			}
+		
+		function computeside(x,y,x1,y1,x2,y2,sidetol){
+	
+				var obj_sidentifier="None";
+				var obj_sideperc=0;
+				var obj_centerdist=0;
+	
+				// Left Side
+				if(x>x1-sidetol&&x<x1+sidetol&&y>y1-sidetol&&y<y2+sidetol){
+						obj_sidentifier=1;
+						obj_sideperc=makesideperc(y,y1,y2);
+						obj_centerdist=centerdist(y,y1,y2);
+				}
+
+				// Bottom Not Including Left Side or Right Side
+				if(x>x1+sidetol&&x<x2-sidetol&&y>y2-sidetol&&y<y2+sidetol){
+						obj_sidentifier=2;
+						obj_sideperc=makesideperc(x,x1,x2);
+						obj_centerdist=centerdist(x,x1,x2);
+				}
+
+				// Right Side
+				if(x>x2-sidetol&&x<x2+sidetol&&y>y1-sidetol&&y<y2+sidetol){
+						obj_sidentifier=3;
+						obj_sideperc=makesideperc(y,y1,y2);
+						obj_centerdist=centerdist(y,y1,y2);
+				}
+				
+				// Top Not Including Left Side or Right Side
+				if(x>x1+sidetol&&x<x2-sidetol&&y>y1-sidetol&&y<y1+sidetol){
+						obj_sidentifier=4;
+						obj_sideperc=makesideperc(x,x1,x2);
+						obj_centerdist=centerdist(x,x1,x2);
+				}
+				
+				return {
+							side:obj_sidentifier,
+							perc:obj_sideperc,
+							dist:obj_centerdist
+					}
+		
 		}		
-
+						
 		// Make side perc for ER model
-		function makeSidePerc( x, x1, x2 ) {
-			r = x2 - x1;
-			perc = ( x - x1 ) / r;
-			if( perc > 1.0 ) {
-				perc = 1.0;
-			}
-			if( perc < 0.0 ) {
-				perc = 0.0;
-			}
-			return perc;
+		
+		function makesideperc(x,x1,x2){
+				r=x2-x1;
+				perc=(x-x1)/r;
+
+				if(perc>1.0) perc=1.0;
+				if(perc<0.0) perc=0.0;
+
+				return perc;
 		}
 		
-		function centerDist( x, x1, x2 ) {
-			r = x1 + (( x2 - x1 ) * 0.5 );	
-			return( x - r );
+		function centerdist(x,x1,x2){
+				r=x1+((x2-x1)*0.5);
+				
+				return (x-r);
 		}
 		
 		// Euclidian distance - Yo!
-		function distance( x1, y1, x2, y2 ) {
-			var dist = Math.sqrt((( y2 - y1 ) * ( y2 - y1 )) + (( x2 - x1 ) * ( x2 - x1 )));
-			return dist;
+		
+		function distance(x1,y1,x2,y2){
+				
+				var dist=Math.sqrt(((y2-y1)*(y2-y1))+((x2-x1)*(x2-x1)));
+				
+				return dist;
 		}
-		
+
 		// Are we over a line or not.
-		function overline( x, y, x1, y1, x2, y2, tolerance ) {
-			var distance = 10000;
-			dx = x2 - x1;
-			dy = y2 - y1;
-			straighttolerance = 2.0;
-			var box1, boy1, box2, boy2;
-			if( x1 > x2 ) {
-				box1 = x2;
-				box2 = x1;
-			} else {
-				box1 = x1;
-				box2 = x2;				
-			}
-			if( y1 > y2 ) {
-				boy1 = y2;
-				boy2 = y1;
-			} else {
-				boy1 = y1;
-				boy2 = y2;				
-			}
-			//drawrect(box1-tolerance,boy1-tolerance,box2+tolerance,boy2+tolerance,"#aaa");
-			if(( x > ( box1 - tolerance )) && ( x < ( box2 + tolerance )) && ( y > ( boy1 - tolerance )) && ( y < ( boy2 + tolerance ))) {
-				// Straight X, Straight Y or Positive or Negative Incline
-				if( Math.abs( dx ) < straighttolerance ) {
-					if( y1 < y2 ) {
-						if( y > y1 - tolerance && y < y2 + tolerance ) {
-							distance = Math.abs( x1 - x );
-						}
-					} else {
-						if( y > y2 - tolerance && y < y1 + tolerance ) {
-							distance = Math.abs( x1 - x );
-						}						
-					}
-				} else if( Math.abs( dy ) < straighttolerance ) {
-					if( x1 < x2 ) {
-						if( x > x1 - tolerance && x < x2 + tolerance ) {
-							distance = Math.abs( y1 - y );
-						}
-					} else {
-						if( x > x2 - tolerance && x < x1 + tolerance ) {
-							distance = Math.abs( y1 - y );
-						}
-					}
-				} else if( Math.abs( dx ) >= Math.abs( dy )) {
-					k = dy / dx;
-					yk = y1 + (( x - x1 ) * k );
-					distance = Math.abs( yk - y );
-				} else {
-					k = dx / dy;
-					xk = x1 + (( y - y1 ) * k );
-					distance = Math.abs( xk - x );
-				}
-			}
-		return distance;
-	}
\ No newline at end of file
+
+		function overline(x,y,x1,y1,x2,y2,tolerance)
+		{
+				var distance=10000;
+				
+				
+				dx=x2-x1;
+				dy=y2-y1;
+				
+				straighttolerance=2.0;
+				
+				var box1,boy1,box2,boy2;
+				
+				if(x1>x2){
+						box1=x2;
+						box2=x1;
+				}else{
+						box1=x1;
+						box2=x2;				
+				}
+
+				if(y1>y2){
+						boy1=y2;
+						boy2=y1;
+				}else{
+						boy1=y1;
+						boy2=y2;				
+				}
+				
+//				drawrect(box1-tolerance,boy1-tolerance,box2+tolerance,boy2+tolerance,"#aaa");
+								
+				if((x>(box1-tolerance))&&(x<(box2+tolerance))&&(y>(boy1-tolerance))&&(y<(boy2+tolerance))){
+						// Straight X, Straight Y or Positive or Negative Incline
+						if(Math.abs(dx)<straighttolerance){
+								if(y1<y2){
+										if(y>y1-tolerance&&y<y2+tolerance){
+												distance=Math.abs(x1-x);
+										}
+								}else{
+										if(y>y2-tolerance&&y<y1+tolerance){
+												distance=Math.abs(x1-x);
+										}						
+								}
+						}else if(Math.abs(dy)<straighttolerance){
+								if(x1<x2){
+										if(x>x1-tolerance&&x<x2+tolerance){
+												distance=Math.abs(y1-y);
+										}
+								}else{
+										if(x>x2-tolerance&&x<x1+tolerance){
+												distance=Math.abs(y1-y);
+										}
+								}
+						}else if(Math.abs(dx)>=Math.abs(dy)){
+								k=dy/dx;								
+								yk=y1+((x-x1)*k);
+								distance=Math.abs(yk-y);
+						}else{
+								k=dx/dy;
+								xk=x1+((y-y1)*k);
+								distance=Math.abs(xk-x);						
+						}
+				}
+												
+				return distance;
+						
+		}
\ No newline at end of file

=== removed file 'js/glMatrix-0.9.5.min.js'
--- js/glMatrix-0.9.5.min.js	2013-04-09 09:21:05 +0000
+++ js/glMatrix-0.9.5.min.js	1970-01-01 00:00:00 +0000
@@ -1,32 +0,0 @@
-// glMatrix v0.9.5
-glMatrixArrayType=typeof Float32Array!="undefined"?Float32Array:typeof WebGLFloatArray!="undefined"?WebGLFloatArray:Array;var vec3={};vec3.create=function(a){var b=new glMatrixArrayType(3);if(a){b[0]=a[0];b[1]=a[1];b[2]=a[2]}return b};vec3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];return b};vec3.add=function(a,b,c){if(!c||a==c){a[0]+=b[0];a[1]+=b[1];a[2]+=b[2];return a}c[0]=a[0]+b[0];c[1]=a[1]+b[1];c[2]=a[2]+b[2];return c};
-vec3.subtract=function(a,b,c){if(!c||a==c){a[0]-=b[0];a[1]-=b[1];a[2]-=b[2];return a}c[0]=a[0]-b[0];c[1]=a[1]-b[1];c[2]=a[2]-b[2];return c};vec3.negate=function(a,b){b||(b=a);b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];return b};vec3.scale=function(a,b,c){if(!c||a==c){a[0]*=b;a[1]*=b;a[2]*=b;return a}c[0]=a[0]*b;c[1]=a[1]*b;c[2]=a[2]*b;return c};
-vec3.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=Math.sqrt(c*c+d*d+e*e);if(g){if(g==1){b[0]=c;b[1]=d;b[2]=e;return b}}else{b[0]=0;b[1]=0;b[2]=0;return b}g=1/g;b[0]=c*g;b[1]=d*g;b[2]=e*g;return b};vec3.cross=function(a,b,c){c||(c=a);var d=a[0],e=a[1];a=a[2];var g=b[0],f=b[1];b=b[2];c[0]=e*b-a*f;c[1]=a*g-d*b;c[2]=d*f-e*g;return c};vec3.length=function(a){var b=a[0],c=a[1];a=a[2];return Math.sqrt(b*b+c*c+a*a)};vec3.dot=function(a,b){return a[0]*b[0]+a[1]*b[1]+a[2]*b[2]};
-vec3.direction=function(a,b,c){c||(c=a);var d=a[0]-b[0],e=a[1]-b[1];a=a[2]-b[2];b=Math.sqrt(d*d+e*e+a*a);if(!b){c[0]=0;c[1]=0;c[2]=0;return c}b=1/b;c[0]=d*b;c[1]=e*b;c[2]=a*b;return c};vec3.lerp=function(a,b,c,d){d||(d=a);d[0]=a[0]+c*(b[0]-a[0]);d[1]=a[1]+c*(b[1]-a[1]);d[2]=a[2]+c*(b[2]-a[2]);return d};vec3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+"]"};var mat3={};
-mat3.create=function(a){var b=new glMatrixArrayType(9);if(a){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9]}return b};mat3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];return b};mat3.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return a};
-mat3.transpose=function(a,b){if(!b||a==b){var c=a[1],d=a[2],e=a[5];a[1]=a[3];a[2]=a[6];a[3]=c;a[5]=a[7];a[6]=d;a[7]=e;return a}b[0]=a[0];b[1]=a[3];b[2]=a[6];b[3]=a[1];b[4]=a[4];b[5]=a[7];b[6]=a[2];b[7]=a[5];b[8]=a[8];return b};mat3.toMat4=function(a,b){b||(b=mat4.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=0;b[4]=a[3];b[5]=a[4];b[6]=a[5];b[7]=0;b[8]=a[6];b[9]=a[7];b[10]=a[8];b[11]=0;b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
-mat3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+"]"};var mat4={};mat4.create=function(a){var b=new glMatrixArrayType(16);if(a){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15]}return b};
-mat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15];return b};mat4.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=0;a[5]=1;a[6]=0;a[7]=0;a[8]=0;a[9]=0;a[10]=1;a[11]=0;a[12]=0;a[13]=0;a[14]=0;a[15]=1;return a};
-mat4.transpose=function(a,b){if(!b||a==b){var c=a[1],d=a[2],e=a[3],g=a[6],f=a[7],h=a[11];a[1]=a[4];a[2]=a[8];a[3]=a[12];a[4]=c;a[6]=a[9];a[7]=a[13];a[8]=d;a[9]=g;a[11]=a[14];a[12]=e;a[13]=f;a[14]=h;return a}b[0]=a[0];b[1]=a[4];b[2]=a[8];b[3]=a[12];b[4]=a[1];b[5]=a[5];b[6]=a[9];b[7]=a[13];b[8]=a[2];b[9]=a[6];b[10]=a[10];b[11]=a[14];b[12]=a[3];b[13]=a[7];b[14]=a[11];b[15]=a[15];return b};
-mat4.determinant=function(a){var b=a[0],c=a[1],d=a[2],e=a[3],g=a[4],f=a[5],h=a[6],i=a[7],j=a[8],k=a[9],l=a[10],o=a[11],m=a[12],n=a[13],p=a[14];a=a[15];return m*k*h*e-j*n*h*e-m*f*l*e+g*n*l*e+j*f*p*e-g*k*p*e-m*k*d*i+j*n*d*i+m*c*l*i-b*n*l*i-j*c*p*i+b*k*p*i+m*f*d*o-g*n*d*o-m*c*h*o+b*n*h*o+g*c*p*o-b*f*p*o-j*f*d*a+g*k*d*a+j*c*h*a-b*k*h*a-g*c*l*a+b*f*l*a};
-mat4.inverse=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=a[4],h=a[5],i=a[6],j=a[7],k=a[8],l=a[9],o=a[10],m=a[11],n=a[12],p=a[13],r=a[14],s=a[15],A=c*h-d*f,B=c*i-e*f,t=c*j-g*f,u=d*i-e*h,v=d*j-g*h,w=e*j-g*i,x=k*p-l*n,y=k*r-o*n,z=k*s-m*n,C=l*r-o*p,D=l*s-m*p,E=o*s-m*r,q=1/(A*E-B*D+t*C+u*z-v*y+w*x);b[0]=(h*E-i*D+j*C)*q;b[1]=(-d*E+e*D-g*C)*q;b[2]=(p*w-r*v+s*u)*q;b[3]=(-l*w+o*v-m*u)*q;b[4]=(-f*E+i*z-j*y)*q;b[5]=(c*E-e*z+g*y)*q;b[6]=(-n*w+r*t-s*B)*q;b[7]=(k*w-o*t+m*B)*q;b[8]=(f*D-h*z+j*x)*q;
-b[9]=(-c*D+d*z-g*x)*q;b[10]=(n*v-p*t+s*A)*q;b[11]=(-k*v+l*t-m*A)*q;b[12]=(-f*C+h*y-i*x)*q;b[13]=(c*C-d*y+e*x)*q;b[14]=(-n*u+p*B-r*A)*q;b[15]=(k*u-l*B+o*A)*q;return b};mat4.toRotationMat=function(a,b){b||(b=mat4.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
-mat4.toMat3=function(a,b){b||(b=mat3.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[4];b[4]=a[5];b[5]=a[6];b[6]=a[8];b[7]=a[9];b[8]=a[10];return b};mat4.toInverseMat3=function(a,b){var c=a[0],d=a[1],e=a[2],g=a[4],f=a[5],h=a[6],i=a[8],j=a[9],k=a[10],l=k*f-h*j,o=-k*g+h*i,m=j*g-f*i,n=c*l+d*o+e*m;if(!n)return null;n=1/n;b||(b=mat3.create());b[0]=l*n;b[1]=(-k*d+e*j)*n;b[2]=(h*d-e*f)*n;b[3]=o*n;b[4]=(k*c-e*i)*n;b[5]=(-h*c+e*g)*n;b[6]=m*n;b[7]=(-j*c+d*i)*n;b[8]=(f*c-d*g)*n;return b};
-mat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],f=a[3],h=a[4],i=a[5],j=a[6],k=a[7],l=a[8],o=a[9],m=a[10],n=a[11],p=a[12],r=a[13],s=a[14];a=a[15];var A=b[0],B=b[1],t=b[2],u=b[3],v=b[4],w=b[5],x=b[6],y=b[7],z=b[8],C=b[9],D=b[10],E=b[11],q=b[12],F=b[13],G=b[14];b=b[15];c[0]=A*d+B*h+t*l+u*p;c[1]=A*e+B*i+t*o+u*r;c[2]=A*g+B*j+t*m+u*s;c[3]=A*f+B*k+t*n+u*a;c[4]=v*d+w*h+x*l+y*p;c[5]=v*e+w*i+x*o+y*r;c[6]=v*g+w*j+x*m+y*s;c[7]=v*f+w*k+x*n+y*a;c[8]=z*d+C*h+D*l+E*p;c[9]=z*e+C*i+D*o+E*r;c[10]=z*
-g+C*j+D*m+E*s;c[11]=z*f+C*k+D*n+E*a;c[12]=q*d+F*h+G*l+b*p;c[13]=q*e+F*i+G*o+b*r;c[14]=q*g+F*j+G*m+b*s;c[15]=q*f+F*k+G*n+b*a;return c};mat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1];b=b[2];c[0]=a[0]*d+a[4]*e+a[8]*b+a[12];c[1]=a[1]*d+a[5]*e+a[9]*b+a[13];c[2]=a[2]*d+a[6]*e+a[10]*b+a[14];return c};
-mat4.multiplyVec4=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2];b=b[3];c[0]=a[0]*d+a[4]*e+a[8]*g+a[12]*b;c[1]=a[1]*d+a[5]*e+a[9]*g+a[13]*b;c[2]=a[2]*d+a[6]*e+a[10]*g+a[14]*b;c[3]=a[3]*d+a[7]*e+a[11]*g+a[15]*b;return c};
-mat4.translate=function(a,b,c){var d=b[0],e=b[1];b=b[2];if(!c||a==c){a[12]=a[0]*d+a[4]*e+a[8]*b+a[12];a[13]=a[1]*d+a[5]*e+a[9]*b+a[13];a[14]=a[2]*d+a[6]*e+a[10]*b+a[14];a[15]=a[3]*d+a[7]*e+a[11]*b+a[15];return a}var g=a[0],f=a[1],h=a[2],i=a[3],j=a[4],k=a[5],l=a[6],o=a[7],m=a[8],n=a[9],p=a[10],r=a[11];c[0]=g;c[1]=f;c[2]=h;c[3]=i;c[4]=j;c[5]=k;c[6]=l;c[7]=o;c[8]=m;c[9]=n;c[10]=p;c[11]=r;c[12]=g*d+j*e+m*b+a[12];c[13]=f*d+k*e+n*b+a[13];c[14]=h*d+l*e+p*b+a[14];c[15]=i*d+o*e+r*b+a[15];return c};
-mat4.scale=function(a,b,c){var d=b[0],e=b[1];b=b[2];if(!c||a==c){a[0]*=d;a[1]*=d;a[2]*=d;a[3]*=d;a[4]*=e;a[5]*=e;a[6]*=e;a[7]*=e;a[8]*=b;a[9]*=b;a[10]*=b;a[11]*=b;return a}c[0]=a[0]*d;c[1]=a[1]*d;c[2]=a[2]*d;c[3]=a[3]*d;c[4]=a[4]*e;c[5]=a[5]*e;c[6]=a[6]*e;c[7]=a[7]*e;c[8]=a[8]*b;c[9]=a[9]*b;c[10]=a[10]*b;c[11]=a[11]*b;c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15];return c};
-mat4.rotate=function(a,b,c,d){var e=c[0],g=c[1];c=c[2];var f=Math.sqrt(e*e+g*g+c*c);if(!f)return null;if(f!=1){f=1/f;e*=f;g*=f;c*=f}var h=Math.sin(b),i=Math.cos(b),j=1-i;b=a[0];f=a[1];var k=a[2],l=a[3],o=a[4],m=a[5],n=a[6],p=a[7],r=a[8],s=a[9],A=a[10],B=a[11],t=e*e*j+i,u=g*e*j+c*h,v=c*e*j-g*h,w=e*g*j-c*h,x=g*g*j+i,y=c*g*j+e*h,z=e*c*j+g*h;e=g*c*j-e*h;g=c*c*j+i;if(d){if(a!=d){d[12]=a[12];d[13]=a[13];d[14]=a[14];d[15]=a[15]}}else d=a;d[0]=b*t+o*u+r*v;d[1]=f*t+m*u+s*v;d[2]=k*t+n*u+A*v;d[3]=l*t+p*u+B*
-v;d[4]=b*w+o*x+r*y;d[5]=f*w+m*x+s*y;d[6]=k*w+n*x+A*y;d[7]=l*w+p*x+B*y;d[8]=b*z+o*e+r*g;d[9]=f*z+m*e+s*g;d[10]=k*z+n*e+A*g;d[11]=l*z+p*e+B*g;return d};mat4.rotateX=function(a,b,c){var d=Math.sin(b);b=Math.cos(b);var e=a[4],g=a[5],f=a[6],h=a[7],i=a[8],j=a[9],k=a[10],l=a[11];if(c){if(a!=c){c[0]=a[0];c[1]=a[1];c[2]=a[2];c[3]=a[3];c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15]}}else c=a;c[4]=e*b+i*d;c[5]=g*b+j*d;c[6]=f*b+k*d;c[7]=h*b+l*d;c[8]=e*-d+i*b;c[9]=g*-d+j*b;c[10]=f*-d+k*b;c[11]=h*-d+l*b;return c};
-mat4.rotateY=function(a,b,c){var d=Math.sin(b);b=Math.cos(b);var e=a[0],g=a[1],f=a[2],h=a[3],i=a[8],j=a[9],k=a[10],l=a[11];if(c){if(a!=c){c[4]=a[4];c[5]=a[5];c[6]=a[6];c[7]=a[7];c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15]}}else c=a;c[0]=e*b+i*-d;c[1]=g*b+j*-d;c[2]=f*b+k*-d;c[3]=h*b+l*-d;c[8]=e*d+i*b;c[9]=g*d+j*b;c[10]=f*d+k*b;c[11]=h*d+l*b;return c};
-mat4.rotateZ=function(a,b,c){var d=Math.sin(b);b=Math.cos(b);var e=a[0],g=a[1],f=a[2],h=a[3],i=a[4],j=a[5],k=a[6],l=a[7];if(c){if(a!=c){c[8]=a[8];c[9]=a[9];c[10]=a[10];c[11]=a[11];c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15]}}else c=a;c[0]=e*b+i*d;c[1]=g*b+j*d;c[2]=f*b+k*d;c[3]=h*b+l*d;c[4]=e*-d+i*b;c[5]=g*-d+j*b;c[6]=f*-d+k*b;c[7]=h*-d+l*b;return c};
-mat4.frustum=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=e*2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=e*2/i;f[6]=0;f[7]=0;f[8]=(b+a)/h;f[9]=(d+c)/i;f[10]=-(g+e)/j;f[11]=-1;f[12]=0;f[13]=0;f[14]=-(g*e*2)/j;f[15]=0;return f};mat4.perspective=function(a,b,c,d,e){a=c*Math.tan(a*Math.PI/360);b=a*b;return mat4.frustum(-b,b,-a,a,c,d,e)};
-mat4.ortho=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=2/i;f[6]=0;f[7]=0;f[8]=0;f[9]=0;f[10]=-2/j;f[11]=0;f[12]=-(a+b)/h;f[13]=-(d+c)/i;f[14]=-(g+e)/j;f[15]=1;return f};
-mat4.lookAt=function(a,b,c,d){d||(d=mat4.create());var e=a[0],g=a[1];a=a[2];var f=c[0],h=c[1],i=c[2];c=b[1];var j=b[2];if(e==b[0]&&g==c&&a==j)return mat4.identity(d);var k,l,o,m;c=e-b[0];j=g-b[1];b=a-b[2];m=1/Math.sqrt(c*c+j*j+b*b);c*=m;j*=m;b*=m;k=h*b-i*j;i=i*c-f*b;f=f*j-h*c;if(m=Math.sqrt(k*k+i*i+f*f)){m=1/m;k*=m;i*=m;f*=m}else f=i=k=0;h=j*f-b*i;l=b*k-c*f;o=c*i-j*k;if(m=Math.sqrt(h*h+l*l+o*o)){m=1/m;h*=m;l*=m;o*=m}else o=l=h=0;d[0]=k;d[1]=h;d[2]=c;d[3]=0;d[4]=i;d[5]=l;d[6]=j;d[7]=0;d[8]=f;d[9]=
-o;d[10]=b;d[11]=0;d[12]=-(k*e+i*g+f*a);d[13]=-(h*e+l*g+o*a);d[14]=-(c*e+j*g+b*a);d[15]=1;return d};mat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+", "+a[9]+", "+a[10]+", "+a[11]+", "+a[12]+", "+a[13]+", "+a[14]+", "+a[15]+"]"};quat4={};quat4.create=function(a){var b=new glMatrixArrayType(4);if(a){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3]}return b};quat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];return b};
-quat4.calculateW=function(a,b){var c=a[0],d=a[1],e=a[2];if(!b||a==b){a[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e));return a}b[0]=c;b[1]=d;b[2]=e;b[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e));return b};quat4.inverse=function(a,b){if(!b||a==b){a[0]*=1;a[1]*=1;a[2]*=1;return a}b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];b[3]=a[3];return b};quat4.length=function(a){var b=a[0],c=a[1],d=a[2];a=a[3];return Math.sqrt(b*b+c*c+d*d+a*a)};
-quat4.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=Math.sqrt(c*c+d*d+e*e+g*g);if(f==0){b[0]=0;b[1]=0;b[2]=0;b[3]=0;return b}f=1/f;b[0]=c*f;b[1]=d*f;b[2]=e*f;b[3]=g*f;return b};quat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2];a=a[3];var f=b[0],h=b[1],i=b[2];b=b[3];c[0]=d*b+a*f+e*i-g*h;c[1]=e*b+a*h+g*f-d*i;c[2]=g*b+a*i+d*h-e*f;c[3]=a*b-d*f-e*h-g*i;return c};
-quat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2];b=a[0];var f=a[1],h=a[2];a=a[3];var i=a*d+f*g-h*e,j=a*e+h*d-b*g,k=a*g+b*e-f*d;d=-b*d-f*e-h*g;c[0]=i*a+d*-b+j*-h-k*-f;c[1]=j*a+d*-f+k*-b-i*-h;c[2]=k*a+d*-h+i*-f-j*-b;return c};quat4.toMat3=function(a,b){b||(b=mat3.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c=c*i;var l=d*h;d=d*i;e=e*i;f=g*f;h=g*h;g=g*i;b[0]=1-(l+e);b[1]=k-g;b[2]=c+h;b[3]=k+g;b[4]=1-(j+e);b[5]=d-f;b[6]=c-h;b[7]=d+f;b[8]=1-(j+l);return b};
-quat4.toMat4=function(a,b){b||(b=mat4.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c=c*i;var l=d*h;d=d*i;e=e*i;f=g*f;h=g*h;g=g*i;b[0]=1-(l+e);b[1]=k-g;b[2]=c+h;b[3]=0;b[4]=k+g;b[5]=1-(j+e);b[6]=d-f;b[7]=0;b[8]=c-h;b[9]=d+f;b[10]=1-(j+l);b[11]=0;b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};quat4.slerp=function(a,b,c,d){d||(d=a);var e=c;if(a[0]*b[0]+a[1]*b[1]+a[2]*b[2]+a[3]*b[3]<0)e=-1*c;d[0]=1-c*a[0]+e*b[0];d[1]=1-c*a[1]+e*b[1];d[2]=1-c*a[2]+e*b[2];d[3]=1-c*a[3]+e*b[3];return d};
-quat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+"]"};

=== removed file 'js/webgl-utils.js'
--- js/webgl-utils.js	2013-04-09 09:21:05 +0000
+++ js/webgl-utils.js	1970-01-01 00:00:00 +0000
@@ -1,174 +0,0 @@
-/*
- * Copyright 2010, Google Inc.
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are
- * met:
- *
- *     * Redistributions of source code must retain the above copyright
- * notice, this list of conditions and the following disclaimer.
- *     * Redistributions in binary form must reproduce the above
- * copyright notice, this list of conditions and the following disclaimer
- * in the documentation and/or other materials provided with the
- * distribution.
- *     * Neither the name of Google Inc. nor the names of its
- * contributors may be used to endorse or promote products derived from
- * this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
- * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
- * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
- * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
- * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
- * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
- * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-
-/**
- * @fileoverview This file contains functions every webgl program will need
- * a version of one way or another.
- *
- * Instead of setting up a context manually it is recommended to
- * use. This will check for success or failure. On failure it
- * will attempt to present an approriate message to the user.
- *
- *       gl = WebGLUtils.setupWebGL(canvas);
- *
- * For animated WebGL apps use of setTimeout or setInterval are
- * discouraged. It is recommended you structure your rendering
- * loop like this.
- *
- *       function render() {
- *         window.requestAnimFrame(render, canvas);
- *
- *         // do rendering
- *         ...
- *       }
- *       render();
- *
- * This will call your rendering function up to the refresh rate
- * of your display but will stop rendering if your app is not
- * visible.
- */
-
-WebGLUtils = function() {
-
-/**
- * Creates the HTLM for a failure message
- * @param {string} canvasContainerId id of container of th
- *        canvas.
- * @return {string} The html.
- */
-var makeFailHTML = function(msg) {
-  return '' +
-    '<table style="background-color: #8CE; width: 100%; height: 100%;"><tr>' +
-    '<td align="center">' +
-    '<div style="display: table-cell; vertical-align: middle;">' +
-    '<div style="">' + msg + '</div>' +
-    '</div>' +
-    '</td></tr></table>';
-};
-
-/**
- * Mesasge for getting a webgl browser
- * @type {string}
- */
-var GET_A_WEBGL_BROWSER = '' +
-  'This page requires a browser that supports WebGL.<br/>' +
-  '<a href="http://get.webgl.org">Click here to upgrade your browser.</a>';
-
-/**
- * Mesasge for need better hardware
- * @type {string}
- */
-var OTHER_PROBLEM = '' +
-  "It doesn't appear your computer can support WebGL.<br/>" +
-  '<a href="http://get.webgl.org/troubleshooting/">Click here for more information.</a>';
-
-/**
- * Creates a webgl context. If creation fails it will
- * change the contents of the container of the <canvas>
- * tag to an error message with the correct links for WebGL.
- * @param {Element} canvas. The canvas element to create a
- *     context from.
- * @param {WebGLContextCreationAttirbutes} opt_attribs Any
- *     creation attributes you want to pass in.
- * @param {function:(msg)} opt_onError An function to call
- *     if there is an error during creation.
- * @return {WebGLRenderingContext} The created context.
- */
-var setupWebGL = function(canvas, opt_attribs, opt_onError) {
-  function handleCreationError(msg) {
-    var container = canvas.parentNode;
-    if (container) {
-      var str = window.WebGLRenderingContext ?
-           OTHER_PROBLEM :
-           GET_A_WEBGL_BROWSER;
-      if (msg) {
-        str += "<br/><br/>Status: " + msg;
-      }
-      container.innerHTML = makeFailHTML(str);
-    }
-  };
-
-  opt_onError = opt_onError || handleCreationError;
-
-  if (canvas.addEventListener) {
-    canvas.addEventListener("webglcontextcreationerror", function(event) {
-          opt_onError(event.statusMessage);
-        }, false);
-  }
-  var context = create3DContext(canvas, opt_attribs);
-  if (!context) {
-    if (!window.WebGLRenderingContext) {
-      opt_onError("");
-    }
-  }
-  return context;
-};
-
-/**
- * Creates a webgl context.
- * @param {!Canvas} canvas The canvas tag to get context
- *     from. If one is not passed in one will be created.
- * @return {!WebGLContext} The created context.
- */
-var create3DContext = function(canvas, opt_attribs) {
-  var names = ["webgl", "experimental-webgl", "webkit-3d", "moz-webgl"];
-  var context = null;
-  for (var ii = 0; ii < names.length; ++ii) {
-    try {
-      context = canvas.getContext(names[ii], opt_attribs);
-    } catch(e) {}
-    if (context) {
-      break;
-    }
-  }
-  return context;
-}
-
-return {
-  create3DContext: create3DContext,
-  setupWebGL: setupWebGL
-};
-}();
-
-/**
- * Provides requestAnimationFrame in a cross browser way.
- */
-window.requestAnimFrame = (function() {
-  return window.requestAnimationFrame ||
-         window.webkitRequestAnimationFrame ||
-         window.mozRequestAnimationFrame ||
-         window.oRequestAnimationFrame ||
-         window.msRequestAnimationFrame ||
-         function(/* function FrameRequestCallback */ callback, /* DOMElement Element */ element) {
-           window.setTimeout(callback, 1000/60);
-         };
-})();
\ No newline at end of file

